<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * Handles the output of the text editor used on many sections
 * of the site. This allows the easy integration of other text
 * editors with WYSIWYG features.
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author			Raymond Benc
 * @package 		Phpfox
 * @version 		$Id: editor.class.php 2456 2011-03-28 14:33:53Z Miguel_Espinoza $
 */
final class Phpfox_Editor
{
	/**
	 * Class constructor
	 *
	 */
	public function __construct()
	{		
	}
	
	/**
	 * Gets the HTML output of the current textarea editor.
	 *
	 * @param string $iId ID of the textarea name, which also creates a unique ID for the HTML <textarea>
	 * @param array $aParams Any special params that the specific form behaves different from other forms can be passed here.
	 * @return string Returns the HTML output of the <textarea>
	 */
	public function get($iId, $aParams = array())
	{		
		$sStr = '';

		if (isset($aParams['user_group_setting']) && Phpfox::getUserParam($aParams['user_group_setting']) == false)
		{
			$sStr .= '<div id="layer_' . $iId . '"><textarea name="val[' . $iId . ']" rows="' . (isset($aParams['rows']) ? $aParams['rows'] : '12') . '" cols="' . (isset($aParams['cols']) ? $aParams['cols'] : '50') . '" style="width:98%;">' . $this->getValue($iId) . '</textarea></div>';
			return $sStr;
		}

		if (Phpfox::getParam('core.wysiwyg') == 'default')
		{
			$sStr .= '<div class="edit_menu_container w_95">' . "\n";
			$sStr .= '<div id="js_editor_menu_' . $iId . '" class="editor_menu"></div>' . "\n";
			$sStr .= '<script type="text/javascript">Editor.setId(\'' . $iId . '\');</script>' . "\n";
			$sStr .= '<div id="layer_' . $iId . '"><textarea name="val[' . $iId . ']" rows="' . (isset($aParams['rows']) ? $aParams['rows'] : '12') . '" cols="' . (isset($aParams['cols']) ? $aParams['cols'] : '50') . '" style="width:98%;" id="' . $iId . '">' . $this->getValue($iId) . '</textarea></div>';
			$sStr .= "\n" . '</div>';			
		}
		else 
		{
			(($sPlugin = Phpfox_Plugin::get('editor_get')) ? eval($sPlugin) : null);	
		}		
		
		return $sStr;
	}
	
	/**
	 * Gets the $_POST form value based on the ID passed.
	 *
	 * @param string $iId ID of the <textarea> form
	 * @return string Returns the value if we can find it, if not the value is blank.
	 */
	public function getValue($iId)
	{
		if (!($aParams = Phpfox::getLib('request')->getArray('val')))
		{
			$aParams = Phpfox::getLib('template')->getVar('aForms');
		}
		return (isset($aParams[$iId]) ? Phpfox::getLib('parse.output')->clean($aParams[$iId]) : '');
	}
}

?>