<?php

/**
 * [PHPFOX_HEADER]
 */
defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Attachment
 * @version 		$Id: upload.class.php 2285 2011-02-01 15:59:25Z Miguel_Espinoza $
 */
class Attachment_Component_Block_Upload extends Phpfox_Component
{

	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		$aExt = Phpfox::getService('attachment.type')->getTypes();
		//Phpfox::getUserParam('attachment.attachment_limit', true);

		$this->template()->assign(array(
			'bIsAllowed' => Phpfox::getService('attachment')->isAllowed(),
			'iTotal' => Phpfox::getParam('attachment.attachment_upload_bars'),
			'sCategoryId' => $this->getParam('sCategoryId'),
			'aValidExtensions' => Phpfox::getService('attachment.type')->getTypes(),
			'iMaxFileSize' => (Phpfox::getUserParam('attachment.item_max_upload_size') === 0 ? 'null' : ((Phpfox::getUserParam('attachment.item_max_upload_size') / 1024) * 1048576)),
			'sAttachmentInput' => $this->request()->get('input'),
			'iMaxQueue' => Phpfox::getUserParam('attachment.attachment_limit') === null ? 0 : Phpfox::getUserParam('attachment.attachment_limit')
		));

		if (Phpfox::getParam('attachment.attachment_enable_mass_uploader'))
		{
			$sExt = '';
			foreach ($aExt as $sExtension)
			{
				$sExt .= '*.' . $sExtension . ';';
			}
			$sExt = rtrim($sExt, ';');

			$sBgImageUrl = $this->url()->getDomain() . 'static/jscript/massuploader/buttonBackground.php?f=attachment';
			$this->template()->assign(array(
				'sHash' => Phpfox::getService('core')->getHashForUpload(),
				'sButtonText' => Phpfox::getPhrase('attachment.select_attachment_s_to_upload'),
				'sUploadUrl' => $this->url()->makeUrl('attachment.frame'),
				'iBtnWidth' => (strlen(Phpfox::getPhrase('attachment.select_attachment_s_to_upload')) * 5),
				'sValidExtensions' => $sExt,
				'iUserId' => Phpfox::getUserId(),
				'sBgImageURL' => $sBgImageUrl,
				'iImgWidth' =>  (strlen(Phpfox::getPhrase('attachment.select_attachment_s_to_upload')) + 5) * 8, // same formula as in buttonBackground.php
				'iImgHeight' => 25,
				'iMaxFileSize' => (Phpfox::getUserParam('attachment.item_max_upload_size') === 0 ? 'null' : (Phpfox::getUserParam('attachment.item_max_upload_size') . ' KB')),
				'sErrorFileIsLarger' => Phpfox::getPhrase('core.upload_failed_your_file_size_is_larger_then_our_limit_file_size')
					)
			);
		}
	}

	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('attachment.component_block_upload_clean')) ? eval($sPlugin) : false);
	}

}

?>