<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Attachment
 * @version 		$Id: frame.class.php 2282 2011-01-28 15:54:30Z Miguel_Espinoza $
 */
class Attachment_Component_Controller_Frame extends Phpfox_Component 
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		if (!isset($_FILES['file']) && isset($_FILES['Filedata']))
		{
			$_FILES['file'] = array();
			$_FILES['file']['error']['file'] = UPLOAD_ERR_OK;
			$_FILES['file']['name']['file'] = $_FILES['Filedata']['name'];
			$_FILES['file']['type']['file'] = $_FILES['Filedata']['type'];
			$_FILES['file']['tmp_name']['file'] = $_FILES['Filedata']['tmp_name'];
			$_FILES['file']['size']['file'] = $_FILES['Filedata']['size'];
		}
		else if (!isset($_FILES['file']))
		{
			exit;
		}

		$oFile = Phpfox::getLib('file');
		$oImage = Phpfox::getLib('image');
		
		$oAttachment = Phpfox::getService('attachment.process');		
		
		$sIds = '';		
		$sStr = '';
		$iUploaded = 0;
		$iFileSizes = 0;
		foreach ($_FILES['file']['error'] as $iKey => $sError)
		{
			if ($sError == UPLOAD_ERR_OK) 
			{
				$aImage = $oFile->load((isset($_FILES['Filedata']) ? 'Filedata' : 'file[' . $iKey . ']'), ($this->request()->get('input') == '' ? Phpfox::getService('attachment.type')->getTypes() : array('gif', 'png', 'jpg')), (Phpfox::getUserParam('attachment.item_max_upload_size') === 0 ? null : (Phpfox::getUserParam('attachment.item_max_upload_size') / 1024)));
				if ($aImage !== false)
				{
					if (!Phpfox::getService('attachment')->isAllowed())
					{
						if (isset($_FILES['Filedata']))
						{
							$this->call('alert("'.Phpfox::getPhrase('attachment.failed_limit_reached').'");');
						}
						else
						{
							$this->_echo('window.parent.document.getElementById(\'js_attachment_input\').style.display = \'block\'; window.parent.document.getElementById(\'js_upload_bar\').style.display = \'none\'; window.parent.document.getElementById("js_attachment_info_' . $iKey . '").innerHTML = "<span style=\"margin-left:4px;\">' . Phpfox::getPhrase('attachment.failed_limit_reached') . '</span>";');
						}
						
						continue;
					}
					
					$iUploaded++;
					$bIsImage = in_array($aImage['ext'], Phpfox::getParam('attachment.attachment_valid_images'));
					
					$iId = $oAttachment->add(array(
							'category' => $this->request()->get('category_name'),
							'file_name' => $_FILES['file']['name'][$iKey],						
							'extension' => $aImage['ext'],
							'is_image' => $bIsImage
						)
					);
					
					$sIds .= $iId . ',';
					
					$sFileName = $oFile->upload('file[' . $iKey . ']', Phpfox::getParam('core.dir_attachment'), $iId);

					$sFileSize = filesize(Phpfox::getParam('core.dir_attachment') . sprintf($sFileName, ''));
					$iFileSizes += $sFileSize;				
					
					$oAttachment->update(array(
						'file_size' => $sFileSize,
						'destination' => $sFileName,
						'server_id' => Phpfox::getLib('request')->getServer('PHPFOX_SERVER_ID')
					), $iId);
					
					if ($bIsImage)
					{
						$sThumbnail = Phpfox::getParam('core.dir_attachment') . sprintf($sFileName, '_thumb');
						$sViewImage = Phpfox::getParam('core.dir_attachment') . sprintf($sFileName, '_view');
						
						$oImage->createThumbnail(Phpfox::getParam('core.dir_attachment') . sprintf($sFileName, ''), $sThumbnail, Phpfox::getParam('attachment.attachment_max_thumbnail'), Phpfox::getParam('attachment.attachment_max_thumbnail'));
						$oImage->createThumbnail(Phpfox::getParam('core.dir_attachment') . sprintf($sFileName, ''), $sViewImage, Phpfox::getParam('attachment.attachment_max_medium'), Phpfox::getParam('attachment.attachment_max_medium'));
						
						$iFileSizes += (filesize($sThumbnail) + filesize($sThumbnail));
					}
	
					if (!isset($_FILES['Filedata']))
					{
						$this->_echo('window.parent.document.getElementById("js_attachment' . $iKey . '").innerHTML = "<input class=\"sJsFileAttachments\" type=\"file\" name=\"file[' . $iKey . ']\" value=\"\" /><span style=\"margin-left:4px;\" id=\"js_attachment_info_' . $iKey . '\">' . Phpfox::getPhrase('attachment.successfully_uploaded') . '</span>";');
					}
				}
				else 
				{
					if (isset($_FILES['Filedata']))
					{
						$this->_echo('alert("'.implode(' ', Phpfox_Error::get()) . ' ==> ' . Phpfox::getUserParam('attachment.item_max_upload_size') . ':'. Phpfox::getUserId().'");');
					}
					else
					{
						$this->_echo('window.parent.document.getElementById(\'js_attachment_input\').style.display = \'block\'; window.parent.document.getElementById(\'js_upload_bar\').style.display = \'none\'; window.parent.document.getElementById("js_attachment_info_' . $iKey . '").innerHTML = "<span style=\"margin-left:4px;\">' . implode(' ', Phpfox_Error::get()) . ' ==> ' . Phpfox::getUserParam('attachment.item_max_upload_size') . ':'. Phpfox::getUserId() .'::'.__LINE__.'</span>";');
					}
				}
			}
		}
		
		if (!$iUploaded)
		{
			exit;
		}
		
		ob_start();
		
		Phpfox::getBlock('attachment.current', array('sIds' => $sIds, 'bCanUseInline' => true, 'sAttachmentInput' => $this->request()->get('input')));
		
		$sContent = ob_get_contents();
		
		ob_clean();
		
		// Update user space usage
		Phpfox::getService('user.space')->update(Phpfox::getUserId(), 'attachment', $iFileSizes);	
		
		$sNewFileSize = ($this->request()->get('attachment_size_num') + $iFileSizes);
		
		if ($this->request()->get('input') == '')
		{			
			$this->_echo("window.parent.document.getElementById('js_attachment').value = window.parent.document.getElementById('js_attachment').value + '" . $sIds . "';");
		}
		$this->_echo("window.parent.$('#js_attachment_error_message').hide(); window.parent.document.getElementById('js_attachment_size_num').value = '" . $sNewFileSize . "'; window.parent.document.getElementById('js_attachment_input').style.display = 'block'; window.parent.document.getElementById('js_upload_bar').style.display = 'none';");
		$this->_echo("window.parent.document.getElementById('js_attachment_size').innerHTML = '(" . $oFile->filesize($sNewFileSize) . ")';	if (window.parent.document.getElementById('js_upload_info')) { window.parent.document.getElementById('js_upload_info').innerHTML = ''; }");
		$this->_echo("window.parent.document.getElementById('js_uploaded_data').innerHTML = '' + window.parent.document.getElementById('js_uploaded_data').innerHTML + '" . str_replace("'", "\'", str_replace(array("\n", "\t", "\r"), '', $sContent)) . "';");
		$this->_echo("window.parent.Phpfox.loadInit();");
		
		exit;
	}

	private function _echo($sTxt)
	{
		if (!isset($_FILES['Filedata']))
		{
			echo '<script type="text/javascript">' . $sTxt . '</script>';
		}
		else
		{
			echo $sTxt;
		}
	}
}

?>