<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Blog
 * @version 		$Id: index.class.php 1995 2010-10-29 09:24:20Z Raymond_Benc $
 */
class Blog_Component_Controller_Index extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{	
		if ($this->request()->get('req2') == 'main')
		{
			return Phpfox::getLib('module')->setController('error.404');
		}
	
		(($sPlugin = Phpfox_Plugin::get('blog.component_controller_index_process_start')) ? eval($sPlugin) : false);
		
		if (($iRedirectId = $this->request()->get('redirect')) && ($aRedirectBlog = Phpfox::getService('blog')->getBlogForEdit($iRedirectId)))
		{
			$this->url()->send($aRedirectBlog['user_name'], array('blog', $aRedirectBlog['title_url']));
		}

		Phpfox::getUserParam('blog.view_blogs', true);
		
		$bIsProfile = $this->getParam('bIsProfile');	
		if ($bIsProfile === true)
		{
			$aUser = $this->getParam('aUser');
		}
	
		/**
		 * Check if we are going to view an actual blog instead of the blog index page.
		 * The 2nd URL param needs to be numeric.
		 */
		if (!Phpfox::isAdminPanel())
		{
			if (($sBlogTitle = $this->request()->get(($bIsProfile === true ? 'req3' : 'req2'))) && $sBlogTitle != 'tag' && $sBlogTitle != 'category')
			{
				/**
				 * Since we are going to be viewing a blog lets reset the controller and get out of this one.
				 */
				return Phpfox::getLib('module')->setController('blog.view');			
			}		
		}

		$aVals = $this->request()->getArray('val');		

		/**
		 * This creates a global variable that can be used in other components. This is a good way to 
		 * pass information to other components.
		 */
		$this->setParam('sTagType', 'blog');
		
		$this->template()->setTitle(($bIsProfile ? Phpfox::getPhrase('blog.full_name_s_blogs', array('full_name' => $aUser['full_name'])) : Phpfox::getPhrase('blog.blog_title')))->setBreadCrumb(($bIsProfile ? Phpfox::getPhrase('blog.full_name_s_blogs', array('full_name' => $aUser['full_name'])) : Phpfox::getPhrase('blog.blog_title')), ($bIsProfile ? $this->url()->makeUrl($aUser['user_name'], 'blog') : $this->url()->makeUrl('blog')));
		
		$sView = $this->request()->get('view');
			
		$aPages = array(1, 5, 10, 15);
		$aDisplays = array();
		foreach ($aPages as $iPageCnt)
		{
			$aDisplays[$iPageCnt] = Phpfox::getPhrase('core.per_page', array('total' => $iPageCnt));
		}			
		
		$aSorts = array(
			'blog.time_stamp' => Phpfox::getPhrase('blog.time'),
			'total_view' => Phpfox::getPhrase('blog.most_viewed'),
			'total_comment' => Phpfox::getPhrase('blog.most_talked_about')
		);		
		
		$aFilters = array(
			'display' => array(
				'type' => 'select',
				'options' => $aDisplays,
				'default' => '5'
			),
			'sort' => array(
				'type' => 'select',
				'options' => $aSorts,
				'default' => 'time_stamp'
			),
			'sort_by' => array(
				'type' => 'select',
				'options' => array(
					'DESC' => Phpfox::getPhrase('core.descending'),
					'ASC' => Phpfox::getPhrase('core.ascending')
				),
				'default' => 'DESC'
			),
			'search' => array(
				'type' => 'input:text',
			)			
		);
		
		$oFilter = Phpfox::getLib('search')->set(array(
				'type' => 'blog',
				'filters' => $aFilters,
				'cache' => true,
				'field' => 'blog.blog_id',
				'search' => 'search'
			)
		);
		
		if ($oFilter->isSearch())
		{
			Phpfox::getUserParam('blog.search_blogs', true);
			
			$aSearch = $this->request()->getArray('search');
			
			$oFilter->search('like%', array(
				'blog.title',
				'blog_text.text'
			), $aSearch['search']);
			
			if ($bIsProfile === true)
			{
				$oFilter->setCondition("AND blog.user_id = " . (int) $aUser['user_id'] . " " . (($aUser['user_id'] == Phpfox::getUserId() || Phpfox::getUserParam('blog.can_approve_blogs')) ? '' : ' AND blog.is_approved = 1') . " " . (Phpfox::getUserId() == $aUser['user_id'] ? "" : " AND blog.post_status = 1"));
				if ($this->request()->get('status') && Phpfox::getUserId() == $aUser['user_id'])
				{
					$oFilter->setCondition("AND blog.post_status = 2");	
				}
			}
			else 
			{
				if (Phpfox::getUserParam('blog.can_approve_blogs'))
				{
					
				}
				else 
				{
					$oFilter->setCondition("AND blog.is_approved = 1 AND blog.privacy = 1 AND blog.post_status = 1");
				}
			}			
			
			switch ($this->request()->get('req2'))
			{
				case 'category':
					$oFilter->setCondition("AND blog_category.name_url = '" . Phpfox::getLib('database')->escape($this->request()->get('req3')) . "'");
					$aSearchResults = Phpfox::getService('blog.category')->getSearch($oFilter->getConditions(), $oFilter->getSort());										
					break;
				case 'tag':
					$oFilter->setCondition("AND tag.tag_url = '" . Phpfox::getLib('database')->escape($this->request()->get('req3')) . "'");					
					$aSearchResults = Phpfox::getService('tag')->getSearch('blog', $oFilter->getConditions(), $oFilter->getSort());					
					break;
				default:
					$aSearchResults = Phpfox::getService('blog')->getSearch($oFilter->getConditions(), $oFilter->getSort());
			}			
			
			(($sPlugin = Phpfox_Plugin::get('blog.component_controller_index_process_search')) ? eval($sPlugin) : false);
			
			$oFilter->cacheResults('search', $aSearchResults);
		}		

		$iPage = $this->request()->getInt('page');
		$iPageSize = $oFilter->getDisplay();	
		$sFormUrl = ($bIsProfile === true ? Phpfox::getService('user')->getLink($aUser['user_id'], $aUser['user_name'], 'blog') : $this->url()->makeUrl('blog'));
		
		if ($bIsProfile === true)
		{
			$oFilter->setCondition("AND blog.user_id = " . (int) $aUser['user_id'] . " " . (($aUser['user_id'] == Phpfox::getUserId() || Phpfox::getUserParam('blog.can_approve_blogs')) ? '' : ' AND blog.is_approved = 1') . " " . (Phpfox::getUserId() == $aUser['user_id'] ? "" : " AND blog.post_status = 1"));
			if ($this->request()->get('status') && Phpfox::getUserId() == $aUser['user_id'])
			{
				$oFilter->setCondition("AND blog.post_status = 2");	
			}
		}
		else 
		{
			if (Phpfox::getUserParam('blog.can_approve_blogs'))
			{
				
			}
			else 
			{
				$oFilter->setCondition("AND blog.is_approved = 1 AND blog.privacy = 1 AND blog.post_status = 1");
			}
		}
		
		switch ($sView)
		{
			case 'spam':
				if (Phpfox::getUserParam('blog.can_approve_blogs'))
				{
					$oFilter->setCondition('AND blog.is_approved = 9');
				}
				break;
			case 'pending':
				if (Phpfox::getUserParam('blog.can_approve_blogs'))
				{
					$oFilter->setCondition('AND blog.is_approved = 0');
				}				
				break;
			case 'most-viewed':
				$oFilter->setSort('total_view');
				break;
			case 'most-talked':
				$oFilter->setSort('total_comment');
				break;				
			default:
				
				break;
		}
		
		// Check if we are requesting to view a "category". Eg. www.site.com/blog/category1/phpfox/
		if ($this->request()->get(($bIsProfile === true ? 'req3' : 'req2')) == 'category')
		{
			// Get the category ID which is the 3rd param in a URL string
			$sCategoryName = $this->request()->get(($bIsProfile === true ? 'req4' : 'req3'));			
			
			/**
			 * Setting an extra template breadcrumb with the category name
			 */
			$this->template()->setBreadCrumb(Phpfox::getPhrase('blog.category'));

			list($iCnt, $aItems) = Phpfox::getService('blog.category')->getBlogsByCategory($sCategoryName, ($bIsProfile ? $aUser['user_id'] : 0), $oFilter->getConditions(), $oFilter->getSort(), $oFilter->getPage(), $iPageSize);
			
			if (isset($aItems[0]['category_name']))
			{
				$this->template()->setTitle(Phpfox::getLib('locale')->convert($aItems[0]['category_name']));
				$this->template()->setBreadCrumb(Phpfox::getLib('locale')->convert($aItems[0]['category_name']), $this->url()->makeUrl('current'), true);
				$sFormUrl = $this->url()->makeUrl('blog', array('category', $aItems[0]['category_name']));
			}
			
			$sFormUrl = $this->url()->makeUrl('blog.category', array($sCategoryName));
		}		
		elseif ($this->request()->get(($bIsProfile === true ? 'req3' : 'req2')) == 'tag')
		{			
			$oFilter->setCondition("AND tag.tag_url = '" . Phpfox::getLib('database')->escape($this->request()->get(($bIsProfile === true ? 'req4' : 'req3'))) . "'");
			
			list($iCnt, $aItems) = Phpfox::getService('tag')->get('blog', $this->request()->get(($bIsProfile === true ? 'req4' : 'req3')), $oFilter->getConditions(), $oFilter->getSort(), $oFilter->getPage(), $iPageSize);
			
			$sFormUrl = $this->url()->makeUrl('blog.tag', array($this->request()->get(($bIsProfile === true ? 'req4' : 'req3'))));
		}
		else 
		{
			list($iCnt, $aItems) = Phpfox::getService('blog')->get($oFilter->getConditions(), $oFilter->getSort(), $oFilter->getPage(), $iPageSize);
		}		

		// Alter the total page count if we are using the search filter
		$iCnt = $oFilter->getSearchTotal($iCnt);		
		
		Phpfox::getService('blog')->getExtra($aItems, 'user_profile');
		
		(($sPlugin = Phpfox_Plugin::get('blog.component_controller_index_process_middle')) ? eval($sPlugin) : false);

		Phpfox::getLib('pager')->set(array('page' => $iPage, 'size' => $iPageSize, 'count' => $iCnt));
		
		$aFilterMenuCache = array();
		$aFilterMenu = array();
		if (!defined('PHPFOX_IS_USER_PROFILE'))
		{
			$aFilterMenu = array(
				Phpfox::getPhrase('blog.recent_blogs') => '',
				Phpfox::getPhrase('blog.most_viewed') => 'most-viewed',
				Phpfox::getPhrase('blog.most_discussed') => 'most-talked'
			);			
				
			if (Phpfox::getUserParam('blog.can_approve_blogs'))
			{
				$aFilterMenu[Phpfox::getPhrase('blog.pending')] = 'pending';
			}
		}		
		
		$iFilterCount = 0;
		foreach ($aFilterMenu as $sMenuName => $sMenuLink)
		{
			$iFilterCount++;
			$aFilterMenuCache[] = array(
				'name' => $sMenuName,
				'link' => $this->url()->makeUrl('blog', array('view' => $sMenuLink)),
				'active' => ($sView == $sMenuLink ? true : false),
				'last' => (count($aFilterMenu) === $iFilterCount ? true : false)
			);
			
			if (!empty($sView) && $sView == $sMenuLink)
			{
				$this->template()->setTitle($sMenuName);
				$this->template()->setBreadcrumb($sMenuName, null, true);
			}
		}		
		
		$this->template()->setMeta('keywords', Phpfox::getParam('blog.blog_meta_keywords'));
		$this->template()->setMeta('description', Phpfox::getParam('blog.blog_meta_description'));
		if ($bIsProfile)
		{
			$this->template()->setMeta('description', '' . $aUser['full_name'] . ' has ' . $iCnt . ' blogs.');
		}
		
		foreach ($aItems as $aItem)
		{
			$this->template()->setMeta('keywords', $this->template()->getKeywords($aItem['title']));	
			if (!empty($aItem['tag_list']))
			{
				$this->template()->setMeta('keywords', Phpfox::getService('tag')->getKeywords($aItem['tag_list']));
			}
		}
		
		/**
		 * Here we assign the needed variables we plan on using in the template. This is used to pass
		 * on any information that needs to be used with the specific template for this component.
		 */
		$this->template()->assign(array(
					'iCnt' => $iCnt,
					'aItems' => $aItems,
					'sFormUrl' => $sFormUrl,
					'sSearchBlock' => Phpfox::getPhrase('blog.search_blogs_'),
					'bIsProfile' => $bIsProfile,
					'sTagType' => ($bIsProfile === true ? 'blog_profile' : 'blog'),
					'sBlogStatus' => $this->request()->get('status'),
					'iShorten' => Phpfox::getParam('blog.length_in_index'),
					'aFilterMenus' => $aFilterMenuCache,
					'iTotalBlogToApprove' => (Phpfox::getUserParam('blog.can_approve_blogs') ? Phpfox::getService('blog')->getPendingTotal() : 0),
					'sView' => $sView
				)
			)
			->setHeader('cache', array(
				'quick_submit.js' => 'module_blog',
				'jquery/plugin/jquery.highlightFade.js' => 'static_script',				
				'quick_edit.js' => 'static_script',	
				'pager.css' => 'style_css',
				'switch_legend.js' => 'static_script',
				'switch_menu.js' => 'static_script'				
			)
		);
		
		if (Phpfox::getUserId())
		{
			$this->template()->setEditor(array(
					'load' => 'simple',
					'wysiwyg' => false
				)
			);
		}			
		
		(($sPlugin = Phpfox_Plugin::get('blog.component_controller_index_process_end')) ? eval($sPlugin) : false);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		$this->template()->clean(array(
				'iCnt',
				'aItems',
				'sSearchBlock'
			)
		);
		
		(($sPlugin = Phpfox_Plugin::get('blog.component_controller_index_clean')) ? eval($sPlugin) : false);
	}
}

?>