<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Blog
 * @version 		$Id: view.class.php 2103 2010-11-09 16:02:21Z Raymond_Benc $
 */
class Blog_Component_Controller_View extends Phpfox_Component 
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		if ($this->request()->getInt('id'))
		{
			return Phpfox::getLib('module')->setController('error.404');
		}
		
		Phpfox::getUserParam('blog.view_blogs', true);
		
		(($sPlugin = Phpfox_Plugin::get('blog.component_controller_view_process_start')) ? eval($sPlugin) : false);	
		
		$bIsProfile = $this->getParam('bIsProfile');		
		if ($bIsProfile === true)
		{
			$this->setParam(array(
					'bViewProfileBlog' => true,
					'sTagType' => 'blog'
				)
			);
		}
	
		$sBlogTitle = $this->request()->get(($bIsProfile === true ? 'req3' : 'req2'));		
		
		if ($bIsProfile === true)
		{
			$aUser = $this->getParam('aUser');
			$aItem = Phpfox::getService('blog')->getBlog($sBlogTitle, $aUser['user_id']);
		}
		else
		{
			$aItem = Phpfox::getService('blog')->getBlog($sBlogTitle);
		}

		if (!isset($aItem['blog_id']))
		{
			return Phpfox_Error::display(Phpfox::getPhrase('blog.blog_not_found'));
		}
		
		if (!Phpfox::getUserParam('blog.can_approve_blogs'))
		{
			if ($aItem['is_approved'] != '1' && $aItem['user_id'] != Phpfox::getUserId())
			{
				return Phpfox_Error::display(Phpfox::getPhrase('blog.blog_not_found'));
			}
		}
		
		if ($aItem['post_status'] == 2 && Phpfox::getUserId() != $aItem['user_id'])
		{
			return Phpfox_Error::display(Phpfox::getPhrase('blog.blog_not_found'));
		}
		
		if (Phpfox::isModule('notification') && $aItem['user_id'] == Phpfox::getUserId())
		{
			Phpfox::getService('notification.process')->delete('blog_approved', $aItem['blog_id'], Phpfox::getUserId());
			Phpfox::getService('notification.process')->delete('blog_notifyLike', $aItem['blog_id'], Phpfox::getUserId());
		}		
		
		if (Phpfox::isModule('track') && Phpfox::isUser() && Phpfox::getUserId() != $aItem['user_id'] && !$aItem['is_viewed'])
		{
			Phpfox::getService('track.process')->add('blog', $aItem['blog_id']);
			Phpfox::getService('blog.process')->updateView($aItem['blog_id']);
		}
		
		if (Phpfox::isUser() && Phpfox::isModule('track') && Phpfox::getUserId() != $aItem['user_id'] && $aItem['is_viewed'] && !Phpfox::getUserBy('is_invisible'))
		{
			Phpfox::getService('track.process')->update('blog_track', $aItem['blog_id']);	
		}		
		
		// Define params for "review views" block
		$this->setParam(array(
				'sTrackType' => 'blog',
				'iTrackId' => $aItem['blog_id'],
				'iTrackUserId' => $aItem['user_id']
			)
		);
		
		if ($sPassword = $this->request()->get('blog_password'))
		{			
			if (Phpfox::getUserParam('blog.can_view_password_protected_blog'))
			{
				if (Phpfox::getService('blog')->verifyPassword($aItem['blog_id'], $sPassword))
				{
					$this->url()->send($aItem['user_name'], array('blog', $aItem['title_url']));	
				}
				else 
				{
					$this->url()->send($aItem['user_name'], array('blog', $aItem['title_url']), Phpfox::getPhrase('blog.password_is_invalid'));
				}			
			}
			else 
			{
				$this->url()->send($aItem['user_name'], array('blog', $aItem['title_url']), Phpfox::getPhrase('blog.unable_to_view_password_protected_blogs'));
			}
		}
		
		$aCategories = Phpfox::getService('blog.category')->getCategoriesById($aItem['blog_id']);
		
		if (Phpfox::isModule('tag'))
		{
			$aTags = Phpfox::getService('tag')->getTagsById('blog', $aItem['blog_id']);	
			if (isset($aTags[$aItem['blog_id']]))
			{
				$aItem['tag_list'] = $aTags[$aItem['blog_id']];
			}
		}
		
		if (isset($aCategories[$aItem['blog_id']]))
		{
			$sCategories = '';
			foreach ($aCategories[$aItem['blog_id']] as $iKey => $aCategory)
			{
				$sCategories .= ($iKey != 0 ? ',' : '') . ' <a href="' . ($aCategory['user_id'] ? Phpfox::getService('user')->getLink($aItem['user_id'], $aItem['user_name'], array('blog', 'category', $aCategory['name_url'])) : $this->url()->makeUrl('blog',  array('category', $aCategory['name_url']))) . '">' . Phpfox::getLib('locale')->convert(Phpfox::getLib('parse.output')->clean($aCategory['category_name'])) . '</a>';
				
				$this->template()->setMeta('keywords', $aCategory['category_name']);
			}
		}
		if (isset($sCategories))
		{
			$aItem['info'] = Phpfox::getPhrase('blog.posted_x_by_x_in_x', array('date' => Phpfox::getTime(Phpfox::getParam('blog.blog_time_stamp'), $aItem['time_stamp']), 'link' => Phpfox::getLib('url')->makeUrl('profile', array($aItem['user_name'])), 'user' => $aItem, 'categories' => $sCategories));
		}
		else 
		{
			$aItem['info'] = Phpfox::getPhrase('blog.posted_x_by_x', array('date' => Phpfox::getTime(Phpfox::getParam('blog.blog_time_stamp'), $aItem['time_stamp']), 'link' => Phpfox::getLib('url')->makeUrl('profile', array($aItem['user_name'])), 'user' => $aItem));
		}		
		
		$aItem['bookmark_url'] = Phpfox::getLib('url')->makeUrl('profile', array($aItem['user_name'], 'blog', $aItem['title_url']));
		
		(($sPlugin = Phpfox_Plugin::get('blog.component_controller_view_process_middle')) ? eval($sPlugin) : false);

		if (!Phpfox::getUserParam('blog.can_view_private_blogs') && $aItem['privacy'] == 4 && Phpfox::getUserId() != $aItem['user_id'] && !$aItem['privacy_pass'])
		{
			Phpfox::getLib('url')->send('privacy.invalid');
		}
		
		if (!Phpfox::getUserParam('blog.can_view_private_blogs') && $aItem['privacy'] == 3 && Phpfox::getUserId() != $aItem['user_id'] && !$aItem['is_friend'])
		{
			Phpfox::getLib('url')->send('friend.request');
		}
		
		// Add tags to meta keywords
		if (!empty($aItem['tag_list']) && $aItem['tag_list'] && Phpfox::isModule('tag'))
		{
			$this->template()->setMeta('keywords', Phpfox::getService('tag')->getKeywords($aItem['tag_list']));
		}	
		
		if ($aItem['user_id'] == Phpfox::getUserId())
		{
			Phpfox::getService('notification.process')->delete('comment_blog', $aItem['blog_id'], Phpfox::getUserId());
		}
		
		$this->template()->setTitle($aItem['title'])
		 	->setBreadCrumb(Phpfox::getPhrase('blog.blogs_title'), $this->url()->makeUrl('blog'))			
			->setMeta('description', $aItem['title'] . '.')
			->setMeta('description', $aItem['text'] . '.')
			->setMeta('description', $aItem['info'] . '.')
			->setMeta('keywords', $this->template()->getKeywords($aItem['title']))	
			->assign(array(
					'aItem' => $aItem,
					'bBlogView' => true,
					'bIsProfile' => $bIsProfile,
					'sTagType' => ($bIsProfile === true ? 'blog_profile' : 'blog'),
					'iShorten' => Phpfox::getParam('blog.length_in_index')
				)
			)->setHeader('cache', array(
				'jquery/plugin/jquery.highlightFade.js' => 'static_script',
				'jquery/plugin/jquery.scrollTo.js' => 'static_script',
				'quick_edit.js' => 'static_script',
				'comment.css' => 'style_css',
				'pager.css' => 'style_css',
				'switch_legend.js' => 'static_script',
				'switch_menu.js' => 'static_script'				
			)
		);
		if (isset($aUser['user_name']))
		{
			$this->template()->setBreadCrumb($aItem['title'], $this->url()->makeUrl($aUser['user_name'] . '.blog.'.$aItem['title_url']), true);
		}
		else{
			$this->template()->setBreadCrumb($aItem['title'], $this->url()->makeUrl('blog', $aItem['title_url']), true);
		}
		if (Phpfox::getUserId())
		{
			$this->template()->setEditor(array(
					'load' => 'simple',
					'wysiwyg' => ((Phpfox::isModule('comment') && Phpfox::getParam('comment.wysiwyg_comments')) && Phpfox::getUserParam('comment.wysiwyg_on_comments'))
				)
			);
		}		
		
		(($sPlugin = Phpfox_Plugin::get('blog.component_controller_view_process_end')) ? eval($sPlugin) : false);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('blog.component_controller_view_clean')) ? eval($sPlugin) : false);
	}
}

?>