<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Bulletin
 * @version 		$Id: index.class.php 1599 2010-05-28 04:31:26Z Raymond_Benc $
 */
class Bulletin_Component_Controller_Index extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('bulletin.bulletin_can_view_bulletins',true);
		
		// is trying to delete a bulletin
		if ($iDelete = $this->request()->getInt('delete'))
		{
			// get the bulletin:
			$aBulletin = Phpfox::getService('bulletin.bulletin')->getBulletin($iDelete);
			
			if (isset($aBulletin['bulletin_id']))
			{			
				// check if user is the owner of the bulletin and can edit the bulletin
				if (Phpfox::getUserId() == $aBulletin['user_id'])
				{
					Phpfox::getUserParam('bulletin.bulletin_can_delete_own', true);
				}
				else
				{
					Phpfox::getUserParam('bulletin.bulletin_can_delete_others', true);	
				}
				
				if (Phpfox::getService('bulletin.process')->delete($iDelete, $aBulletin['user_id']))
				{
					$this->url()->send('bulletin', null, Phpfox::getPhrase('bulletin.bulletin_successfully_deleted'));
				}
			}
		}
		
		$iPage = $this->request()->getInt('page');
		$iPageSize = 6;		
		$aCond = array();

		// Are we only planning to see our own bulletins?
		if ($this->request()->get('req2') == 'my')
		{
			// Set the condition
			$aCond[] = 'b.user_id = ' . Phpfox::getUserId();
		}
		elseif ($this->request()->get('view') == 'approval' && Phpfox::getUserParam('bulletin.can_approve_bulletins'))
		{	
			$aCond[] = 'AND b.view_id = 1';		
		}
		else 
		{
			if (!Phpfox::getUserParam('bulletin.can_approve_bulletins'))
			{
				$aCond[] = 'AND b.view_id = 0';	
			}
		}
		
		list($iCnt, $aBulletins) = Phpfox::getService('bulletin')->get($aCond, $iPage, $iPageSize);
		
		Phpfox::getLib('pager')->set(array('page' => $iPage, 'size' => $iPageSize, 'count' => $iCnt));
		
		$this->template()->setTitle(Phpfox::getPhrase('bulletin.bulletins'))
			->setBreadcrumb(Phpfox::getPhrase('bulletin.bulletins'), $this->url()->makeUrl('bulletin'))
			->setHeader('cache', array(
					'pager.css' => 'style_css'
				)
			)
			->assign(array(				
				'aBulletin' => $aBulletins	// this assignment happens because we always need to show the aBulletins
			)
		);		
		
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('bulletin.component_controller_index_clean')) ? eval($sPlugin) : false);
	}
}

?>