<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * Displays a welcome message to a user in the sites index page. 
 * Also contains by default the users profile URL, current time stamp and link to site themes.
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Core
 * @version 		$Id: welcome.class.php 1287 2009-12-01 22:34:30Z Raymond_Benc $
 */
class Core_Component_Block_Welcome extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		// If the user is not a member don't display this block
		if (!Phpfox::isUser())
		{
			return false;
		}

		// Assign template vars
		$this->template()->assign(array(
				'sUserProfileUrl' => $this->url()->makeUrl('profile', Phpfox::getUserBy('user_name')), // Create the users profile URL
				'sCurrentUserName' => Phpfox::getLib('parse.output')->shorten(Phpfox::getLib('parse.output')->clean(Phpfox::getUserBy('full_name')), 50, '...'), // Get the users display name
				'sCurrentTimeStamp' => Phpfox::getTime(Phpfox::getParam('core.global_welcome_time_stamp'), PHPFOX_TIME) // Get the current time stamp
			)
		);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('core.component_controller_index_clean')) ? eval($sPlugin) : false);
		
		// Clean template vars from memory
		$this->template()->clean(array(
				'sUserProfileUrl'
			)
		);
	}
}

?>