<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: display.class.php 888 2009-08-21 12:15:22Z Raymond_Benc $
 */
class Custom_Component_Block_Display extends Phpfox_Component
{
	private $_sTemplate = null;
	
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		static $iUserGroupId = 0;
		static $bIsCustom = false;
		
		if (!Phpfox::getService('user.privacy')->hasAccess($this->getParam('item_id'), 'profile.profile_info'))
		{
			return false;
		}
		
		if ($iUserGroupId === 0)
		{
			$aUser = (PHPFOX_IS_AJAX ? array('user_group_id' => $this->getParam('user_group_id')) : $this->getParam('aUser'));
		
			$bIsCustom = Phpfox::getService('user.group.setting')->getGroupParam($aUser['user_group_id'], 'custom.has_special_custom_fields');
			$iUserGroupId = $aUser['user_group_id'];
		}
		
		$aCustomMain = Phpfox::getService('custom')->getForDisplay($this->getParam('type_id'), $this->getParam('item_id'), ($bIsCustom ? $iUserGroupId : null));
		
		if (!is_array($aCustomMain))
		{
			return false;
		}
		
		$this->_sTemplate = $this->getParam('template');

		$this->template()->assign(array(
				'aCustomMain' => $aCustomMain,
				'sTemplate' => $this->getParam('template')
			)
		);	
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{		
		$this->template()->clean(array(
				'aCustomMain'
			)
		);
		
		(($sPlugin = Phpfox_Plugin::get('custom.component_block_display_clean')) ? eval($sPlugin) : false);
	}

	public function getCacheId()
	{		
		if ($this->_sTemplate != 'sidebar' || $this->_sTemplate != 'content')
		{	
			return false;
		}
	}		
}

?>