<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Service
 * @version 		$Id: callback.class.php 1585 2010-05-07 13:08:58Z Raymond_Benc $
 */
class Custom_Service_Callback extends Phpfox_Service 
{
	/**
	 * Class constructor
	 */	
	public function __construct()
	{	
		
	}
	
	public function exportModule($sProduct, $sModule)
	{
		return Phpfox::getService('custom')->export($sProduct, $sModule);
	}
	
	public function reparserList()
	{
		$aFields = $this->database()->select('*')
			->from(Phpfox::getT('custom_field'))
			->where('var_type IN(\'textarea\', \'text\')')
			->execute('getRows');
		
		$aCallback = array();
		foreach ($aFields as $aField)
		{
			if (!Phpfox::isModule($aField['module_id']))
			{
				continue;
			}
			
			$aCallback[] = array(
				'name' => Phpfox::getPhrase($aField['phrase_var_name']) . ' (' . Phpfox::getPhrase('admincp.custom_field') . ')',
				'table' => array('user_custom_value', 'user_custom'),
				'original' => 'cf_' . $aField['field_name'],
				'parsed' => 'cf_' . $aField['field_name'],
				'item_field' => 'user_id'
			);
		}	
		
		return $aCallback;
	}
	
	/**
	 * If a call is made to an unknown method attempt to connect
	 * it to a specific plug-in with the same name thus allowing 
	 * plug-in developers the ability to extend classes.
	 *
	 * @param string $sMethod is the name of the method
	 * @param array $aArguments is the array of arguments of being passed
	 */
	public function __call($sMethod, $aArguments)
	{
		/**
		 * Check if such a plug-in exists and if it does call it.
		 */
		if ($sPlugin = Phpfox_Plugin::get('custom.service_callback__call'))
		{
			return eval($sPlugin);
		}
			
		/**
		 * No method or plug-in found we must throw a error.
		 */
		Phpfox_Error::trigger('Call to undefined method ' . __CLASS__ . '::' . $sMethod . '()', E_USER_ERROR);
	}	
}

?>