<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: view.class.php 1316 2009-12-10 22:42:54Z Raymond_Benc $
 */
class Event_Component_Controller_View extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('event.can_access_event', true);
		
		$aCallback = $this->getParam('aCallback', false);
		
		$sEvent = $this->request()->get(($aCallback !== false ? $aCallback['request'] : 'req3'));
		
		if (!($aEvent = Phpfox::getService('event')->callback($aCallback)->getEvent($sEvent)))
		{
			return Phpfox_Error::display(Phpfox::getPhrase('event.the_event_you_are_looking_for_does_not_exist_or_has_been_removed'));
		}
		
		if ($aCallback !== false)
		{
			$aEvent['host'] = $aCallback['host'];
		}		
		
		if ($aEvent['privacy'] == '1' && !$aEvent['invite_id'] && !Phpfox::getUserParam('event.can_approve_events') && !Phpfox::getUserParam('event.can_view_pirvate_events'))
		{
			return Phpfox_Error::display(Phpfox::getPhrase('event.this_event_is_private'));	
		}
		
		if (Phpfox::isModule('notification') && $aEvent['user_id'] == Phpfox::getUserId())
		{
			Phpfox::getService('notification.process')->delete('event_approved', $aEvent['event_id'], Phpfox::getUserId());
			Phpfox::getService('notification.process')->delete('event_notifyLike', $aEvent['event_id'], Phpfox::getUserId());
		}			
		
		$this->setParam('aEvent', $aEvent);
		
		$this->template()->setTitle($aEvent['title'])
			->setMeta('description', $aEvent['description'])
			->setMeta('keywords', $this->template()->getKeywords($aEvent['title']))
			->setBreadcrumb(Phpfox::getPhrase('event.events'), ($aCallback !== false ? $this->url()->makeUrl($aCallback['url'][0], array_merge($aCallback['url'][1], array('event'))) : $this->url()->makeUrl('event')))
			->setBreadcrumb($aEvent['breadcrumb'])
			->setBreadcrumb($aEvent['title'], null, true)
			->setHeader('cache', array(
					'jquery/plugin/jquery.highlightFade.js' => 'static_script',	
					'jquery/plugin/jquery.scrollTo.js' => 'static_script',
					'quick_edit.js' => 'static_script',
					'comment.css' => 'style_css',
					'pager.css' => 'style_css',
					'switch_legend.js' => 'static_script',
					'switch_menu.js' => 'static_script'					
				)
			)			
			->setHeader(array(
					'<script type="text/javascript">$(function(){$(\'.js_mp_fix_width\').each(function(){$(this).parents(\'.js_mp_fix_holder:first\').width(this.width);});});</script>'
				)
			)
			->setEditor(array(
					'load' => 'simple'
				)
			)
			->assign(array(
					'aEvent' => $aEvent,
					'aCallback' => $aCallback
				)
			);			
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('event.component_controller_view_clean')) ? eval($sPlugin) : false);
	}
}

?>