<?php 
/**
 * [PHPFOX_HEADER]
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Event
 * @version 		$Id: index.html.php 1549 2010-04-14 10:42:27Z Miguel_Espinoza $
 */
 
defined('PHPFOX') or exit('NO DICE!'); 

?>
{if !count($aEvents)}
<div class="extra_info">
{if $sView == 'invitation'}
	{phrase var='event.you_have_not_been_invited_to_any_events_yet'}
	<ul class="action">
		<li><a href="{url link=$sParentLink}">{phrase var='event.browse_events'}</a></li>
	</ul>	
{elseif $sView == 'attending'}
	{phrase var='event.you_are_not_attending_any_events'}
	<ul class="action">
		<li><a href="{url link=$sParentLink}">{phrase var='event.browse_events'}</a></li>
	</ul>
{elseif $sView == 'maybe'}
	{phrase var='event.no_events_found_where_you_might_attend'}
	<ul class="action">
		<li><a href="{url link=$sParentLink}">{phrase var='event.browse_events'}</a></li>
	</ul>
{elseif $sView == 'not_attending'}
	{phrase var='event.no_events_found_where_you_are_not_attending'}
	<ul class="action">
		<li><a href="{url link=$sParentLink}">{phrase var='event.browse_events'}</a></li>
	</ul>
{elseif $sView == 'past'}
	{phrase var='event.no_past_events_were_found'}
	<ul class="action">
		<li><a href="{url link=$sParentLink}">{phrase var='event.browse_events'}</a></li>
	</ul>
{else}
	{phrase var='event.no_events_have_been_created'}
	<ul class="action">
		<li><a href="{url link=''$sParentLink'.add'}">{phrase var='event.be_the_first_to_create_an_event'}</a></li>
	</ul>
{/if}
</div>
{else}

{if $iEventApproveCnt}
<div class="message">
{if $iEventApproveCnt == 1}
	{phrase var='event.there_is_one_event_that_is_pending_approval'}
{else}
	{phrase var='event.there_are_total_events_that_are_pending_approval' total=$iEventApproveCnt}
{/if}
{phrase var='event.click_here_to_approve_events' link=$sApproveLink}
</div>
{/if}

<div class="main_break"></div>

{foreach from=$aEvents key=sDate item=aGroups}
<div class="block">
	<div class="title">{$sDate}</div>	
	<div class="border">
		<div class="content">
			{foreach from=$aGroups name=events item=aEvent}
			<div id="js_event_item_holder_{$aEvent.event_id}" class="js_event_parent {if $aEvent.is_sponsor && !defined('PHPFOX_IS_GROUP_VIEW')}row_sponsored {elseif $aEvent.is_featured}row_featured {/if}{if $aEvent.view_id == 1}row_moderate {/if}{if is_int($phpfox.iteration.events)}row1{else}row2{/if}{if $phpfox.iteration.events == 1} row_first{/if}">
				{if $aEvent.privacy == 1}
				<span class="row_featured_link">
					{phrase var='event.private'}
				</span>
				{/if}
				<span class="js_featured_event row_featured_link"{if !$aEvent.is_featured} style="display:none;"{/if}>
					{phrase var='event.featured'}
				</span>
				<span class="row_pending_link"{if $aEvent.view_id != 1} style="display:none;"{/if}>
					{phrase var='event.pending'}
				</span>
				<div style="width:130px; position:absolute; text-align:center; left:5px;">
					<a href="{$aEvent.url}">{img server_id=$aEvent.server_id title=$aEvent.title path='event.url_image' file=$aEvent.image_path suffix='_120' max_width='120' max_height='120'}</a>
				</div>
				<div style="margin-left:135px; height:120px;">
					<a href="{$aEvent.url}">{$aEvent.title|clean}</a>
					{if !empty($aEvent.tag_line)}
					<div class="extra_info">
						{$aEvent.tag_line|clean}
					</div>
					{/if}
					<div class="extra_info">
						{phrase var='event.start_time_at_location' start_time=$aEvent.start_time_phrase location=$aEvent.location_phrase}
						{if !empty($aEvent.city)}, {$aEvent.city|clean}{/if}, {$aEvent.country_iso|location}
						{if count($aEvent.breadcrumb)}
							<div class="p_4">
							{foreach from=$aEvent.breadcrumb name=breadcrumbs item=aBredcrumb}
							{if $phpfox.iteration.breadcrumbs != 1}&raquo; {/if}<a href="{$aBredcrumb.1}">{$aBredcrumb.0}</a>
							{/foreach}
							</div>
						{/if}
					</div>
					<div class="extra_info" style="padding-top:0px;">
						{phrase var='event.posted_by_user_name_on_time_stamp' user_name=$aEvent.user_name_link time_stamp=$aEvent.time_stamp_phrase}
					</div>
					{if isset($aEvent.rsvp_id)}
					<div class="separate" style="margin-bottom:0px;"></div>
					<div class="extra_info">
						{phrase var='event.your_rsvp'}: <span id="js_event_rsvp_{$aEvent.event_id}">
						{if $aEvent.rsvp_id == 3}
							{phrase var='event.not_attending'}
						{elseif $aEvent.rsvp_id == 2}
							{phrase var='event.maybe'}
						{elseif $aEvent.rsvp_id == 1}
							{phrase var='event.attending'}
						{else}
							<a href="#" onclick="tb_show('{phrase var='event.rsvp' phpfox_squote=true}', $.ajaxBox('event.rsvp', 'height=130&amp;width=300&amp;id={$aEvent.event_id}')); return false;">{phrase var='event.no_response'}</a>
						{/if}
						{if $aEvent.rsvp_id}
							(<a href="#" onclick="tb_show('{phrase var='event.rsvp' phpfox_squote=true}', $.ajaxBox('event.rsvp', 'height=130&amp;width=300&amp;id={$aEvent.event_id}{if $aCallback !== false}&amp;module={$aCallback.module}&amp;item={$aCallback.item}{/if}')); return false;">{phrase var='event.edit_lowercase'}</a>)
						{/if}
						</span>
					</div>
					{/if}
				</div>
				<div class="t_right">
					<ul class="item_menu" style="margin:0px;">
					{if $sView == 'invitation'}
						<li><a href="#" onclick="if (confirm('{phrase var='event.are_you_sure' phpfox_squote=true}')) {left_curly} $(this).parents('.js_event_parent:first').remove(); $.ajaxCall('event.removeInvite', 'id={$aEvent.event_id}'); {right_curly} return false;">{phrase var='event.remove_invite'}</a></li>
					{/if}
					{if $aEvent.view_id == 1 && Phpfox::getUserParam('event.can_approve_events')}
						<li><a href="#" title="{phrase var='event.approve_this_event'}" onclick="$(this).parents('.js_event_parent:first').removeClass('row_moderate').find('.row_pending_link:first').html('{phrase var='event.approved' phpfox_squote=true}').fadeOut(5000); $.ajaxCall('event.approve', 'event_id={$aEvent.event_id}'); $(this).parent().remove(); return false;">{phrase var='event.approve'}</a></li>
					{/if}
					{if $aEvent.view_id == 0 && Phpfox::getUserParam('event.can_feature_events')}
						<li id="js_feature_{$aEvent.event_id}"{if $aEvent.is_featured} style="display:none;"{/if}><a href="#" title="{phrase var='event.feature_this_event'}" onclick="$(this).parent().hide(); $('#js_unfeature_{$aEvent.event_id}').show(); $(this).parents('.js_event_parent:first').addClass('row_featured').find('.js_featured_event').show(); $.ajaxCall('event.feature', 'event_id={$aEvent.event_id}&amp;type=1'); return false;">{phrase var='event.feature'}</a></li>				
						<li id="js_unfeature_{$aEvent.event_id}"{if !$aEvent.is_featured} style="display:none;"{/if}><a href="#" title="{phrase var='event.un_feature_this_event'}" onclick="$(this).parent().hide(); $('#js_feature_{$aEvent.event_id}').show(); $(this).parents('.js_event_parent:first').removeClass('row_featured').find('.js_featured_event').hide(); $.ajaxCall('event.feature', 'event_id={$aEvent.event_id}&amp;type=0'); return false;">{phrase var='event.unfeature'}</a></li>				
					{/if}					
					{if ($aEvent.user_id == Phpfox::getUserId() && Phpfox::getUserParam('event.can_delete_own_event')) || Phpfox::getUserParam('event.can_delete_other_event')}
						<li><a href="#" onclick="if (confirm('{phrase var='event.are_you_sure' phpfox_squote=true}')) {literal}{{/literal} $.ajaxCall('event.delete', 'id={$aEvent.event_id}'); {literal}}{/literal} return false;">{phrase var='event.delete'}</a></li>
					{/if}
					{if Phpfox::getUserParam('event.can_sponsor_event') && !defined('PHPFOX_IS_GROUP_VIEW')}
					<li>					    
						
						<span id="js_event_unsponsor_{$aEvent.event_id}" {if !$aEvent.is_sponsor}style="display:none"{/if}>
						    <a href="#" title="{phrase var='event.unsponsor_this_event'}" onclick="$.ajaxCall('event.sponsor', 'event_id={$aEvent.event_id}&amp;type=0'); return false;">
						       {phrase var='event.unsponsor_this_event'}
						    </a>
						</span>
						
						<span id="js_event_sponsor_{$aEvent.event_id}" {if $aEvent.is_sponsor}style="display:none"{/if}>
						    <a href="#" title="{phrase var='event.sponsor_this_event'}" onclick="$.ajaxCall('event.sponsor', 'event_id={$aEvent.event_id}&amp;type=1'); return false;">
							{phrase var='event.sponsor_this_event'}
						    </a>
						</span>
						
					</li>
					{/if}
						<li><!-- --></li>
					</ul>	
				</div>
			</div>
			{/foreach}
		</div>
	</div>
</div>
{/foreach}
{pager}
{/if}