<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Ajax
 * @version 		$Id: ajax.class.php 1599 2010-05-28 04:31:26Z Raymond_Benc $
 */
class Feed_Component_Ajax_Ajax extends Phpfox_Ajax
{
	public function getEditBar()
	{
		Phpfox::getBlock('feed.setting');
		
		$this->html('#js_edit_block_' . $this->get('block_id'), $this->getContent(false))->slideDown('#js_edit_block_' . $this->get('block_id'));
	}
	
	public function addComment()
	{
		$aVals = $this->get('val');
		
		Phpfox::isUser(true);
		Phpfox::getUserParam('comment.can_post_comments', true);
		
		if (!Phpfox::getService('user.privacy')->hasAccess($aVals['item_id'], 'comment.add_comment'))
		{
			$this->html('#js_feed_comment_process', '');
			$this->call("$('#js_feed_comment_submit').removeAttr('disabled');");			
			$this->alert(Phpfox::getPhrase('feed.you_do_not_have_permission_to_add_a_comment_on_this_persons_profile'));
			
			return false;
		}				
		
		if (($iFlood = Phpfox::getUserParam('comment.comment_post_flood_control')) !== 0)
		{
			$aFlood = array(
				'action' => 'last_post', // The SPAM action
				'params' => array(
					'field' => 'time_stamp', // The time stamp field
					'table' => Phpfox::getT('feed'), // Database table we plan to check
					'condition' => 'type_id = \'comment_profile_my\' AND user_id = ' . Phpfox::getUserId(), // Database WHERE query
					'time_stamp' => $iFlood * 60 // Seconds);	
				)
			);
				 			
			// actually check if flooding
			if (Phpfox::getLib('spam')->check($aFlood))
			{				
				$this->html('#js_feed_comment_process', '');
				$this->call("$('#js_feed_comment_submit').removeAttr('disabled');");				
				$this->alert(Phpfox::getPhrase('feed.posting_a_comment_a_little_too_soon') . ' ' . Phpfox::getLib('spam')->getWaitTime());
			 				
				return false;
			}		
		}
		
		if (Phpfox::getLib('parse.format')->isEmpty($aVals['feed_text']))
		{
			$this->html('#js_feed_comment_process', '');
			$this->call("$('#js_feed_comment_submit').removeAttr('disabled');");
			$this->alert(Phpfox::getPhrase('feed.add_some_text_to_your_comment'));
			
			return false;
		}		
		
		if (($iId = Phpfox::getService('feed.process')->addComment($aVals)))
		{
			list($iCnt, $aFeeds) = Phpfox::getService('feed')->get($aVals['item_id'], $iId);
			
			define('PHPFOX_IS_USER_PROFILE', true);
			
			$aUser = Phpfox::getService('user')->get($aVals['item_id']);
			$this->template()->assign(array(
					'aUser' => $aUser
				)
			);
			
			Phpfox::getLib('template')->assign(array('aFeed' => $aFeeds[0]))->getTemplate('feed.block.entry');
			
			$this->prepend('#js_new_feed_comment', $this->getContent(false));
			$this->removeClass('.js_user_feed', 'row_first');
			$this->call("iCnt = 0; \$('.js_user_feed').each(function(){ iCnt++; if (iCnt == 1) { \$(this).addClass('row_first'); } });");
			$this->html('#js_feed_comment_process', '');
			$this->call("$('#js_feed_comment_submit').removeAttr('disabled'); $.scrollTo('#js_new_feed_comment', 800); $('#js_feed_comment_form')[0].reset();");		
			
			$this->call('Phpfox.loadInit();');
		}
		else 
		{
				$this->html('#js_feed_comment_process', '');
				$this->call("$('#js_feed_comment_submit').removeAttr('disabled');");				
			 				
				return false;			
		}
	}
	
	public function viewMore()
	{
		Phpfox::getBlock('feed.display');
		
		$this->remove('#feed_view_more');
		$this->append('#js_feed_content', $this->getContent(false));
		$this->call('Phpfox.loadInit();');
	}
	
	public function rate()
	{		
		Phpfox::isUser(true);
		
		list($sRating, $iLastVote) = Phpfox::getService('feed.process')->rate($this->get('id'), $this->get('type'));
		Phpfox::getBlock('feed.rating', array(
				'sRating' => (int) $sRating,
				'iFeedId' => $this->get('id'),
				'bHasRating' => true,
				'iLastVote' => $iLastVote
			)
		);
		$this->html('#js_feed_rating' . $this->get('id'), $this->getContent(false));		
	}

	public function delete()
	{
		if (Phpfox::getService('feed.process')->deleteFeed($this->get('id')))
		{
			$this->html('#js_item_feed_' . $this->get('id'), '<div class="valid_message">' . Phpfox::getPhrase('feed.feed_successfully_deleted') . '</div>', '.fadeOut(5000)');
		}
	}
	
	public function getCommentText()
	{
		$aRow = Phpfox::getService('feed')->getFeed($this->get('feed_id'));	

		(($sPlugin = Phpfox_Plugin::get('feed.component_ajax_getcommenttext')) ? eval($sPlugin) : false);
		
		if (!isset($bHasPluginCall))
		{			
			$this->call("$('#js_quick_edit_id" . $this->get('id') . "').html('<textarea style=\"width:95%; height:80px;\" name=\"quick_edit_input\" cols=\"90\" rows=\"10\" id=\"js_quick_edit" . $this->get('id') . "\">" . str_replace("'", "\'", Phpfox::getLib('parse.output')->ajax($aRow['content'])) . "</textarea>');");		
		}
	}	
	
	public function updateFeedText()
	{
		$sTxt = $this->get('quick_edit_input');
		
		if (Phpfox::getLib('parse.format')->isEmpty($sTxt))
		{
			$this->alert(Phpfox::getPhrase('comment.add_some_text_to_your_comment'));
			
			return false;	
		}

		if (Phpfox::getService('feed.process')->updateCommentText($this->get('feed_id'), $sTxt))
		{
			Phpfox::getLib('parse.output')->setImageParser(array('width' => 200, 'height' => 200));
			if (Phpfox::getParam('core.allow_html'))
			{
				$sTxt = Phpfox::getLib('parse.output')->parse(Phpfox::getLib('parse.input')->prepare($sTxt));
			}
			else 
			{
				$sTxt = Phpfox::getLib('parse.output')->parse($sTxt);
			}
			Phpfox::getLib('parse.output')->setImageParser(array('clear' => true));

			$this->html('#' . $this->get('id'), $sTxt, '.highlightFade()');			
		}
	}
	
	public function like()
	{
		if (Phpfox::getService('feed.process')->like($this->get('feed_id'), $this->get('type_id')))
		{
			list($aLikesCount, $aLikes) = Phpfox::getService('feed')->getLikeForFeed($this->get('feed_id'));
			
			if (count($aLikes))
			{
				$this->template()->assign(array(
						'aFeed' => array(
							'feed_id' => $this->get('feed_id'),
							'like_rows' => $aLikes[$this->get('feed_id')],
							'like_count' => ($aLikesCount[$this->get('feed_id')] - count($aLikes[$this->get('feed_id')]))
						)
					)
				);
				
				$this->template()->getTemplate('feed.block.like');
				
				$this->html('#js_feed_like_holder_' . $this->get('feed_id'), $this->getContent(false))->show('#js_feed_like_holder_' . $this->get('feed_id'));	
			}
			else 
			{
				$this->html('#js_feed_like_holder_' . $this->get('feed_id'), '')->hide('#js_feed_like_holder_' . $this->get('feed_id'));	
			}
		}
	}
	
	public function likeList()
	{
		Phpfox::getBlock('feed.like-list');
	}
	
	public function approveComment()
	{
		Phpfox::isUser(true);
		Phpfox::getUserParam('comment.can_moderate_comments', true);
		Phpfox::getService('feed.process')->approve($this->get('feed_id'));		
	}
}

?>