<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Feed
 * @version 		$Id: display.class.php 2427 2011-03-24 11:01:50Z Miguel_Espinoza $
 */
class Feed_Component_Block_Display extends Phpfox_Component 
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{	
		$iUserId = $this->getParam('user_id');
		Phpfox::getLib('parse.output')->setEmbedParser();
		if (PHPFOX_IS_AJAX && ($iUserId = $this->request()->get('profile_user_id')))
		{
			define('PHPFOX_IS_USER_PROFILE', true);
			
			$aUser = Phpfox::getService('user')->get($iUserId);
			
			$this->template()->assign(array(
					'aUser' => $aUser
				)
			);
		}		
		
		$bIsProfile = (is_numeric($iUserId) && $iUserId > 0);
		
		if ($this->request()->get('feed') && $bIsProfile)
		{
			switch ($this->request()->get('flike'))
			{
				case 'status':
					Phpfox::getService('notification.process')->delete('user_status_notifyLike', $this->request()->get('feed'), Phpfox::getUserId());
					break;			
				case 'photo':
					Phpfox::getService('notification.process')->delete('user_photo_notifyLike', $this->request()->get('feed'), Phpfox::getUserId());
					break;	
				case 'fcomment':
					Phpfox::getService('notification.process')->delete('comment_profile_my_notifyLike', $this->request()->get('feed'), Phpfox::getUserId());
					break;
				default:
					if ($sPlugin = Phpfox_Plugin::get('feed.component_block_display_process_flike'))
					{
						eval($sPlugin);
					}					
					break;
			}
		}
		
		$iFeedPage = $this->request()->get('page', 1);
		
		list($iFeedCount, $aRows) = Phpfox::getService('feed')->get(($bIsProfile > 0 ? $iUserId : null), ($this->request()->get('feed') ? $this->request()->get('feed') : null), $iFeedPage);
		
		(($sPlugin = Phpfox_Plugin::get('feed.component_block_display_process')) ? eval($sPlugin) : false);
		
		if (!count($aRows) && !$bIsProfile && !isset($bSkip))
		{
			return false;
		}
		
		if ($this->request()->get('feed') && !count($aRows) && $bIsProfile)
		{
			$aUser = $this->getParam('aUser');
			
			$this->url()->send($aUser['user_name'], null, Phpfox::getPhrase('feed.the_activity_feed_you_are_looking_for_does_not_exist'));
		}
		
		if (Phpfox::getParam('feed.allow_comments_on_feeds'))
		{
			$aFeeds = array();
			$sFeedIds = '';
			foreach ($aRows as $aRow)
			{
				$sFeedIds .= $aRow['feed_id'] . ',';
				$aFeeds[$aRow['feed_id']] = $aRow;
			}
			$sFeedIds = rtrim($sFeedIds, ',');		
			
			unset($aRows, $aRow);
			
			if (!empty($sFeedIds))
			{				
				// Get the comments for this page
				if (Phpfox::isModule('comment'))
				{					
					if (($iGetCommentId = $this->request()->getInt('feed-comment')))
					{
						list($iCnt, $aComments) = Phpfox::getService('comment')->get('cmt.*', array(
								'AND cmt.comment_id = ' . $iGetCommentId,
								"AND cmt.type_id = 'feed'",								
								(Phpfox::getUserParam('comment.can_moderate_comments') ? 'AND cmt.view_id >= 0' : 'AND cmt.view_id = 0')
							), 'cmt.time_stamp ASC');						
					}
					else 
					{
						list($iCnt, $aComments) = Phpfox::getService('comment')->get('cmt.*', array(
								"AND cmt.type_id = 'feed'",
								'AND cmt.item_id IN(' . $sFeedIds . ')',
								(Phpfox::getUserParam('comment.can_moderate_comments') ? 'AND cmt.view_id >= 0' : 'AND cmt.view_id = 0')
							), 'cmt.time_stamp ASC');
					}

					foreach ($aComments as $aComment)
					{
						$aFeeds[$aComment['item_id']]['comments'][] = $aComment;
					}
				}
				
				foreach ($aFeeds as $iKey => $aFeed)
				{
					if (isset($aFeed['comments']))
					{
						$aFeeds[$iKey]['total_comment'] = count($aFeed['comments']);
						if ($aFeeds[$iKey]['total_comment'] > Phpfox::getParam('feed.comment_feed_cutoff'))
						{			
							// $iRemoved = 0;							
							for ($iCommentCount = 0; $iCommentCount < (count($aFeed['comments']) - Phpfox::getParam('feed.comment_feed_cutoff')); $iCommentCount++)
							{
								// $iRemoved++;
								unset($aFeeds[$iKey]['comments'][$iCommentCount]);
							}
							
							$aFeeds[$iKey]['total_left'] = $aFeeds[$iKey]['total_comment'];
						}
					}
				}				
			}		
		}		
		
		$iUserid = ($bIsProfile > 0 ? $iUserId : null);
		$iTotalFeeds = (int) Phpfox::getComponentSetting(($iUserid === null ? Phpfox::getUserId() : $iUserid), 'feed.feed_display_limit_' . ($iUserid !== null ? 'profile' : 'dashboard'), Phpfox::getParam('feed.feed_display_limit'));

		$this->template()->assign(array(
				'sHeader' => Phpfox::getPhrase('feed.updates'),
				'aFeeds' => (Phpfox::getParam('feed.allow_comments_on_feeds') ? $aFeeds : $aRows),
				'iFeedNextPage' => ($iFeedPage + 1),
				'iFeedCurrentPage' => $iFeedPage,
				'iTotalFeedPages' => (ceil($iFeedCount / $iTotalFeeds)),
				'aFeedVals' => $this->request()->getArray('val'),
				'iViewingFeedEntry' => $this->request()->get('feed'),
				'iViewingFeedEntryWithComment' => $this->request()->get('feed-comment')
			)
		);	
		
		if ($bIsProfile)
		{			
			if (!Phpfox::getService('user.privacy')->hasAccess($iUserId, 'feed.display_on_profile'))
			{
				return false;
			}
			
			if ($iUserId == Phpfox::getUserId())
			{
				$this->template()->assign(array('aEditBar' => array(
							'ajax_call' => 'feed.getEditBar',
							'params' => '&amp;type_id=' . 'profile'
						)
					)
				);			
				
				if (Phpfox::getUserParam('feed.can_remove_feeds_from_profile'))
				{
					$this->template()->assign('sDeleteBlock', 'profile');
				}
			}
			
			if (Phpfox::isModule('rss'))
			{
				$aUser = $this->getParam('aUser');
				if (isset($aUser['user_name']))
				{
					if (Phpfox::getService('user.privacy')->hasAccess($aUser['user_id'], 'rss.can_subscribe_profile'))
					{
						$this->template()->assign('sBlockTitleBar', '<div class="js_edit_header_bar"><a href="' . Phpfox::getLib('url')->makeUrl($aUser['user_name'], 'rss') . '" title="' . Phpfox::getPhrase('rss.subscribe_to_my_feed') . '">' . Phpfox::getLib('image.helper')->display(array('theme' => 'rss/tiny.png', 'class' => 'v_middle')) . '</a></div>');
					}
				}
			}			
		}
		else 
		{
			$this->template()->assign(array('aEditBar' => array(
						'ajax_call' => 'feed.getEditBar',
						'params' => '&amp;type_id=' . 'dashboard'
					)
				)
			);					
			
			if (Phpfox::getUserParam('feed.can_remove_feeds_from_dashboard'))
			{
				$this->template()->assign('sDeleteBlock', 'dashboard');
			}			
		}
		
		return 'block';
	}

	public function clean()
	{
		$this->template()->clean(array(
				'sHeader',
				'aFeeds',
				'sBoxJsId'
			)
		);
		Phpfox::getLib('parse.output')->setEmbedParser(array('clear' => true));
	}	
}

?>