<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * Callbacks
 *
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Feed
 * @version 		$Id: callback.class.php 8 2009-01-05 04:52:08Z Raymond_Benc $
 */
class Feed_Service_Callback extends Phpfox_Service
{
	public function  __construct()
	{
		$this->_sTable = Phpfox::getT('feed');
	}
	
	public function massAdmincpModuleDelete($iModule)
	{
		$this->database()->delete($this->_sTable, "type_id = '" . $this->database()->escape($iModule) . "'");
	}
	
	public function getAjaxCommentVar()
	{
		return 'feed.can_post_comment_on_feed';
	}	
	
	public function getCommentItem($iId)
	{
		$aFeed = $this->database()->select('feed_id AS comment_item_id, user_id AS comment_user_id')
			->from($this->_sTable)
			->where('feed_id = ' . (int) $iId)
			->execute('getSlaveRow');
			
		$aFeed['comment_view_id'] = 0;
			
		return $aFeed;
	}	
	
	public function addComment($aVals, $iUserId = null, $sUserName = null)
	{
		$aFeed = $this->database()->select('f.feed_id, f.type_id, f.user_id, u.user_name')
			->from($this->_sTable, 'f')
			->join(Phpfox::getT('user'), 'u', 'u.user_id = f.user_id')
			->where('f.feed_id = ' . $aVals['item_id'])
			->execute('getSlaveRow');		

		$sLink = Phpfox::getLib('url')->makeUrl($aFeed['user_name'], array('feed' => $aFeed['feed_id']));
		Phpfox::getLib('mail')->to($aFeed['user_id'])
			->subject(array('feed.full_name_left_you_a_comment_on_site_title', array('full_name' => $sUserName, 'site_title' => Phpfox::getParam('core.site_title'))))
			->message(array('feed.full_name_left_you_a_comment_on_site_title_to_view_this_comment', array('full_name' => $sUserName, 'site_title' => Phpfox::getParam('core.site_title'), 'link' => $sLink)))
			->notification('comment.add_new_comment')
			->send();
			
		Phpfox::getService('notification.process')->add('comment_feed', $aFeed['feed_id'], $aFeed['user_id'], array(
				'title' => '',
				'user_id' => Phpfox::getUserId(),
				'image' => Phpfox::getUserBy('user_image'),
				'server_id' => Phpfox::getUserBy('server_id')
			)
		);			
		(($sPlugin = Phpfox_Plugin::get('feed.service_callback_addcomment_1')) ? eval($sPlugin) : false);
		// (Phpfox::isModule('feed') ? Phpfox::getService('feed.process')->add('comment_feed', $aFeed['feed_id'], $aVals['text_parsed'], $iUserId, $aFeed['user_id']) : null);
	}
	
	public function getCommentNewsFeed($aRow)
	{
		return false;
		
		if ($aRow['owner_user_id'] == $aRow['viewer_user_id'])
		{
			$aRow['text'] = Phpfox::getPhrase('feed.a_href_owner_link_owner_full_name_a_commented_on_their_own_a_href_link_feed_a', array(
					'owner_link' => Phpfox::getLib('url')->makeUrl($aRow['owner_user_name']),
					'owner_full_name' => $this->preParse()->clean($aRow['owner_full_name']),
					'link' => Phpfox::getLib('url')->makeUrl($aRow['viewer_user_name'], array('feed' => $aRow['item_id'], '#feed'))			
				)
			);
		}
		else 
		{
			$aRow['text'] = Phpfox::getPhrase('feed.owner_full_name_commented_on_full_names_feed', array(
					'owner_link' => Phpfox::getLib('url')->makeUrl($aRow['owner_user_name']),
					'owner_full_name' => $this->preParse()->clean($aRow['owner_full_name']),
					'viewer_link' => Phpfox::getLib('url')->makeUrl($aRow['viewer_user_name']),
					'viewer_full_name' => $this->preParse()->clean($aRow['viewer_full_name']),
					'link' => Phpfox::getLib('url')->makeUrl($aRow['viewer_user_name'], array('feed' => $aRow['item_id'], '#feed'))
				)
			);
		}
		
		$aRow['text'] .= Phpfox::getService('feed')->quote($aRow['content']);
		(($sPlugin = Phpfox_Plugin::get('feed.service_callback_getcommentnewsfeed_1')) ? eval($sPlugin) : false);
		return $aRow;
	}
	
	public function getItemName($iId, $sName)
	{
		return '<a href="' . Phpfox::getLib('url')->makeUrl('comment.view', array('id' => $iId)) . '">' . Phpfox::getPhrase('feed.on_name_s_feed', array('name' => $sName)) . '</a>';
	}	
	
	public function deleteComment($iId)
	{
		
	}
	
	public function hideBlockDisplay($sTypeId)
	{		
		return array(
			'table' => ($sTypeId == 'profile' ? 'user_design_order' : 'user_dashboard')
		);
	}
	
	public function getBlockDetailsDisplay($sTypeId)
	{
		switch ($sTypeId)
		{
			case 'dashboard':
				if (!Phpfox::getUserParam('feed.can_remove_feeds_from_dashboard'))
				{
					return false;
				}
				break;
			case 'profile':	
				if (!Phpfox::getUserParam('feed.can_remove_feeds_from_profile'))
				{
					return false;
				}
				break;
			default:
				
				break;
		}
		
		return array(
			'title' => Phpfox::getPhrase('feed.updates')
		);
	}
	
	public function onDeleteUser($iUser)
	{
	    $this->database()->delete($this->_sTable, 'user_id = ' . (int)$iUser);
	    $this->database()->delete($this->_sTable, 'item_user_id = ' . (int)$iUser);
	    $this->database()->delete(Phpfox::getT('feed_like'), 'user_id = ' . (int)$iUser);
	    $this->database()->delete(Phpfox::getT('feed_like_cache'), 'user_id = ' . (int)$iUser);
	    $this->database()->delete(Phpfox::getT('feed_rating'), 'user_id = ' . (int)$iUser);
	}

	public function getProfileSettings()
	{
		return array(
			'feed.display_on_profile' => array(
				'phrase' => Phpfox::getPhrase('feed.updates')						
			)
		);
	}

	public function getReportRedirect($iId)
	{
		$aFeed = $this->database()->select('f.*, ' . Phpfox::getUserField())
			->from(Phpfox::getT('feed'), 'f')
			->join(Phpfox::getT('user'), 'u', 'u.user_id = f.user_id')
			->where('f.feed_id = ' . (int) $iId)
			->execute('getRow');
			
		return Phpfox::getLib('url')->makeUrl($aFeed['user_name'], array('feed' => $aFeed['feed_id'], '#feed'));
	}	
	
	public function getReportRedirectComment($iId)
	{
		$aFeed = $this->database()->select('c.comment_id, f.feed_id, ' . Phpfox::getUserField())
			->from(Phpfox::getT('comment'), 'c')
			->join(Phpfox::getT('feed'), 'f', 'f.feed_id = c.item_id')
			->join(Phpfox::getT('user'), 'u', 'u.user_id = f.user_id')
			->where('c.comment_id = ' . (int) $iId)
			->execute('getRow');	
			
		if (!isset($aFeed['comment_id']))
		{
			return false;
		}
		
		return Phpfox::getLib('url')->makeUrl($aFeed['user_name'], array('feed' => $aFeed['feed_id'], 'feed-comment' => $aFeed['comment_id'], '#feed'));
	}
	
	public function getRedirectComment($iId)
	{
		return $this->getReportRedirect($iId);	
	}
	
	public function pendingApproval()
	{
		return array(
			'phrase' => Phpfox::getPhrase('feed.profile_comments'),
			'value' => $this->database()->select('COUNT(*)')->from(Phpfox::getT('feed'))->where('view_id = 1')->execute('getSlaveField'),
			'link' => Phpfox::getLib('url')->makeUrl('admincp.feed', array('view' => 'approval'))
		);
	}
	
	public function getCommentNotificationFeed($aRow)
	{
		(($sPlugin = Phpfox_Plugin::get('feed.service_callback_getcommentnotificationfeed_1')) ? eval($sPlugin) : false);
		if (isset($mPluginReturn))
		{
			return $mPluginReturn;
		}
		return array(
			'message' => Phpfox::getPhrase('user.user_link_full_name_commented_on_your_status', array(			
					'user_link' => Phpfox::getLib('url')->makeUrl($aRow['user_name']),
					'full_name' => $aRow['full_name'],
					'link' => Phpfox::getLib('url')->makeUrl('profile', array('feed' => $aRow['item_id'])) . '#feed'			
				)
			),
			'link' => Phpfox::getLib('url')->makeUrl('profile', array('feed' => $aRow['item_id'])) . '#feed',
			'path' => 'core.url_user',
			'suffix' => '_50'
		);			
	}
}

?>