<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Forum
 * @version 		$Id: index.class.php 2462 2011-03-28 15:43:15Z Miguel_Espinoza $
 */
class Forum_Component_Controller_Index extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('forum.can_view_forum', true);
		
		if ($this->request()->get('req2') == 'topics' || $this->request()->get('req2') == 'posts')
		{
			return Phpfox::getLib('module')->setController('error.404');
		}		
		
		$this->template()->setBreadcrumb(Phpfox::getPhrase('forum.forum'), $this->url()->makeUrl('forum'))
			->setFullSite()
			->setPhrase(array(
					'forum.provide_a_reply',
					'forum.adding_your_reply',
					'forum.are_you_sure',
					'forum.post_successfully_deleted',
					'forum.reply_multi_quoting'
				)
			)			
			->setHeader('cache', array(					
					'forum.css' => 'style_css',
					'forum.js' => 'module_forum'
				)
			);
			
		if ($this->request()->get('req2') && $this->request()->get('req3'))
		{
			return Phpfox::getLib('module')->setController('forum.thread');
		}			
		elseif ($this->request()->get('req2'))
		{
			return Phpfox::getLib('module')->setController('forum.forum');
		}			
		
		$this->template()->setTitle(Phpfox::getPhrase('forum.forum'))
			->assign(array(
				'aForums' => Phpfox::getService('forum')->live()->getForums(),
				'bHasCategory' => Phpfox::getService('forum')->hasCategory(),
				'aStats' => Phpfox::getService('forum')->getStats(),
				'aCallback' => null
			)
		);	
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('forum.component_controller_index_clean')) ? eval($sPlugin) : false);
	}
}

?>