<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Friend
 * @version 		$Id: mini.class.php 1219 2009-10-23 19:16:51Z Raymond_Benc $
 */
class Friend_Component_Block_Mini extends Phpfox_Component 
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		if (!Phpfox::isUser())
		{
			return false;
		}
		
		$iTotal = (int) Phpfox::getComponentSetting(Phpfox::getUserId(), 'friend.friend_display_limit_dashboard', Phpfox::getParam('friend.friend_display_limit'));
		
		list($iCnt, $aRows) = Phpfox::getService('friend')->get('friend.user_id = ' . Phpfox::getUserId(), 'friend.is_top_friend DESC, friend.ordering ASC, friend.time_stamp DESC', 0, $iTotal);

		$this->template()->assign(array(
				'sHeader' => Phpfox::getPhrase('friend.my_friends'),
				'aFriends' => $aRows,
				'aEditBar' => array(
					'ajax_call' => 'friend.getEditBar',
					'params' => '&amp;type_id=dashboard'
				)				
			)
		);
		
		if ($iCnt)
		{
			$this->template()->assign(array(
					'aFooter' =>  array(
						Phpfox::getPhrase('friend.change_my_top_friends') => $this->url()->makeUrl('friend', array('edit' => 'top')),
						Phpfox::getPhrase('friend.view_all') => $this->url()->makeUrl('friend')
					)
				)
			);
		}
		
		if (Phpfox::getUserParam('friend.can_remove_friends_from_dashboard'))
		{
			$this->template()->assign('sDeleteBlock', 'dashboard');
		}

		return 'block';	
	}	
}

?>