<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Friend
 * @version 		$Id: index.class.php 1306 2009-12-09 05:05:18Z Raymond_Benc $
 */
class Friend_Component_Controller_Index extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{		
		Phpfox::isUser(true);
		
		$sView = $this->request()->get('view');
		$iPage = $this->request()->getInt('page');
		$iPageSize = 15;		
		$this->template()->setTitle(Phpfox::getPhrase('friend.my_friends'))->setBreadcrumb(Phpfox::getPhrase('friend.my_friends'), $this->url()->makeUrl('friend'));
		
		$aFilters = array(
			'sort' => array(
				'type' => 'select',
				'options' => array(),
				'default' => 'full_name',
				'alias' => 'u'
			),
			'sort_by' => array(
				'type' => 'select',
				'options' => array(
					'DESC' => Phpfox::getPhrase('core.descending'),
					'ASC' => Phpfox::getPhrase('core.ascending')
				),
				'default' => 'ASC'
			),
			'search' => array(
				'type' => 'input:text',
				'search' => '(u.full_name LIKE \'%[VALUE]%\' OR u.email LIKE \'%[VALUE]%\' OR u.user_name LIKE \'%[VALUE]%\') AND',
				'size' => '15',
				'onclick' => Phpfox::getPhrase('friend.search_friends'),
				'class' => 'header_bar_input'
			)
		);		
		
		$oFilter = Phpfox::getLib('search')->set(array(
				'type' => 'friend',
				'filters' => $aFilters,
				'search' => 'search'
			)
		);		
		
		$bIsOnline = false;
		$iListId = 0;
		$aSend = null;
		switch ($sView)
		{
			case 'top':
				$oFilter->setCondition('friend.user_id = ' . Phpfox::getUserId() . ' AND is_top_friend = 1');				
				$this->template()->setBreadcrumb(Phpfox::getPhrase('friend.top'), null, true);
				$aSend = array('view' => 'top');
				break;
			case 'online':
				$this->template()->setBreadcrumb(Phpfox::getPhrase('friend.online'), null, true);
				$oFilter->setCondition('friend.user_id = ' . Phpfox::getUserId());
				$bIsOnline = true;				
				$aSend = array('view' => 'online');
				break;
			case 'list':
				if (($iListId = $this->request()->getInt('id')) && ($aList = Phpfox::getService('friend.list')->getList($iListId, Phpfox::getUserId())) && isset($aList['list_id']))
				{
					$oFilter->setCondition('list_id = ' . (int) $iListId . ' AND friend.user_id = ' . Phpfox::getUserId());
					$aSend = array('list' => $iListId);
					$this->template()->setTitle($aList['name'])->setBreadcrumb($aList['name'], $this->url()->makeUrl('friend', array('view' => 'list', 'id' => $iListId)));
				}
				else
				{
					return Phpfox_Error::display(Phpfox::getPhrase('friend.invalid_friend_list'));
				}				
				break;
			default:
				$oFilter->setCondition('friend.user_id = ' . Phpfox::getUserId());	
		}		
		
		if (($aVals = $this->request()->getArray('val')) && isset($aVals['id']) && is_array($aVals['id']))
		{
			$oServiceFriendProcess = Phpfox::getService('friend.process');
			foreach ($aVals['id'] as $iId)
			{
				$oServiceFriendProcess->delete($iId);
			}
			
			$this->url()->send('friend', $aSend, Phpfox::getPhrase('friend.successfully_deleted'));
		}		
		
		$aLetters = array(
			'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
		);		
		
		if (($sLetter = $this->request()->get('letter')) && in_array($sLetter, $aLetters))
		{
			$oFilter->setCondition("AND u.full_name LIKE '" . Phpfox::getLib('database')->escape($sLetter) . "%'");	
		}		
		
		list($iCnt, $aRows) = Phpfox::getService('friend')->get($oFilter->getConditions(), $oFilter->getSort(), $oFilter->getPage(), $iPageSize, true, true, $bIsOnline);
		
		$iCnt = $oFilter->getSearchTotal($iCnt);
		
		Phpfox::getLib('pager')->set(array('page' => $iPage, 'size' => $iPageSize, 'count' => $iCnt));
		
		$this->template()->setPhrase(array(
					'friend.create_new_list',
					'friend.edit_lists',
					'friend.view_list',
					'friend.adding_new_list'
				)
			)	
			->setHeader('cache', array(
					'jquery/plugin/jquery.highlightFade.js' => 'static_script',	
					'pager.css' => 'style_css',
					'selector.js' => 'static_script',				
					'jquery/ui.js' => 'static_script',
					'friend.js' => 'module_friend'
				)
			)				
			->assign(array(
				'aFriends' => $aRows,
				'aLetters' => $aLetters,
				'sActualLetter' => $sLetter,
				'aLists' => Phpfox::getService('friend.list')->get(),
				'iList' => $iListId,
				'sView' => $sView	
			)
		);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('friend.component_controller_index_clean')) ? eval($sPlugin) : false);
	}
}

?>