<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Ajax
 * @version 		$Id: ajax.class.php 2599 2011-05-11 07:16:13Z Miguel_Espinoza $
 */
class Im_Component_Ajax_Ajax extends Phpfox_Ajax
{
	public function load()
	{
		Phpfox::getBlock('im.messenger');
		
		$this->hide('#js_im_ajax_button');
		$this->call('Phpfox.im.addBlock(\'js_im_holder\', \'' . $this->getContent() . '\');');		
		$this->call("$.ajaxCall('im.getRooms', 'check_friend=true','GET');");
		$this->call('setCookie(\'im_last_open_window\', \'messenger\');');		
	}
	
	public function hideRoom()
	{		
		$this->call("$.ajaxCall('im.getRooms','','GET');");
		$this->call('deleteCookie(\'im_last_open_window\');');
	}
	
	public function block()
	{
		Phpfox::getService('im.process')->block($this->get('id'));		
		
		$this->call("$.ajaxCall('im.getRooms','','GET');");
		$this->call('deleteCookie(\'im_last_open_window\');');
	}

	public function close()
	{
		Phpfox::getService('im.process')->close($this->get('id'));		
		
		$this->call("$.ajaxCall('im.getRooms','','GET');");
		$this->call('deleteCookie(\'im_last_open_window\');');
	}
	
	public function chat()
	{
		list($iRoomId, $sName, $bIsAlreadyOpen) = Phpfox::getService('im.process')->add($this->get('user_id'));
		
		$aOrder = $this->get('order');
		if (!is_array($aOrder))
		{
			$aOrder = array();
		}
		$aOrder[$iRoomId] = '';
		Phpfox::getService('im.process')->updateOrder($aOrder);		
		
		Phpfox::getBlock('im.chat', array(
				'im_id' => $iRoomId
			)
		);	

		$sRoomContent = $this->getContent();	
				
		if ($bIsAlreadyOpen === true)
		{
			$this->call('Phpfox.im.addBlock(\'js_cache_im_room_' . $iRoomId . '\', \'' . $sRoomContent . '\');')
				->call("if ($('#js_im_content').length > 0) { document.getElementById('js_im_content').scrollTop = document.getElementById('js_im_content').scrollHeight; }")
				->call("$.ajaxCall('im.getMessages', 'im_id=" . $iRoomId . "','GET');");
		}
		else 
		{
			$this->template()->assign(array(
						'aRoom' => Phpfox::getService('im')->getChat($iRoomId),
						'bIsNewRoom' => true
					)
				)
				->getTemplate('im.block.link');
					
			$this->before('#js_im_holder', $this->getContent(false))
				->call('Phpfox.im.addBlock(\'js_cache_im_room_' . $iRoomId . '\', \'' . $sRoomContent . '\');')
				->call("if ($('#js_im_content').length > 0) { document.getElementById('js_im_content').scrollTop = document.getElementById('js_im_content').scrollHeight; }")
				->call("$.ajaxCall('im.getMessages', 'im_id=" . $iRoomId . "','GET');");
		}
		
		$this->call('setCookie(\'im_last_open_window\', \'chat_' . $iRoomId . '\');');
	}	
	
	public function open()
	{			
		$oBlockImChat = Phpfox::getBlock('im.chat', array(
				'im_id' => $this->get('id')
			)
		);
		
		if ($oBlockImChat->isLive() === true)
		{			
			Phpfox::getService('im.process')->isSeen($this->get('id'));
			
			$this->call('Phpfox.im.addBlock(\'js_cache_im_room_' . $this->get('id') . '\', \'' . $this->getContent() . '\');')
				->call("if ($('#js_im_content').length > 0) { document.getElementById('js_im_content').scrollTop = document.getElementById('js_im_content').scrollHeight; }")
				->call("$.ajaxCall('im.getMessages', 'im_id=" . $this->get('id') . "','GET');")
				->call('$(\'#js_cache_im_room_' . $this->get('id') . '\').find(\'.im_ajax_button:first\').hide();')
				->call('$(\'#js_cache_im_room_' . $this->get('id') . '\').find(\'.im_delete_button:first\').show();');
				
			$this->call('setCookie(\'im_last_open_window\', \'chat_' . $this->get('id') . '\');');
			// $this->call('if (isset(oCachedImInterval) && typeof(oCachedImInterval[' . $this->get('id') . ']) != \'undefined\') { clearInterval(oCachedImInterval[' . $this->get('id') . ']); }');
		}
		else 
		{
			$this->call('deleteCookie(\'im_last_open_window\');');
		}
	}
	
	public function getRooms()
	{		
		static $sCache = null;
		static $sCacheOnline = null;
		
		$sUserFieldKeys = array();
		$aParts = explode(',', Phpfox::getUserField());
		foreach ($aParts as $sPart)
		{
			$sPart = preg_replace('/u\.(.*?)/i', '\\1', trim($sPart));
			$sUserFieldKeys[$sPart] = $sPart;
		}
		
		for ($i = 1; $i <= 15; $i++)
		{		
			$aRooms = Phpfox::getService('im')->getRooms();			

			if ($this->get('check_friend'))
			{
				Phpfox::getBlock('im.list');
				
				$sHash = $this->getContent(false);
				
				if ($sCacheOnline !== null && $sCacheOnline !== md5($sHash))
				{
					$this->html('#js_im_friend_list', $sHash);
					
					break;
				}

				$sCacheOnline = md5($sHash);			
			}
			else 
			{
				$sHash = Phpfox::getService('im')->getOnlineFriendsCount(Phpfox::getUserId());

				if ($sCacheOnline !== null && $sCacheOnline !== md5($sHash))
				{
					$this->html('#js_im_total_friend_count', $sHash);
					
					break;
				}				
				
				$sCacheOnline = md5($sHash);	
			}			
				
			$aRoomsCache = array();
			foreach ($aRooms as $iKey => $aRoom)
			{
				foreach ($aRoom as $sRoomKey => $sRoomValue)
				{
					if (!isset($sUserFieldKeys[$sRoomKey]))
					{
						$aRoomsCache[$iKey][$sRoomKey] = $sRoomValue;
					}
				}				
			}						
			
			if ($sCache !== null && $sCache !== md5(serialize($aRoomsCache)))
			{
				foreach ($aRooms as $iKey => $aRoom)
				{
					$this->template()->assign(array(
							'aRoom' => $aRoom
						)
					)
					->getTemplate('im.block.link');					
					
					$sContent = $this->getContent();		
					
					$this->call('if ($(\'#js_cache_im_room_' . $aRoom['parent_id'] . '\').length <= 0) { $(\'#js_im_holder\').parent().find(\'.js_cache_im_list:first\').before(\'' . $sContent . '\'); } else { $(\'#js_cache_im_room_' . $aRoom['parent_id'] . '\').before(\'<li style="display:none;" id="js_cache_inline_menu"></li>\'); $(\'#js_cache_im_room_' . $aRoom['parent_id'] . '\').remove(); $(\'#js_cache_inline_menu\').after(\'' . $sContent . '\'); $(\'#js_cache_inline_menu\').remove(); }');
					if ($aRoom['is_new'])
					{
						$this->call('$(\'#js_cache_im_room_' . $aRoom['parent_id'] . '\').find(\'a\').addClass(\'new\');');
						// $this->call('if (isset(oCachedImInterval) && typeof(oCachedImInterval[' . $aRoom['parent_id'] . ']) != \'undefined\') { clearInterval(oCachedImInterval[' . $aRoom['parent_id'] . ']); }');
						// $this->call('oCachedImInterval[' . $aRoom['parent_id'] . '] = setInterval(\'Phpfox.im.alertNew("' . $aRoom['parent_id'] . '");\', 500);');
						// if (Phpfox::getService('im')->hasAlert(Phpfox::getUserId(), $aRoom['parent_id']))
						{
							if (!Phpfox::getUserBy('im_beep'))
							{
								$this->call('Phpfox.player.play("js_im_player", "' . Phpfox::getParam('core.url_static') . 'mp3/incoming.mp3");');
							}
						}						
					}
				}
				
				break;	
			}			
			
			$sCache = md5(serialize($aRoomsCache));					
			
			sleep(2);	
		}		
		
		if ($this->get('check_friend'))
		{
			$this->call("$.ajaxCall('im.getRooms', 'check_friend=true','GET');");
		}
		else 
		{
			$this->call("$.ajaxCall('im.getRooms','','GET');");
		}
		
		$this->html('#js_global_footer_time_stamp', '<a href="' . Phpfox::getLib('url')->makeUrl('user.setting') . '" title="' . Phpfox::getTime(Phpfox::getParam('core.footer_bar_tool_tip_time_stamp'), PHPFOX_TIME). '">' . Phpfox::getTime(Phpfox::getParam('core.footer_watch_time_stamp'), PHPFOX_TIME) . '</a>');
	}
	
	public function add()
	{
		$aVals = $this->get('val');
		
		if (Phpfox::getService('im.process')->addText($aVals))
		{		
			$this->template()->assign(array(
						'aMessage' => array(
							'time_stamp' => PHPFOX_TIME,
							'full_name' => Phpfox::getUserBy('full_name'),
							'user_name' => Phpfox::getUserBy('user_name'),
							'text' => $aVals['text']
						)
					)
				)
				->getTemplate('im.block.text');
			
			$this->val('#js_im_text', '')
				->append('#js_latest_message', $this->getContent(false))
				->call('if ($(\'#js_im_content\').length > 0) { document.getElementById(\'js_im_content\').scrollTop = document.getElementById(\'js_im_content\').scrollHeight; }')
				->call("$.ajaxCall('im.getMessages', 'im_id=" . $aVals['parent_id'] . "','GET');");
		}
	}
	
	public function getMessages()
	{
		$iRoomId = $this->get('im_id');
		
		static $sCache = null;
		
		$sUserFieldKeys = array();
		$aParts = explode(',', Phpfox::getUserField());
		foreach ($aParts as $sPart)
		{
			$sPart = preg_replace('/u\.(.*?)/i', '\\1', trim($sPart));
			$sUserFieldKeys[$sPart] = $sPart;
		}		
		
		for ($i = 1; $i <= 15; $i++)
		{
			Phpfox::getBlock('im.message', array(
					'im_id' => $iRoomId,
					'im_static' => false
				)
			);			
			
			$sContent = $this->getContent(false);			
			$aRooms = Phpfox::getService('im')->getRooms();
			
			$aRoomsCache = array();
			foreach ($aRooms as $iKey => $aRoom)
			{
				foreach ($aRoom as $sRoomKey => $sRoomValue)
				{
					if (!isset($sUserFieldKeys[$sRoomKey]))
					{
						$aRoomsCache[$iKey][$sRoomKey] = $sRoomValue;
					}
				}				
			}			
			
			$sContent .= '<div style="display:none;">' .  md5(serialize($aRoomsCache)) . '</div>';	
			$sCall = '';					
			foreach ($aRooms as $aRoom)
			{
				$this->template()->assign(array(
						'aRoom' => $aRoom
					)
				)
				->getTemplate('im.block.link');					
					
				$sRoomContent = $this->getContent();		
				
				$sCall .= 'if ($(\'#js_cache_im_room_' . $aRoom['parent_id'] . '\').length <= 0) { $(\'#js_im_holder\').parent().find(\'.js_cache_im_list:first\').before(\'' . $sRoomContent . '\'); } else { $(\'#js_cache_im_room_' . $aRoom['parent_id'] . '\').before(\'<li style="display:none;" id="js_cache_inline_menu"></li>\'); $(\'#js_cache_im_room_' . $aRoom['parent_id'] . '\').remove(); $(\'#js_cache_inline_menu\').after(\'' . $sRoomContent . '\'); $(\'#js_cache_inline_menu\').remove(); }';
				
				if ($iRoomId == $aRoom['parent_id'])
				{
					$sCall .= '$(\'#js_cache_im_room_' . $aRoom['parent_id'] . '\').find(\'a\').addClass(\'focus\');';
					
					Phpfox::getService('im.process')->removeAlert(Phpfox::getUserId(), $aRoom['parent_id']);
				}
				else 
				{					
					if ($aRoom['is_new'])
					{
						$sCall .= '$(\'#js_cache_im_room_' . $aRoom['parent_id'] . '\').find(\'a\').addClass(\'new\');';
						// $sCall .= 'if (isset(oCachedImInterval) && typeof(oCachedImInterval[' . $aRoom['parent_id'] . ']) != \'undefined\') { clearInterval(oCachedImInterval[' . $aRoom['parent_id'] . ']); }';						
						// $sCall .= 'oCachedImInterval[' . $aRoom['parent_id'] . '] = setInterval(\'Phpfox.im.alertNew("' . $aRoom['parent_id'] . '");\', 500);';
						// if (Phpfox::getService('im')->hasAlert(Phpfox::getUserId(), $aRoom['parent_id']))
						{
							if (!Phpfox::getUserBy('im_beep'))
							{
								$sCall .= 'Phpfox.player.play("js_im_player", "' . Phpfox::getParam('core.url_static') . 'mp3/incoming.mp3");';
							}
						}
					}
				}
			}			
			
			if ($sCache !== null && $sCache !== md5($sContent))
			{
				$this->call($sCall);
				
				break;	
			}
			
			$sCache = md5($sContent);
			
			sleep(2);
		}
		
		$this->call("if ($('#js_im_content').length > 0) { var bScrollInBottom = document.getElementById('js_im_content').scrollTop == document.getElementById('js_im_content').scrollHeight-parseInt(document.getElementById('js_im_content').style.height); }")
			->html('#js_im_messages', $sContent)
			->call("$.ajaxCall('im.getMessages', 'im_id=" . $iRoomId . "','GET');")
			->call("if(isset(bScrollInBottom) && bScrollInBottom && ($('#js_im_content').length > 0)) document.getElementById('js_im_content').scrollTop = document.getElementById('js_im_content').scrollHeight;");
			
		$this->html('#js_global_footer_time_stamp', '<a href="' . Phpfox::getLib('url')->makeUrl('user.setting') . '" title="' . Phpfox::getTime(Phpfox::getParam('core.footer_bar_tool_tip_time_stamp'), PHPFOX_TIME). '">' . Phpfox::getTime(Phpfox::getParam('core.footer_watch_time_stamp'), PHPFOX_TIME) . '</a>');
	}
	
	public function goOffline()
	{
		Phpfox::getService('im.process')->goOffline();
	}
	
	public function changeStatus()
	{
		Phpfox::getService('im.process')->changeStatus($this->get('status'));
	}
	
	public function playSound()
	{
		Phpfox::getService('im.process')->playSound($this->get('im_beep'));	
	}
	
	public function searchFriends()
	{
		Phpfox::getBlock('im.list', array(
				'im_display_ul' => false
			)
		);
		
		$this->html('#js_im_user_list', $this->getContent(false));
	}
}

?>
