<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: list.class.php 875 2009-08-20 08:15:20Z Raymond_Benc $
 */
class Im_Component_Block_List extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		$iPage = $this->request()->getInt('page', 0);
		$iPageSize = Phpfox::getParam('im.total_friends_to_display_in_im');		
		$aCond = array();
		
		$aCond[] = 'AND f.user_id = ' . Phpfox::getUserId();
		if (($sFind = $this->request()->get('find')))
		{
			$aCond[] = 'AND u.full_name LIKE \'%' . Phpfox::getLib('database')->escape($sFind) . '%\'';
		}
		
		list($iCnt, $aFriends) = Phpfox::getService('im')->getOnlineFriends(Phpfox::getUserId(), $aCond, $iPage, $iPageSize);

		Phpfox::getLib('ajax')->html('#js_im_total_friend_count', $iCnt);
		
		Phpfox::getLib('pager')->set(array('ajax' => 'im.searchFriends', 'page' => $iPage, 'size' => $iPageSize, 'count' => $iCnt));
		
		$this->template()->assign(array(
				'aFriends' => $aFriends,
				'bDisplayUl' => $this->getParam('im_display_ul', true),
				'bIsMiniPager' => true
			)
		);			
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('im.component_block_list_clean')) ? eval($sPlugin) : false);
	}
}

?>