<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Mail
 * @version 		$Id: ajax.class.php 1967 2010-10-27 19:30:25Z Raymond_Benc $
 */
class Mail_Component_Ajax_Ajax extends Phpfox_Ajax
{	
	public function delete()
	{
		Phpfox::isUser(true);
		
		$sType = $this->get('type');		
				
		if (($sType == 'trash' ? Phpfox::getService('mail.process')->deleteTrash($this->get('id')) : Phpfox::getService('mail.process')->delete($this->get('id'), ($sType == 'sentbox' ? true : false))))
		{
			$this->call("$('#js_message_" . $this->get('id') . "').hide('slow');");
			$this->call("$('#js_mail_messages').message('" . Phpfox::getPhrase('mail.message_successfully_deleted', array('phpfox_squote' => true)) . "', 'valid').fadeOut(5000);");
		}
	}
	
	public function move()
	{
		Phpfox::isUser(true);
		
		$aVals = $this->get('val');
		if (Phpfox::getService('mail.folder.process')->move($this->get('folder'), $aVals['id']))
		{
			foreach ($aVals['id'] as $iId)
			{
				$this->call("$('#js_message_{$iId}').hide('slow');");
			}
		}
		
		$this->call("$('#js_mail_messages').message('" . Phpfox::getPhrase('mail.messages_successfully_moved', array('phpfox_squote' => true)) . "', 'valid').fadeOut(5000);");
	}	
	
	public function addFolder()
	{
		Phpfox::isUser(true);
		Phpfox::getUserParam('mail.can_add_folders', true);
		
		$sFolder = $this->get('add_folder');

		if (Phpfox::getService('mail.folder')->reachedLimit()) // Did they reach their limit?
		{
			$this->call("$('#js_temp_menu').remove(); alert('" . Phpfox::getPhrase('mail.you_have_reached_your_limit') . "');");			
		}		
		elseif (Phpfox::getService('mail.folder')->isFolder($sFolder)) // Is there already a folder like this one?
		{
			$this->call("$('#js_temp_menu').remove(); alert('" . Phpfox::getPhrase('mail.folder_already_use', array('phpfox_squote' => true)) . "');");
		}
		elseif (Phpfox::getLib('parse.format')->isEmpty($sFolder))
		{
			$this->call("$('#js_temp_menu').remove(); alert('" . Phpfox::getPhrase('mail.provide_a_name_for_your_folder', array('phpfox_squote' => true)) . "');");
		}
		else // Everything is okay, lets add the folder
		{			
			if ($iId = Phpfox::getService('mail.folder.process')->add($sFolder))
			{
				$sNew = Phpfox::getLib('parse.output')->clean(Phpfox::getLib('parse.input')->clean($sFolder, 255));
				$this->call("$('#js_temp_menu').remove();");
				$this->call("$('#js_add_folder_main').val('" . Phpfox::getPhrase('mail.add_new_folder', array('phpfox_squote' => true)) . "');");
				$this->call("$('#js_add_folder_header').val('" . Phpfox::getPhrase('mail.add_new_folder', array('phpfox_squote' => true)) . "');");
				$this->call("$('#js_last_folder').append('<li id=\"sJsNewlyAddedFolder\"><a href=\"" . Phpfox::getLib('url')->makeUrl('mail/box', array('id' => $iId)) . "\"><img src=\"" . Phpfox::getParam('core.url_module') . "mail/static/image/saved.gif\" alt=\"\" /> " . $sNew . "</a></li>'); $('#sJsNewlyAddedFolder').highlightFade();");
				$this->call("$('#js_last_folder_option').append('<option value=\"{$iId}\" selected=\"selected\">" . $sNew . "</option>');");
				// $this->call('$("#js_form").ajaxCall("mail.move", "folder='.$iId.'");');
			}
		}
	}
	
	public function editFolders()
	{
		Phpfox::getBlock('mail.box.edit');
		$this->call("$('#js_mail_box_folders').hide();");			
		$this->html('#js_edit_folders', $this->getContent(false), '.show()');	
		$this->call('Phpfox.loadInit();');
	}
	
	public function updateFolder()
	{
	    $aVal = $this->get('val');	    
	    $sFolder = reset($aVal['name']);
	    if (Phpfox::getLib('parse.format')->isEmpty($sFolder))
	    {
		
		
	    	$this->call("$('#js_process_form_image').hide(); alert('" . Phpfox::getPhrase('mail.provide_a_name_for_your_folder', array('phpfox_squote' => true)) . "'); $('#js_edit_input_folder_1 :input').focus();");
	    }
	    elseif (Phpfox::getService('mail.folder.process')->update($aVal))
		{
			Phpfox::getBlock('mail.folder', array(
				'bIsAjax' => true
			));			
			
			$this->call("$('#js_mail_box_folders').parent().html('" . $this->getContent() . "').show(); $('#js_block_bottom_link_1').html('" . Phpfox::getPhrase('mail.edit_folders', array('phpfox_squote' => true)) . "'); Phpfox.loadInit();");
		}
	}
	
	public function deleteFolder()
	{
		if (Phpfox::getService('mail.folder.process')->delete($this->get('id')))
		{
			$this->call("$('#js_edit_input_folder_" . $this->get('id') . "').hide();");
			$this->call("$('.sJsFolder_" . $this->get('id') . "').hide(); Phpfox.loadInit();");
		}
	}
	
	public function compose()
	{
		Phpfox::getComponent('mail.compose', null, 'controller');
	}

	/**
	 * Allows reading a message given its id
	 * @return void
	 */
	public function readMessage()
	{
		// security checks
		Phpfox::getUserParam('admincp.has_admin_access', true);
		Phpfox::getUserParam('mail.can_read_private_messages', true);
		
		$iId = $this->get('id');
		
		if (!is_numeric($iId))
		{
			return false;
		}
		Phpfox::getBlock('mail.message');
	}

	/**
	 * delicate function, deletes a message from the mail and mail_text table
	 */
	public function deleteMessage()
	{
		Phpfox::getUserParam('admincp.has_admin_access', true);
		Phpfox::getUserParam('mail.can_read_private_messages', true);

		$iId = $this->get('id');
		
		if (!is_numeric($iId))
		{
			return false;
		}
		Phpfox::getService('mail.process')->adminDelete($iId);
		$this->call('$("#js_mail_'.$iId.'").remove();');

	}
}

?>