<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: info.class.php 1558 2010-05-04 12:51:22Z Raymond_Benc $
 */
class Marketplace_Component_Block_Info extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		$aListing = $this->getParam('aListing');		
		
		$sExchangeRate = '';
		if ($aListing['currency_id'] != Phpfox::getService('core.currency')->getDefault())
		{
			if (($sAmount = Phpfox::getService('core.currency')->getXrate($aListing['currency_id'], $aListing['price'])))
			{
				$sExchangeRate .= ' (' . Phpfox::getService('core.currency')->getCurrency($sAmount) . ')';
			}
		}
		
		$this->template()->assign(array(
				'sHeader' => Phpfox::getPhrase('marketplace.price') . ': ' . ($aListing['price'] == '0.00' ? Phpfox::getPhrase('marketplace.free') : Phpfox::getService('core.currency')->getCurrency(number_format($aListing['price'], 2), $aListing['currency_id'])) . $sExchangeRate . ($aListing['view_id'] == '2' ? ' (' . Phpfox::getPhrase('marketplace.sold') . ')' : '')
			)
		);
		
		return 'block';
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('marketplace.component_block_info_clean')) ? eval($sPlugin) : false);
	}
}

?>