<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: add.class.php 2318 2011-02-28 13:27:55Z Miguel_Espinoza $
 */
class Marketplace_Component_Controller_Add extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::isUser(true);
		Phpfox::getUserParam('marketplace.can_create_listing', true);
		
		Phpfox_Error::setDisplay(false);
		$bIsEdit = false;
		$sStep = $this->request()->get('step', false);
		$sAction = $this->request()->get('req3', false);		
		$sMarketplaceMessage = '';
		
		if ($iEditId = $this->request()->get('id'))
		{
			if (($aListing = Phpfox::getService('marketplace')->getForEdit($iEditId)))
			{
				$bIsEdit = true;
				$this->setParam('aListing', $aListing);
				$this->setParam(array(
						'country_child_value' => $aListing['country_iso'],
						'country_child_id' => $aListing['country_child_id']
					)
				);				
				$this->template()->setHeader(array(
							'<script type="text/javascript">$(function(){ var aCategories = explode(\',\', \'' . $aListing['categories'] . '\'); for (i in aCategories) { $(\'#js_mp_holder_\' + aCategories[i]).show(); $(\'#js_mp_category_item_\' + aCategories[i]).attr(\'selected\', true); } });</script>'
						)
					)
					->assign(array(
						'aForms' => $aListing
					)
				);
			}
		}
		else 
		{
			$this->template()->assign('aForms', array('price' => '0.00'));
		}
		
		$aValidation = array(
			'title' => Phpfox::getPhrase('marketplace.provide_a_name_for_this_listing'),
			'country_iso' => Phpfox::getPhrase('marketplace.provide_a_location_for_this_listing'),
			'price' => array(
				'def' => 'money'
			)
		);
		
		$oValidator = Phpfox::getLib('validator')->set(array(
				'sFormName' => 'js_marketplace_form',
				'aParams' => $aValidation
			)
		);
		
		if ($aVals = $this->request()->get('val'))
		{
			if ($oValidator->isValid($aVals))
			{				
				if ($bIsEdit)
				{
					if (Phpfox::getService('marketplace.process')->update($aListing['listing_id'], $aVals))
					{
						(($sPlugin = Phpfox_Plugin::get('marketplace.component_controller_add_process_update_complete')) ? eval($sPlugin) : false);
						
						if (isset($aVals['step']))
						{
							if ($aVals['step'] == 'invite')
							{
								$this->url()->send('marketplace.view', $aListing['title_url'], Phpfox::getPhrase('marketplace.listing_successfully_updated'));
							}
							else 
							{
								$this->url()->send('marketplace.add', array('id' => $aListing['listing_id'], 'step' => 'invite'));
							}
						}
						else 
						{
							switch ($aVals['action'])
							{
								case 'customize':
									Phpfox::getLib('session')->set('mp_add_message', Phpfox::getPhrase('marketplace.successfully_uploaded_images_for_this_listing'));
							
									$this->url()->send('marketplace.add.customize', array('id' => $aListing['listing_id']));	
									break;
								case 'invite':
									Phpfox::getLib('session')->set('mp_add_message', Phpfox::getPhrase('marketplace.successfully_invited_users_for_this_listing'));
							
									$this->url()->send('marketplace.add.invite', array('id' => $aListing['listing_id']));	
									break;
								default:
									Phpfox::getLib('session')->set('mp_add_message', Phpfox::getPhrase('marketplace.successfully_updated_this_listing'));
							
									$this->url()->send('marketplace.add', array('id' => $aListing['listing_id']));
									break;
							}							
						}						
					}
				}
				else 
				{
					if (($iFlood = Phpfox::getUserParam('marketplace.flood_control_marketplace')) !== 0)
					{
						$aFlood = array(
							'action' => 'last_post', // The SPAM action
							'params' => array(
								'field' => 'time_stamp', // The time stamp field
								'table' => Phpfox::getT('marketplace'), // Database table we plan to check
								'condition' => 'user_id = ' . Phpfox::getUserId(), // Database WHERE query
								'time_stamp' => $iFlood * 60 // Seconds);	
							)
						);
							 			
						// actually check if flooding
						if (Phpfox::getLib('spam')->check($aFlood))
						{
							Phpfox_Error::set(Phpfox::getPhrase('marketplace.you_are_creating_a_listing_a_little_too_soon') . ' ' . Phpfox::getLib('spam')->getWaitTime());	
						}
					}					
					
					if (Phpfox_Error::isPassed())
					{				
						if ($iId = Phpfox::getService('marketplace.process')->add($aVals))
						{
							Phpfox::getLib('session')->set('mp_add_message', Phpfox::getPhrase('marketplace.listing_successfully_added'));
							
							$this->url()->send('marketplace.add', array('id' => $iId, 'step' => 'customize'));
						}
					}
				}
			}
			
			$sStep = (isset($aVals['step']) ? $aVals['step'] : '');
			$sAction = (isset($aVals['action']) ? $aVals['action'] : '');
		}
		
		if (($sMarketplaceMessage = Phpfox::getLib('session')->get('mp_add_message')))
		{
			Phpfox::getLib('session')->remove('mp_add_message');
		}		
		
		$aCurrencies = Phpfox::getService('core.currency')->get();
		foreach ($aCurrencies as $iKey => $aCurrency)
		{
			$aCurrencies[$iKey]['is_default'] = '0';
			
			if (Phpfox::getService('core.currency')->getDefault() == $iKey)	
			{
				$aCurrencies[$iKey]['is_default'] = '1';	
			}
		}
		
		$this->template()->setTitle(($bIsEdit ? Phpfox::getPhrase('marketplace.edit_a_marketplace_listing') : Phpfox::getPhrase('marketplace.create_a_marketplace_listing')))
			->setBreadcrumb(Phpfox::getPhrase('marketplace.marketplace'), $this->url()->makeUrl('marketplace'))
			->setBreadcrumb(($bIsEdit ? Phpfox::getPhrase('marketplace.edit_a_listing') : Phpfox::getPhrase('marketplace.create_a_listing')), null, true)
			->setEditor()
			->setPhrase(array(
					'core.select_a_file_to_upload'
				)
			)				
			->setHeader(array(
					'<script type="text/javascript">$(function(){$(\'#js_mp_block_' . ($sAction ? $sAction : ($sStep ? $sStep : 'detail')) . '\').show();});</script>',
					'add.js' => 'module_marketplace',
					'progress.js' => 'static_script',
					'<script type="text/javascript">var oProgressBar = {holder: \'#js_marketplace_form_holder\', progress_id: \'#js_progress_bar\', uploader: \'#js_progress_uploader\', add_more: true, max_upload: 6, total: 1, frame_id: \'js_upload_frame\', file_id: \'image[]\'};</script>',
					'pager.css' => 'style_css',
					'country.js' => 'module_core'
				)
			)
			->assign(array(
					'sMyEmail' => Phpfox::getUserBy('email'),
					'sStep' => $sStep,
					'aMarketplaceErrors' => Phpfox_Error::get(),
					'sAction' => ($sAction ? $sAction : 'detail'),			
					'sMarketplaceMessage' => $sMarketplaceMessage,
					'sCreateJs' => $oValidator->createJS(),
					'sGetJsForm' => $oValidator->getJsForm(false),
					'bIsEdit' => $bIsEdit,
					'sCategories' => Phpfox::getService('marketplace.category')->get(),
					'iMaxFileSize' => (Phpfox::getUserParam('marketplace.max_upload_size_listing') === 0 ? null : ((Phpfox::getUserParam('marketplace.max_upload_size_listing') / 1024) * 1048576)),
					'aCurrencies' => $aCurrencies,
					'sUserSettingLink' => $this->url()->makeUrl('user.setting')
				)
			);
			
		(($sPlugin = Phpfox_Plugin::get('marketplace.component_controller_add_process')) ? eval($sPlugin) : false);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('marketplace.component_controller_add_clean')) ? eval($sPlugin) : false);
	}
}

?>