<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: view.class.php 1798 2010-09-08 09:28:49Z Miguel_Espinoza $
 */
class Marketplace_Component_Controller_View extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('marketplace.can_access_marketplace', true);
		
		if (!($sListingId = $this->request()->get('req3')))
		{
			$this->url()->send('marketplace');
		}
		
		if (!($aListing = Phpfox::getService('marketplace')->getListing($sListingId)))
		{
			return Phpfox_Error::display(Phpfox::getPhrase('marketplace.the_listing_you_are_looking_for_either_does_not_exist_or_has_been_removed'));	
		}			
		
		$this->setParam('aListing', $aListing);	
		
		if (Phpfox::isUser() && $aListing['invite_id'] && !$aListing['visited_id'] && $aListing['user_id'] != Phpfox::getUserId())
		{
			Phpfox::getService('marketplace.process')->setVisit($aListing['listing_id'], Phpfox::getUserId());
		}		
		
		if (Phpfox::isModule('notification') && $aListing['user_id'] == Phpfox::getUserId())
		{
			Phpfox::getService('notification.process')->delete('marketplace_approved', $aListing['listing_id'], Phpfox::getUserId());
			Phpfox::getService('notification.process')->delete('marketplace_notifyLike', $aListing['listing_id'], Phpfox::getUserId());
		}		

		$this->setParam('aRatingCallback', array(
				'type' => 'user',
				'default_rating' => $aListing['total_score'],
				'item_id' => $aListing['user_id'],
				'stars' => range(1, 10)
			)
		);			
		
		$this->template()->setTitle($aListing['title'] . ($aListing['view_id'] == '2' ? ' (' . Phpfox::getPhrase('marketplace.sold') . ')' : ''))
			->setBreadcrumb(Phpfox::getPhrase('marketplace.marketplace'), $this->url()->makeUrl('marketplace'))
			->setMeta('description', $aListing['description'])
			->setMeta('keywords', $this->template()->getKeywords($aListing['title'] . $aListing['short_description']))			
			->setBreadcrumb($aListing['breadcrumb'])
			->setBreadcrumb($aListing['title'] . ($aListing['view_id'] == '2' ? ' (' . Phpfox::getPhrase('marketplace.sold') . ')' : ''), null, true)
			->setHeader('cache', array(
					'jquery/plugin/jquery.highlightFade.js' => 'static_script',	
					'jquery/plugin/jquery.scrollTo.js' => 'static_script',
					'quick_edit.js' => 'static_script',
					'comment.css' => 'style_css',
					'pager.css' => 'style_css',
					'switch_legend.js' => 'static_script',
					'switch_menu.js' => 'static_script',
					'view.js' => 'module_marketplace',
					'view.css' => 'module_marketplace'
				)
			)		
			->setPhrase(array(
					'rate.thanks_for_rating'			
				)
			)			
			->setHeader(array(
					'rate.js' => 'module_rate',
					'<script type="text/javascript">$(function() { Phpfox.rate.init({display: false}); });</script>',		
				)		
			)
			->setEditor(array(
					'load' => 'simple'
				)
			)
			->assign(array(
					'aListing' => $aListing
				)
			);
			
		(($sPlugin = Phpfox_Plugin::get('marketplace.component_controller_view_process_end')) ? eval($sPlugin) : false);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('marketplace.component_controller_view_clean')) ? eval($sPlugin) : false);
	}
}

?>