<?php 
/**
 * [PHPFOX_HEADER]
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox
 * @version 		$Id: index.html.php 1559 2010-05-04 13:06:56Z Miguel_Espinoza $
 */
 
defined('PHPFOX') or exit('NO DICE!'); 

?>
{if !count($aListings) && count($aForms)}
<div class="extra_info">
	{phrase var='marketplace.unable_to_find_what_you_are_looking_for'}
</div>
{elseif !count($aListings) && !count($aForms)}
<div class="extra_info">
{if $sListingView == 'featured'}
	{phrase var='marketplace.no_listings_have_been_featured'}
{elseif $sListingView == 'purchased'}
	{phrase var='marketplace.you_haven_t_made_any_purchases_yet'}
{elseif $sListingView == 'sold'}
	{phrase var='marketplace.you_haven_t_sold_any_items_yet'}
{elseif $sListingView == 'invitation'}
	{phrase var='marketplace.you_have_not_received_any_invites'}
	{elseif $sListingView == 'pending'}
	{phrase var='marketplace.no_listings_pending_approval'}
{elseif $sListingView == 'my'}
	{phrase var='marketplace.you_have_not_added_any_listings_yet'}
	<ul class="action">
		<li><a href="{url link='marketplace.add'}">{phrase var='marketplace.add_a_listing'}</a></li>
	</ul>	
{else}
	{phrase var='marketplace.no_listings_have_been_added'}
	<ul class="action">
		<li><a href="{url link='marketplace.add'}">{phrase var='marketplace.be_the_first_to_add_a_listing'}</a></li>
	</ul>	
{/if}
</div>
{else}

{if $iListingApproveCnt}
<div class="message">
{if $iListingApproveCnt == 1}
	{phrase var='marketplace.there_is_one_listing_that_is_pending_approval'}
{else}
	{phrase var='marketplace.there_are_total_listings_that_are_pending_approval' total=$iListingApproveCnt}
{/if}
	<a href="{url link='marketplace' view='pending'}">{phrase var='marketplace.click_here_to_approve_listings'}</a>
</div>
{/if}

{foreach from=$aListings name=listings item=aListing}
<div id="js_mp_item_holder_{$aListing.listing_id}" class="js_listing_parent {if $aListing.is_sponsor}row_sponsored {/if}{if $aListing.is_featured}row_featured {/if}{if $aListing.view_id == 1}row_moderate {/if}{if is_int($phpfox.iteration.listings)}row1{else}row2{/if}{if $phpfox.iteration.listings == 1} row_first{/if}">
	<div style="width:130px; position:absolute; text-align:center;">
		<a href="{url link='marketplace.view.'$aListing.title_url''}">{img server_id=$aListing.server_id title=$aListing.title path='marketplace.url_image' file=$aListing.image_path suffix='_120' max_width='120' max_height='120'}</a>
	</div>
	<div style="margin-left:135px; height:120px;">
		<div class="go_right" style="font-size:10pt; font-weight:bold;">		    
		    <span class="js_featured_listing row_featured_link"{if !$aListing.is_featured} style="display:none;"{/if}>
			    {phrase var='marketplace.featured'}
		    </span>
		    <span class="row_pending_link"{if $aListing.view_id != 1} style="display:none;"{/if}>
			    {phrase var='marketplace.pending'}
		    </span>
		    <div class="js_featured_listing row_featured_link" style="padding-bottom:20px;{if !$aListing.is_featured} display:none;{/if}"></div>
		    <div class="row_pending_link row_featured_link" style="padding-bottom:20px;{if $aListing.view_id != 1} display:none;{/if}"></div>
		    {if $aListing.price == '0.00'}
			    {phrase var='marketplace.free'}
		    {else}
			    {$aListing.currency_id|currency_symbol}{$aListing.price|number_format:2}
		    {/if}
		</div>
		<a href="{url link='marketplace.view.'$aListing.title_url''}">{$aListing.title|clean}</a>{if $aListing.view_id == '2'} <span style="font-weight:bold;">({phrase var='marketplace.sold'})</span>{/if}
		{if !empty($aListing.short_description)}
		<div class="extra_info">
			{$aListing.short_description|clean}
		</div>
		{/if}
		<div class="extra_info">
			{phrase var='marketplace.posted_time_stamp_by_user_info_in_country_iso' time_stamp=$aListing.time_stamp|date:'marketplace.marketplace_view_time_stamp' user_info=$aListing|user country_iso=$aListing.country_iso|location}			
			<div class="p_4">
			{if !empty($aListing.city)} {$aListing.city|clean} &raquo; {/if} 
			{if !empty($aListing.country_child_id)} {$aListing.country_child_id|location_child} &raquo; {/if} 
			{$aListing.country_iso|location}
			</div>
			{if $sListingView == 'sold'}
			{if isset($aListing.invoices) && is_array($aListing.invoices) && count($aListing.invoices)}
			{phrase var='marketplace.purchased_by'}: {foreach from=$aListing.invoices name=invoices item=aInvoice}{if $phpfox.iteration.invoices != 1}, {/if}{$aInvoice|user}{/foreach}
			{/if}
			{/if}
		</div>
	</div>
	<div class="t_right">
		<ul class="item_menu" style="margin:0px;">
		    {if Phpfox::getUserParam('marketplace.can_sponsor_marketplace')}
		    <li>
			<span id="js_sponsor_{$aListing.listing_id}" class="">
			    {if $aListing.is_sponsor}
				<a href="#" onclick="$.ajaxCall('marketplace.sponsor','listing_id={$aListing.listing_id}&type=0');return false;">
				    {phrase var='marketplace.unsponsor_this_listing'}
				</a>
			    {else}
				<a href="#" onclick="$.ajaxCall('marketplace.sponsor','listing_id={$aListing.listing_id}&type=1');return false;">
				    {phrase var='marketplace.sponsor_this_listing'}
				</a>
			    {/if}
			</span>
		    </li>
		    {elseif Phpfox::getUserParam('marketplace.can_purchase_sponsor') && 
		    $aListing.user_id == Phpfox::getUserId() && $aListing.is_sponsor != 1}
		    <li>
			<a href="{url link='ad.sponsor' module='marketplace' id=$aListing.listing_id}">
			    {phrase var='marketplace.sponsor_this_listing'}
			</a>
		    </li>
		    {/if}
		{if $aListing.view_id == 1 && Phpfox::getUserParam('marketplace.can_approve_listings')}
			<li><a href="#" title="{phrase var='marketplace.approve_this_listing'}" onclick="$(this).parents('.js_listing_parent:first').removeClass('row_moderate').find('.row_pending_link:first').html('Approved').fadeOut(5000); $.ajaxCall('marketplace.approve', 'listing_id={$aListing.listing_id}'); $(this).parent().remove(); return false;">{phrase var='marketplace.approve'}</a></li>
		{/if}
		{if $aListing.view_id == 0 && Phpfox::getUserParam('marketplace.can_feature_listings')}
			<li id="js_feature_{$aListing.listing_id}"{if $aListing.is_featured} style="display:none;"{/if}><a href="#" title="{phrase var='marketplace.feature_this_listing'}" onclick="$(this).parent().hide(); $('#js_unfeature_{$aListing.listing_id}').show(); $(this).parents('.js_listing_parent:first').addClass('row_featured').find('.js_featured_listing').show(); $.ajaxCall('marketplace.feature', 'listing_id={$aListing.listing_id}&amp;type=1'); return false;">{phrase var='marketplace.feature'}</a></li>				
			<li id="js_unfeature_{$aListing.listing_id}"{if !$aListing.is_featured} style="display:none;"{/if}><a href="#" title="{phrase var='marketplace.un_feature_this_listing'}" onclick="$(this).parent().hide(); $('#js_feature_{$aListing.listing_id}').show(); $(this).parents('.js_listing_parent:first').removeClass('row_featured').find('.js_featured_listing').hide(); $.ajaxCall('marketplace.feature', 'listing_id={$aListing.listing_id}&amp;type=0'); return false;">{phrase var='marketplace.unfeature'}</a></li>				
		{/if}		
		{if ($aListing.user_id == Phpfox::getUserId() && Phpfox::getUserParam('marketplace.can_delete_own_listing')) || Phpfox::getUserParam('marketplace.can_delete_other_listings')}
			<li><a href="#" onclick="if (confirm('{phrase var='marketplace.are_you_sure' phpfox_squote=true}')) {literal}{{/literal} $.ajaxCall('marketplace.delete', 'id={$aListing.listing_id}'); {literal}}{/literal} return false;">{phrase var='marketplace.delete'}</a></li>
		{/if}
			<li><!-- --></li>
		</ul>	
	</div>
</div>
{/foreach}
{pager}
{/if}