<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: album.class.php 2412 2011-03-23 12:50:45Z Miguel_Espinoza $
 */
class Music_Component_Controller_Album extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('music.can_access_music', true);
		Phpfox::isUser(true);
		if (!Phpfox::getUserParam('music.can_upload_music_public') && !Phpfox::getUserParam('music.can_edit_other_music_albums'))
		{
			$this->url()->send('music.register');
		}
		$bIsEdit = false;
		$sStep = $this->request()->get('step', false);
		$aVals = $this->request()->getArray('val');
		$sAction = (isset($aVals['action']) ? $aVals['action'] :  $this->request()->get('req3', false));		
		Phpfox_Error::setDisplay(false);	
		$sMusicMessage = '';

		if ($iEditId = $this->request()->get('id'))
		{
			if (($aAlbum = Phpfox::getService('music.album')->getForEdit($iEditId)))
			{
				$bIsEdit = true;
				$this->template()->assign(array(
						'aForms' => $aAlbum
					)
				);
			}
		}		
		
		if (!$bIsEdit && !Phpfox::getUserParam('music.can_upload_music_public'))
		{
			$this->url()->send('music.register');	
		}
		
		$aValidation = array(
			'name' => Phpfox::getPhrase('music.provide_a_name_for_this_album'),
			'year' => array(
				'def' => 'year'
			)
		);
		
		$oValidator = Phpfox::getLib('validator')->set(array(
				'sFormName' => 'js_album_form',
				'aParams' => $aValidation
			)
		);
		
		if ($aVals)
		{
			if ($oValidator->isValid($aVals))
			{
				if ($bIsEdit)
				{
					if (Phpfox::getService('music.album.process')->update($aAlbum['album_id'], $aVals))
					{
						if (isset($aVals['step']))
						{
							if ($aVals['step'] == 'song')
							{
								$this->url()->send(Phpfox::getUserBy('user_name'), array('music', $aAlbum['name_url']), Phpfox::getPhrase('music.album_successfully_updated'));
							}
							else 
							{
								$this->url()->send('music.album', array('id' => $aAlbum['album_id'], 'step' => 'song'));
							}
						}
						else 
						{
							switch ($aVals['action'])
							{
								case 'song':
									Phpfox::getLib('session')->set('music_add_message', Phpfox::getPhrase('music.tracks_successfully_uploaded') . (Phpfox::getUserParam('music.music_song_approval') ? ' ' . Phpfox::getPhrase('music.note_that_it_will_have_to_be_approved_first_before_it_is_displayed_publicly') : ''));
									
									$this->url()->send('music.album.song', array('id' => $aAlbum['album_id']));									
									break;
								case 'art':
									Phpfox::getLib('session')->set('music_add_message', Phpfox::getPhrase('music.album_art_successfully_updated'));
									
									$this->url()->send('music.album.art', array('id' => $aAlbum['album_id']));									
									break;
								default:
									Phpfox::getLib('session')->set('music_add_message', Phpfox::getPhrase('music.album_successfully_updated'));
									
									$this->url()->send('music.album', array('id' => $aAlbum['album_id']));									
									break;									
									break;
							}
						}
					}
				}
				else 
				{
					if ($iId = Phpfox::getService('music.album.process')->add($aVals))
					{
						Phpfox::getLib('session')->set('music_add_message', Phpfox::getPhrase('music.album_successfully_added'));
						
						$this->url()->send('music.album', array('id' => $iId, 'step' => 'art'));
					}
				}
			}
		}
		
		if (($sMusicMessage = Phpfox::getLib('session')->get('music_add_message')))
		{
			Phpfox::getLib('session')->remove('music_add_message');
		}
		$sMethod = Phpfox::getParam('music.music_enable_mass_uploader') && ($this->request()->get('method','massuploader') == 'massuploader') ? 'massuploader' : 'simple';
		// used to tell the template where to link for the opposite method
		$sMethodUrl = str_replace(array('method_simple/','method_massuploader/'), '',$this->url()->getFullUrl()) . 'method_' . ($sMethod == 'simple' ? 'massuploader' : 'simple') . '/';
		
		if ($sMethod == 'massuploader')
		{
			$iMaxFileSize = (Phpfox::getUserParam('music.music_max_file_size') === 0 ? null : ((Phpfox::getUserParam('music.music_max_file_size') / 1024) * 1048576));
			$this->template()->setHeader('cache', array(
				'massuploader/swfupload.js' => 'static_script',
				'<script type="text/javascript">
							function setSWFUSettings()
							{
								swfu.setButtonDimensions(' . (strlen(Phpfox::getPhrase('photo.click_here_to_upload_photos')) * 5) . ',20);
								swfu.setUploadURL("' . $this->url()->makeUrl('music.upload') . '");
								swfu.setFileSizeLimit("' . ($iMaxFileSize* 1048576) . '");
								swfu.setFileUploadLimit(' . Phpfox::getUserParam('photo.max_images_per_upload') . ');
								swfu.customSettings.progress_target = "js_progress_bar";
								swfu.customSettings.cookie = [];
								swfu.customSettings.flash_user_id = '.Phpfox::getUserId() .';
								swfu.customSettings.sAjaxCall = "";
								swfu.customSettings.sHash = "'.Phpfox::getService('core')->getHashForUpload().'";
								'. (isset($aAlbum['album_id']) ? 'swfu.customSettings.album_id = '.$aAlbum['album_id'].'; ' : '').'
								swfu.setFileTypes("*.mp3","*.mp3");
								swfu.atFileQueue = function(){$("#swfUploadText").hide();}
								' . /* We can add a plugin call here to let clients further customize the swf object */'' . '
							}
							</script>',
				'massuploader/upload.js' => 'static_script',
				'upload.css' => 'module_music'
			))
			->setPhrase(array(
							'photo.you_can_upload_a_jpg_gif_or_png_file',
							'core.name',
							'core.status',
							'core.in_queue',
							'core.upload_failed_your_file_size_is_larger_then_our_limit_file_size'
						)
					);
		}
		$this->template()->setTitle(($bIsEdit ? Phpfox::getPhrase('music.update_album') . ': ' . $aAlbum['name'] : Phpfox::getPhrase('music.create_album')))
			->setBreadcrumb(Phpfox::getPhrase('music.music'), $this->url()->makeUrl('music'))
			->setBreadcrumb(($bIsEdit ? Phpfox::getPhrase('music.update_album') . ': ' . $aAlbum['name'] : Phpfox::getPhrase('music.create_album')), null, true)
			->setFullSite()
			->setPhrase(array(
					'music.select_an_mp3',
					'core.select_a_file_to_upload'
				)
			)
			->setHeader(array(
					'album.js' => 'module_music',
					'upload.js' => 'module_music',
					'progress.js' => 'static_script',
					'<script type="text/javascript">var oProgressBar = {holder: \'#js_music_form_holder\', progress_id: \'#js_progress_bar\', uploader: \'#js_progress_uploader\', add_more: true, max_upload: 1, total: 1, frame_id: \'js_upload_frame\', file_id: \'image\'};</script>',					
					'<script type="text/javascript">$(function(){$(\'#js_music_block_' . ($sAction ? $sAction : ($sStep ? $sStep : 'detail')) . '\').show();});</script>',
					'player/' . Phpfox::getParam('core.default_music_player') . '/phpfox.js' => 'static_script',
					'<script type="text/javascript">$(function() { Phpfox.player.load({id: \'js_music_player\', type: \'music\'}); });</script>'
				)
			)
			->assign(array(
					'sStep' => $sStep,
					'sAction' => ($sAction ? $sAction : 'detail'),
					'bIsEdit' => $bIsEdit,
					'sCreateJs' => $oValidator->createJS(),
					'sGetJsForm' => $oValidator->getJsForm(false),
					'sMusicMessage' => $sMusicMessage,
					'aMusicErrors' => Phpfox_Error::get(),
					'iUploadLimit' => Phpfox::getLib('file')->getLimit(Phpfox::getUserParam('music.music_max_file_size')),
					'sJavaScriptEditLink' => ($bIsEdit ? "if (confirm('" . Phpfox::getPhrase('music.are_you_sure', array('phpfox_squote' => true)) . "')) { $('#js_submit_upload_image').show(); $('#js_music_upload_image').show(); $('#js_music_current_image').remove(); $.ajaxCall('music.deleteImage', 'id={$aAlbum['album_id']}'); } return false;" : ''),
					'aUserGenres' => Phpfox::getService('music.genre')->getUserGenre(Phpfox::getUserId()),
					'sMethod' => $sMethod,
					'sMethodUrl' => $sMethodUrl
				)
			);	
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('music.component_controller_album_clean')) ? eval($sPlugin) : false);
	}
}

?>