<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: album.class.php 1549 2010-04-14 10:42:27Z Miguel_Espinoza $
 */
class Music_Component_Controller_Browse_Album extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('music.can_access_music', true);
		
		$oServiceSongBrowse = Phpfox::getService('music.album.browse');
		$sCategory = '';
		$sCategoryUrl = '';
		$iPage = $this->request()->get('page');
		$sGenre = $this->request()->get('req4', null);	
		$sView = $this->request()->get('view');
		
		$aPages = array(30, 60, 90);
		$aDisplays = array();
		foreach ($aPages as $iPageCnt)
		{
			$aDisplays[$iPageCnt] = Phpfox::getPhrase('core.per_page', array('total' => $iPageCnt));
		}		
	
		$aFilters = array(
			'display' => array(
				'type' => 'select',
				'options' => $aDisplays,
				'default' => '12'
			),
			'sort' => array(
				'type' => 'select',
				'options' => array(
					'time_stamp' => Phpfox::getPhrase('music.date_added'),
					'title' => Phpfox::getPhrase('music.name')
				),
				'default' => 'time_stamp',
				'alias' => 'm'
			),
			'sort_by' => array(
				'type' => 'select',
				'options' => array(
					'DESC' => Phpfox::getPhrase('core.descending'),
					'ASC' => Phpfox::getPhrase('core.ascending')
				),
				'default' => 'DESC'
			),
			'keyword' => array(
				'type' => 'input:text',
				'size' => 20,
				'search' => 'AND m.name LIKE \'%[VALUE]%\''
			)			
		);
		
		$oFilter = Phpfox::getLib('search')
			->set(array(
				'type' => 'browse',
				'filters' => $aFilters,
				'search' => 'keyword',
				'prepare' => false
			)
		);				
		
		if ($sView == 'my')
		{
			$oFilter->setCondition('AND m.user_id = ' . Phpfox::getUserId());
		}
		else 
		{
			if (($iUserId = $this->request()->get('userid')))
			{
				$oFilter->setCondition('AND m.user_id = ' . $iUserId);	
			}			
		}		

		if ($this->request()->getInt('sponsor') == 1)
		{
		    $oFilter->setCondition('AND m.is_sponsor != 1');
		    Phpfox::addMessage(Phpfox::getPhrase('music.sponsor_help_album'));
		}
		$oServiceSongBrowse->condition($oFilter->getConditions())
			->genre($sGenre)
			->category($sCategory)
			->order($oFilter->getSort())
			->page($iPage)
			->size($oFilter->getDisplay())
			->execute();						
			
		Phpfox::getLib('pager')->set(array('page' => $iPage, 'size' => $oFilter->getDisplay(), 'count' => $oFilter->getSearchTotal($oServiceSongBrowse->getCount())));		
		
		if (Phpfox::getParam('music.music_index_controller') == 'album' && $this->request()->get('req3') != 'album')
		{
			$this->template()->setTitle(Phpfox::getPhrase('music.music'))
				->setBreadcrumb(Phpfox::getPhrase('music.music'), $this->url()->makeUrl('music'));
		}
		else 
		{
			$this->template()->setTitle(Phpfox::getPhrase('music.music_albums'))
				->setBreadcrumb(Phpfox::getPhrase('music.music'), $this->url()->makeUrl('music'))
				->setBreadcrumb(Phpfox::getPhrase('music.albums'), null, true);
		}
		
		$this->template()
			->setHeader('cache', array(
					'pager.css' => 'style_css',
					'player/' . Phpfox::getParam('core.default_music_player') . '/phpfox.js' => 'static_script'										
				)
			)
			->setHeader(array(
					'<script type="text/javascript">$(function() { Phpfox.player.load({id: \'js_music_player\', type: \'music\'}); });</script>'			
				)
			)			
			->assign(array(
				'aAlbums' => $oServiceSongBrowse->get(),
				'sCategoryUrl' => $sGenre,
				'sParentLink' => '.browse.album'
			)
		);		
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('music.component_controller_browse_album_clean')) ? eval($sPlugin) : false);
	}
}

?>