<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Music
 * @version 		$Id: index.class.php 1583 2010-05-07 11:10:25Z Raymond_Benc $
 */
class Music_Component_Controller_Index extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{		
		Phpfox::getUserParam('music.can_access_music', true);
		
		if (($sRedirect = $this->request()->getInt('redirect')) && ($aSong = Phpfox::getService('music')->getSong(Phpfox::getUserId(), $sRedirect, true)))
		{
			$this->url()->send($aSong['user_name'], array('music', ($aSong['album_id'] ? $aSong['album_url'] : 'view'), $aSong['title_url']));
		}		
		
		define('PHPFOX_MUSIC_INDEX', true);
		
		$this->template()->setHeader(array(
				'<script type="text/javascript">$(function() { Phpfox.player.load({id: \'js_music_player_block\', type: \'music\'}); });</script>'		
			)
		);
		
		if ($this->request()->getInt('delete') && Phpfox::getService('music.album.process')->delete($this->request()->getInt('delete')))
		{
			$this->url()->send('music', null, Phpfox::getPhrase('music.music_album_successfully_deleted'));		
		}		
		
		if (!defined('PHPFOX_MUSIC_INDEX_OVERIDE'))
		{			
			if (Phpfox::getParam('music.music_index_controller') != 'artist')
			{				
				return Phpfox::getLib('module')->setController('music.browse.' . Phpfox::getParam('music.music_index_controller'));
			}
		}
		
		if ($this->request()->get('req2') == 'stylemusic' || $this->request()->get('req2') == 'album')
		{
			return Phpfox::getLib('module')->setController('error.404');
		}
				
		$oServiceMusicBrowse = Phpfox::getService('music.browse');
		$iPage = $this->request()->get('page');
		$sView = $this->request()->get('view', false);
		$iPageSize = 10;
		$sGenre = $this->request()->get('req2', null);	
		if ($sGenre == 'browse')
		{
			$sGenre = null;
		}
		$iPage = $this->request()->get('page');
		
		$aPages = array(30, 60, 90);
		$aDisplays = array();
		foreach ($aPages as $iPageCnt)
		{
			$aDisplays[$iPageCnt] = Phpfox::getPhrase('core.per_page', array('total' => $iPageCnt));
		}		
	
		$aFilters = array(
			'display' => array(
				'type' => 'select',
				'options' => $aDisplays,
				'default' => '12'
			),
			'sort' => array(
				'type' => 'select',
				'options' => array(
					'joined' => Phpfox::getPhrase('music.date_joined'),
					'full_name' => Phpfox::getPhrase('music.name')
				),
				'default' => 'joined',
				'alias' => 'u'
			),
			'sort_by' => array(
				'type' => 'select',
				'options' => array(
					'DESC' => Phpfox::getPhrase('core.descending'),
					'ASC' => Phpfox::getPhrase('core.ascending')
				),
				'default' => 'DESC'
			),
			'keyword' => array(
				'type' => 'input:text',
				'size' => 20,
				'search' => 'AND u.full_name LIKE \'%[VALUE]%\''
			)			
		);
		
		$oFilter = Phpfox::getLib('search')
			->set(array(
				'type' => 'browse',
				'filters' => $aFilters,
				'search' => 'keyword',
				'prepare' => false
			)
		);	
		
		$oFilter->setCondition('AND u.user_group_id = ' . Phpfox::getParam('music.music_user_group_id') . '');
		
		$oServiceMusicBrowse->condition($oFilter->getConditions())
			->genre($sGenre)
			->order($oFilter->getSort())
			->page($iPage)
			->size($oFilter->getDisplay())
			->execute();		
			
		Phpfox::getLib('pager')->set(array('page' => $iPage, 'size' => $oFilter->getDisplay(), 'count' => $oFilter->getSearchTotal($oServiceMusicBrowse->getCount())));		
		
		$aUsers = $oServiceMusicBrowse->get();		
		
		$this->template()
			->setTitle(Phpfox::getPhrase('music.music'))
			->setBreadcrumb(Phpfox::getPhrase('music.music'), $this->url()->makeUrl('music'))
			->setHeader('cache', array(
					'pager.css' => 'style_css',
					'player/' . Phpfox::getParam('core.default_music_player') . '/phpfox.js' => 'static_script'										
				)
			)
			->setHeader(array(
					'<script type="text/javascript">$(function() { Phpfox.player.load({id: \'js_music_player\', type: \'music\'}); });</script>'					
				)
			)
			->assign(array(
					'aUsers' => $aUsers,
					'bSearch' => ($sGenre !== null ? true : false),
					'sCategoryUrl' => ($sGenre !== null ? $sGenre : ''),
					'sParentLink' => '',
					'iSongApproveCnt' => (Phpfox::getUserParam('music.can_approve_songs') ? Phpfox::getService('music')->getPendingTotal() : 0)
				)
			);			
		
		if ($sGenre !== null)
		{
			$aKeys = array_keys($aUsers);
			if (isset($aKeys[0]))
			{
				$this->template()
					->setTitle($aUsers[$aKeys[0]]['genre_name'])
					->setBreadcrumb($aUsers[$aKeys[0]]['genre_name'], null, true);					
			}
		}
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('music.component_controller_index_clean')) ? eval($sPlugin) : false);
	}
}

?>