<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: upload.class.php 2424 2011-03-23 15:51:45Z Miguel_Espinoza $
 */
class Music_Component_Controller_Upload extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::isUser(true);
		if (!Phpfox::getUserParam('music.can_upload_music_public'))
		{
			$this->url()->send('music.register');
		}
		
		$aValidation = array(			
			'title' => Phpfox::getPhrase('music.provide_a_name_for_this_song')
		);
		
		$oValidator = Phpfox::getLib('validator')->set(array(
				'sFormName' => 'js_music_form',
				'aParams' => $aValidation
			)
		);		
		$sMethod = Phpfox::getParam('music.music_enable_mass_uploader') && ($this->request()->get('method','massuploader') == 'massuploader') ? 'massuploader' : 'simple';
		// used to tell the template where to link for the opposite method
		$sMethodUrl = str_replace(array('method_simple/','method_massuploader/'), '',$this->url()->getFullUrl()) . 'method_' . ($sMethod == 'simple' ? 'massuploader' : 'simple') . '/';
		$aVals = $this->request()->get('val');
		
		if (isset($aVals['method']))
		{
			$sMethod = $aVals['method'];
		}
		if ($sMethod == 'simple' && !empty($aVals))
		{
			if ($oValidator->isValid($aVals))
			{
				if (($aSong = Phpfox::getService('music.process')->upload($aVals, (isset($aVals['album_id']) ? (int) $aVals['album_id'] : 0))))
				{
					if (isset($aVals['album_id']) && $aVals['album_id'] > 0)
					{
						$aAlbum = Phpfox::getService('music.album')->getForPlayer($aVals['album_id']);

						$this->url()->send(Phpfox::getUserBy('user_name'), array('music', $aAlbum['name_url'], $aSong['title_url']), Phpfox::getPhrase('music.your_song_was_successfully_uploaded') . (Phpfox::getUserParam('music.music_song_approval') ? ' ' . Phpfox::getPhrase('music.note_that_it_will_have_to_be_approved_first_before_it_is_displayed_publicly') : ''));						
					}
					
					$this->url()->send(Phpfox::getUserBy('user_name'), array('music', 'view', $aSong['title_url']), Phpfox::getPhrase('music.your_song_was_successfully_uploaded') . (Phpfox::getUserParam('music.music_song_approval') ? ' ' . Phpfox::getPhrase('music.note_that_it_will_have_to_be_approved_first_before_it_is_displayed_publicly') : ''));
				}
			}
		}
		elseif ($sMethod == 'massuploader' && isset($_FILES['Filedata']))
		{
			
			$_FILES['mp3'] = $_FILES['Filedata'];
			$aVals = array('title' => $_FILES['mp3']['name']);

			if (isset($_POST['album_id']))
			{
				$aVals['album_id'] = (int)$_POST['album_id'];
			}
			if (($aSong = Phpfox::getService('music.process')->upload($aVals, (isset($aVals['album_id']) ? (int) $aVals['album_id'] : 0))))
			{
				//echo 'window.location.href = "' . Phpfox::getLib('url')->makeUrl('profile.music.view.' . $aSong['title_url']) . '";';
				echo '$("#title").val("'.str_replace(array('_','.mp3'), array(' ', ''),$_FILES['mp3']['name']).'");';
				echo '$("#btnSubmit").click(function(){Phpfox.music.setName('.$aSong['song_id'].');});';
				echo '$("#btnSubmit").val("'.Phpfox::getPhrase('music.provide_a_name_for_this_song').'").show();';
				echo '$(".song_name").show();';
				echo '$("#swfUploaderButtonContainer").hide();';
				exit();
			}
			else
			{
			}
		}

		if ($sMethod == 'massuploader')
		{
			$iMaxFileSize = (Phpfox::getUserParam('music.music_max_file_size') === 0 ? null : ((Phpfox::getUserParam('music.music_max_file_size') / 1024) * 1048576));
			$this->template()->setHeader('cache', array(
				'massuploader/swfupload.js' => 'static_script',
				'<script type="text/javascript">
							function setSWFUSettings()
							{								
								swfu.setButtonDimensions(' . (strlen(Phpfox::getPhrase('music.click_here_to_upload')) * 5) . ',20);
								swfu.setUploadURL("' . $this->url()->makeUrl('music.upload') . '");
								swfu.setFileSizeLimit("' . ($iMaxFileSize * 1048576). '");
								swfu.setFileUploadLimit(1);
								swfu.setFileQueueLimit(1);
								swfu.customSettings.progress_target = "js_progress_bar";
								swfu.customSettings.cookie = [];
								swfu.customSettings.flash_user_id = '.Phpfox::getUserId() .';
								swfu.customSettings.sAjaxCall = "";
								swfu.customSettings.sHash = "'.Phpfox::getService('core')->getHashForUpload().'";
								'. (isset($aAlbum['album_id']) ? 'swfu.customSettings.album_id = '.$aAlbum['album_id'].'; ' : '').'
								swfu.setFileTypes("*.mp3","*.mp3");
								swfu.atFileQueue = function(){$("#music_album_id_select").attr("disabled", "disabled"); this.addPostParam("album_id", $("#music_album_id_select").val());}
							}
							</script>',
				'massuploader/upload.js' => 'static_script',
				'upload.css' => 'module_music'
			))
			->setPhrase(array(
							'photo.you_can_upload_a_jpg_gif_or_png_file',
							'core.name',
							'core.status',
							'core.in_queue',
							'core.upload_failed_your_file_size_is_larger_then_our_limit_file_size',
							'core.more_queued_than_allowed'
						)
					);
		}

		$this->template()->setTitle(Phpfox::getPhrase('music.upload_a_song'))
			->setBreadcrumb(Phpfox::getPhrase('music.music'), $this->url()->makeUrl('music'))
			->setBreadcrumb(Phpfox::getPhrase('music.upload_a_song'), null, true)
			->setFullSite()
			->setPhrase(array(
					'music.select_an_mp3'
				)
			)			
			->setHeader('cache', array(
					'upload.js' => 'module_music',
					'progress.css' => 'style_css'
				)
			)
			->assign(array(
					'aUploadAlbums' => Phpfox::getService('music.album')->getForUpload(),
					'sCreateJs' => $oValidator->createJS(),
					'sGetJsForm' => $oValidator->getJsForm(false),
					'iUploadLimit' => Phpfox::getLib('file')->getLimit(Phpfox::getUserParam('music.music_max_file_size')),
					'aUserGenres' => Phpfox::getService('music.genre')->getUserGenre(Phpfox::getUserId()),
					'sMethod' => $sMethod,
					'sMethodUrl' => $sMethodUrl
				)
			);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('music.component_controller_upload_clean')) ? eval($sPlugin) : false);
	}
}

?>