<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: view-album.class.php 1306 2009-12-09 05:05:18Z Raymond_Benc $
 */
class Music_Component_Controller_View_Album extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('music.can_access_music', true);
		
		$aUser = $this->getParam('aUser');
		
		$aAlbum = Phpfox::getService('music.album')->getAlbum($aUser['user_id'], $this->request()->get('req3'));
		
		if (!isset($aAlbum['album_id']))
		{
			return Phpfox_Error::display(Phpfox::getPhrase('music.unable_to_find_the_album_you_are_looking_for'));
		}
		
		$this->setParam('aAlbum', $aAlbum);
		$this->setParam('aRatingCallback', array(
				'type' => 'music_album',
				'total_rating' => Phpfox::getPhrase('music.total_rating_ratings', array('total_rating' => $aAlbum['total_rating'])),
				'default_rating' => $aAlbum['total_score'],
				'item_id' => $aAlbum['album_id'],
				'stars' => array(
					'2' => Phpfox::getPhrase('music.poor'),
					'4' => Phpfox::getPhrase('music.nothing_special'),
					'6' => Phpfox::getPhrase('music.worth_listening_too'),
					'8' => Phpfox::getPhrase('music.pretty_cool'),
					'10' => Phpfox::getPhrase('music.awesome')
				)
			)
		);		
		
		$this->template()->setTitle($aAlbum['name'])
			->setTitle($aUser['full_name'])
			->setBreadcrumb(Phpfox::getPhrase('music.music'), $this->url()->makeUrl('music'))
			->setBreadcrumb(Phpfox::getPhrase('music.albums'), $this->url()->makeUrl('music.browse.album'))
			->setBreadcrumb($aAlbum['name'], null, true)
			->setPhrase(array(
					'rate.thanks_for_rating'			
				)
			)			
			->setHeader(array(
					'jquery/plugin/jquery.highlightFade.js' => 'static_script',	
					'jquery/plugin/jquery.scrollTo.js' => 'static_script',
					'rate.js' => 'module_rate',
					'<script type="text/javascript">$(function() { Phpfox.rate.init({display: ' . ($aAlbum['has_rated'] ? 'false' : ($aAlbum['user_id'] == Phpfox::getUserId() ? 'false' : 'true')) . ', error_message: \'' . ($aAlbum['has_rated'] ? Phpfox::getPhrase('music.you_have_already_voted', array('phpfox_squote' => true)) : Phpfox::getPhrase('music.you_cannot_rate_your_own_album', array('phpfox_squote' => true))) . '\'}); });</script>',
					'quick_edit.js' => 'static_script',
					'comment.css' => 'style_css',
					'pager.css' => 'style_css',
					'switch_legend.js' => 'static_script',
					'switch_menu.js' => 'static_script',					
					'player/' . Phpfox::getParam('core.default_music_player') . '/phpfox.js' => 'static_script',
					'<script type="text/javascript">$(function() { Phpfox.player.load({id: \'js_music_player\', type: \'music\'}); });</script>'
				)
			)
			->setEditor(array(
					'load' => 'simple'
				)
			)
			->assign(array(
					'aAlbum' => $aAlbum
				)
			);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('music.component_controller_view_album_clean')) ? eval($sPlugin) : false);
	}
}

?>