<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: view.class.php 2412 2011-03-23 12:50:45Z Miguel_Espinoza $
 */
class Music_Component_Controller_View extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('music.can_access_music', true);
		
		if (!($aSong = Phpfox::getService('music')->getSong($this->param('aUser')->user_id, $this->request()->get('req4'))))
		{
			return Phpfox_Error::display(Phpfox::getPhrase('music.the_song_you_are_looking_for_cannot_be_found'));
		}
		
		if (Phpfox::isModule('notification') && $aSong['user_id'] == Phpfox::getUserId())
		{
			Phpfox::getService('notification.process')->delete('music_songapproved', $aSong['song_id'], Phpfox::getUserId());
			Phpfox::getService('notification.process')->delete('music_song_album_notifyLike', $aSong['song_id'], Phpfox::getUserId());
			Phpfox::getService('notification.process')->delete('music_song_notifyLike', $aSong['song_id'], Phpfox::getUserId());
		}			
		
		$this->setParam('aSong', $aSong);
		$this->setParam('aRatingCallback', array(
				'type' => 'music_song',
				'total_rating' => Phpfox::getPhrase('music.total_rating_ratings', array('total_rating' => $aSong['total_rating'])),
				'default_rating' => $aSong['total_score'],
				'item_id' => $aSong['song_id'],
				'stars' => array(
					'2' => Phpfox::getPhrase('music.poor'),
					'4' => Phpfox::getPhrase('music.nothing_special'),
					'6' => Phpfox::getPhrase('music.worth_listening_too'),
					'8' => Phpfox::getPhrase('music.pretty_cool'),
					'10' => Phpfox::getPhrase('music.awesome')
				)
			)
		);		

		if (!empty($aSong['album_url']))
		{			
			$aAlbum = Phpfox::getService('music.album')->getAlbum($aSong['user_id'], $aSong['album_url']);
			if (!isset($aAlbum['album_id']))
			{
				return Phpfox_Error::display(Phpfox::getPhrase('music.unable_to_find_the_album_this_song_belongs_to'));
			}
			$this->template()->setBreadcrumb(Phpfox::getPhrase('music.music'), $this->url()->makeUrl('music'))
				->setBreadcrumb(Phpfox::getPhrase('music.albums'), $this->url()->makeUrl('music.browse.album'))
				->setBreadcrumb($aAlbum['name'], $this->url()->makeUrl($aSong['user_name'], array('music', $aAlbum['name_url'])));
		}
		else 
		{
			$this->template()->setBreadcrumb(Phpfox::getPhrase('music.music'), $this->url()->makeUrl('music'))->setBreadcrumb(Phpfox::getPhrase('music.songs'), $this->url()->makeUrl('music.browse.song'));
		}

		
		
		
		$this->template()->setTitle($aSong['title'])
			->setBreadcrumb($aSong['title'], null, true)
			->setPhrase(array(
					'rate.thanks_for_rating'			
				)
			)			
			->setHeader('cache', array(
					'jquery/plugin/jquery.highlightFade.js' => 'static_script',
					'jquery/plugin/jquery.scrollTo.js' => 'static_script',
					'rate.js' => 'module_rate',					
					'quick_edit.js' => 'static_script',
					'comment.css' => 'style_css',
					'pager.css' => 'style_css',
					'switch_legend.js' => 'static_script',
					'switch_menu.js' => 'static_script',
					'player/' . Phpfox::getParam('core.default_music_player') . '/phpfox.js' => 'static_script'					
				)
			)
			->setHeader(array(
					'<script type="text/javascript">$(function() { Phpfox.player.load({on_start: function() { $.ajaxCall(\'music.play\', \'id=' . $aSong['song_id'] . '\'); }, id: \'js_music_player\', type: \'music\', auto: true, play: \'' . $aSong['song_path'] . '\'}); });</script>',
					'<script type="text/javascript">$(function() { Phpfox.rate.init({display: ' . ($aSong['has_rated'] ? 'false' : ($aSong['user_id'] == Phpfox::getUserId() ? 'false' : 'true')) . ', error_message: \'' . ($aSong['has_rated'] ? Phpfox::getPhrase('music.you_have_already_voted', array('phpfox_squote' => true)) : Phpfox::getPhrase('music.you_cannot_rate_your_own_song', array('phpfox_squote' => true))) . '\'}); });</script>'	
				)
			)
			->setEditor(array(
					'load' => 'simple'
				)
			)		
			->assign(array(
				'aSong' => $aSong
			)
		);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('music.component_controller_view_clean')) ? eval($sPlugin) : false);
	}
}

?>