<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Service
 * @version 		$Id: genre.class.php 1496 2010-03-05 17:15:05Z Raymond_Benc $
 */
class Music_Service_Genre_Genre extends Phpfox_Service 
{
	/**
	 * Class constructor
	 */	
	public function __construct()
	{	
		$this->_sTable = Phpfox::getT('music_genre');	
	}
	
	public function getList()
	{		
		return $this->database()->select('genre_id, name, name_url')
			->from($this->_sTable)
			->order('name ASC')
			->execute('getRows', array(
					'cache' => true,
					'cache_name' => 'music_genre'
				)
			);
	}
	
	public function getUserGenre($iUserId)
	{
		return $this->database()->select('mg.genre_id, mg.name, mg.name_url, mgu.order_id')
			->from(Phpfox::getT('music_genre_user'), 'mgu')
			->join(Phpfox::getT('music_genre'), 'mg', 'mg.genre_id = mgu.genre_id')
			->where('mgu.user_id = ' . (int) $iUserId)
			->execute('getSlaveRows');
	}
	
	/**
	 * If a call is made to an unknown method attempt to connect
	 * it to a specific plug-in with the same name thus allowing 
	 * plug-in developers the ability to extend classes.
	 *
	 * @param string $sMethod is the name of the method
	 * @param array $aArguments is the array of arguments of being passed
	 */
	public function __call($sMethod, $aArguments)
	{
		/**
		 * Check if such a plug-in exists and if it does call it.
		 */
		if ($sPlugin = Phpfox_Plugin::get('music.service_genre_genre__call'))
		{
			return eval($sPlugin);
		}
			
		/**
		 * No method or plug-in found we must throw a error.
		 */
		Phpfox_Error::trigger('Call to undefined method ' . __CLASS__ . '::' . $sMethod . '()', E_USER_ERROR);
	}	
}

?>