<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: link.class.php 852 2009-08-10 18:05:32Z Raymond_Benc $
 */
class Notification_Component_Block_Link extends Phpfox_Component
{	
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		$aNotifications = Phpfox::getService('notification')->get();
		$iTotalNotifications = 0;
		$aIsSeen = array();
		foreach ($aNotifications as $aNotification)
		{
			if (!$aNotification['is_seen'])
			{
				$iTotalNotifications++;
				$aIsSeen[] = $aNotification['notification_id'];
			}
		}
		
		if (PHPFOX_IS_AJAX && $iTotalNotifications)
		{
			Phpfox::getLib('ajax')->call('$(\'#js_notification_total_count_show\').html(\'' . $iTotalNotifications . '\').show();');
		}
		
		$this->template()->assign(array(
				'aNotifications' => $aNotifications,
				'iTotalNotifications' => $iTotalNotifications,
				'bNotifyIsInline' => true,
				'sIsSeenIds' => (count($aIsSeen) ? serialize($aIsSeen) : '')
			)
		);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('notification.component_block_link_clean')) ? eval($sPlugin) : false);
	}
}

?>