<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: battle.class.php 1601 2010-05-30 05:20:59Z Raymond_Benc $
 */
class Photo_Component_Controller_Battle extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('photo.can_view_photos', true);
		
		$this->template()->setFullSite();
		
		$this->setParam('sPhotoCategorySubSystem', 'battle');
		
		$sCategory = null;
		$aRequests = $this->request()->getRequests();			
		foreach ($aRequests as $sKey => $sValue)
		{			
			if (!preg_match("/req[0-9]/", $sKey))
			{
				continue;
			}
			
			if ($sKey != 'req1' && $sKey != 'req2')
			{
				$sCategory = $sValue;
			}
		}		
		
		$sJavaScript = Phpfox::getService('photo.battle')->getJavaScript($sCategory);
		
		$this->template()->setTitle(Phpfox::getPhrase('photo.photo_battle'))
			->setBreadcrumb(Phpfox::getPhrase('photo.photos'), $this->url()->makeUrl('photo'))
			->setBreadcrumb(Phpfox::getPhrase('photo.battle'), null, true)
			->setHeader('cache', array(
					'battle.js' => 'module_photo',	
					'battle.css' => 'module_photo'
				)
			)
			->setPhrase(array(
					'photo.added_on_time_stamp_by_full_name'
				)
			)
			->assign(array(
					'sCategory' => ($sCategory === null ? Phpfox::getPhrase('photo.all_photos') : Phpfox::getService('photo.category')->getCategoryName($sCategory)),
					'aCallback' => null
				)			
			);
			
		
		if ($sJavaScript !== false)
		{
			$this->template()->setHeader('<script type="text/javascript">Phpfox.photoBattle.set(\'' . $sCategory . '\'); Phpfox.photoBattle.init(' . $sJavaScript . ');</script>');
		}		
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('photo.component_controller_battle_clean')) ? eval($sPlugin) : false);
	}
}

?>