<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * Rate public photos controller.
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: rate.class.php 1956 2010-10-27 14:35:19Z Miguel_Espinoza $
 */
class Photo_Component_Controller_Rate extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('photo.can_view_photos', true);
		
		if (!Phpfox::getParam('photo.can_rate_on_photos'))
		{
			return Phpfox_Error::display(Phpfox::getPhrase('photo.photo_rating_is_disabled'));
		}
		
		Phpfox::getUserParam('photo.can_rate_on_photos', true);
		
		$sCategory = null;
		$aRequests = $this->request()->getRequests();			
		foreach ($aRequests as $sKey => $sValue)
		{			
			if (!preg_match("/req[0-9]/", $sKey))
			{
				continue;
			}
			
			if ($sKey != 'req1' && $sKey != 'req2')
			{
				$sCategory = $sValue;
			}
		}
		
		(($sPlugin = Phpfox_Plugin::get('photo.component_controller_rate_process_start')) ? eval($sPlugin) : false);
		
		$sPhotos = Phpfox::getService('photo.rate')->getJavaScript($sCategory, $this->request()->get('id', null));
		
		$sJs = '';
		if ($sPhotos === false)
		{
			$this->template()->assign('bNoMorePhotos', true);
		}
		else 
		{
			$sJs = "<script type=\"text/javascript\">Phpfox.PhotoRate.init(\n\t\t{\n\t\t\t{$sPhotos}}\n\t\t});\n\t\t</script>";		
		}
		
		$sBar = '';
		for ($i = 1; $i <= 10; $i++)
		{			
			$sBar .= '<li><a href="' . $this->url()->makeUrl('current', array('rating' => $i)) . '" class="js_rating_bar">' . $i . '</a></li>';	
		}
		
		$this->setParam('sPhotoCategorySubSystem', 'rate');
		
		$this->template()->setTitle(Phpfox::getPhrase('photo.rate_photos'))
				->setBreadcrumb(Phpfox::getPhrase('photo.photos'), $this->url()->makeUrl('photo'))
				->setBreadcrumb(Phpfox::getPhrase('photo.rate'), null, true)
				->setPhrase(array(
						'photo.added_on_time_stamp_by_full_name',
						'photo.with_a_total_of_total_vote_votes'
					)
				)				
				->setHeader('cache', array(		
					'rate_bar.css' => 'style_css',			
					'rate.js' => 'module_photo'								
				))
				->setHeader(array(
					$sJs
					)				
			)		
			->assign(array(
				'sRatingBar' => $sBar,
				'aCallback' => null
			)
		);
		
		(($sPlugin = Phpfox_Plugin::get('photo.component_controller_rate_process_end')) ? eval($sPlugin) : false);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('photo.component_controller_rate_clean')) ? eval($sPlugin) : false);
	}
}

?>