<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Poll
 * @version 		$Id: index.class.php 1679 2010-07-20 14:02:30Z Raymond_Benc $
 */
class Poll_Component_Controller_Index extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('poll.can_access_polls', true);
		
		if (($iRedirect = $this->request()->getInt('redirect')) && ($sUrl = Phpfox::getService('poll.callback')->getFeedRedirect($iRedirect)))
		{
			$this->url()->forward($sUrl);
		}		
	
		(($sPlugin = Phpfox_Plugin::get('poll.component_controller_index_process_start')) ? eval($sPlugin) : false);
		
		$sSuffix = '_' . Phpfox::getParam('poll.poll_max_image_pic_size');
		// view_id = not requiring moderation
		$iPage = $this->request()->getInt('page');
		$iPageSize = (int) Phpfox::getParam('poll.polls_to_show');		
		$aCond = array();
		
		if ($iDeleteId = $this->request()->getInt('delete'))
		{
			if (Phpfox::getService('user.auth')->hasAccess('poll', 'poll_id', $iDeleteId, 'poll.poll_can_delete_own_polls', 'poll.poll_can_delete_others_polls') && Phpfox::getService('poll.process')->moderatePoll($iDeleteId, 2))
			{
				$this->url()->send('poll', null, Phpfox::getPhrase('poll.poll_successfully_deleted'));	
			}
		}
		
		// Track users		
		
		// Define params for "review views" block
		$this->setParam(array(
				'sTrackType' => 'poll',
				'iTrackId' => false,
				'iTrackUserId' => Phpfox::getUserId()
			)
		);
		
		$sUser = false;
		$aUser = false;
		$aCond[] = 'AND ' . Phpfox::getLib('database')->isNull('p.module_id');
		// check if we're viewing a user's polls (profile page)		
		if (defined('PHPFOX_IS_USER_PROFILE'))
		{
			/**
		 	* @fix Get the user array();
		 	*/
			// this is the way to get the info from the owner of the content in the page (!= getUserId())
			$aUser = $this->getParam('aUser'); 			
			if (Phpfox::getUserParam('poll.poll_can_moderate_polls') || $aUser['user_id'] == Phpfox::getUserId())
			{
				$aCond[] = ' AND p.user_id = ' . $aUser['user_id'] . ' AND p.view_id IN(0,1)';
			}
			else 
			{
				$aCond[] = ' AND p.user_id = ' . $aUser['user_id'] . ' AND p.view_id = 0';
			}			
			
			$sUser = $aUser['user_id'];
		}
		else
		{
			if (Phpfox::getUserParam('poll.poll_can_moderate_polls'))
			{
				$aCond[] = ' AND p.view_id IN(0,1) AND p.privacy = 1';
			}
			else 
			{
				$aCond[] = ' AND p.view_id = 0 AND p.privacy = 1';
			}
		}		

		list($iCnt, $aPolls) = Phpfox::getService('poll')->getPolls($aCond, $sUser, $iPage, $iPageSize, $aUser);
	
		if (defined('PHPFOX_IS_USER_PROFILE'))
		{
			$this->template()->setMeta('keywords', Phpfox::getPhrase('poll.full_name_s_polls', array('full_name' => $aUser['full_name'])));
			$this->template()->setMeta('description', Phpfox::getPhrase('poll.full_name_s_polls_on_site_title_full_name_has_total_poll_s', array(
						'full_name' => $aUser['full_name'],
						'site_title' => Phpfox::getParam('core.site_title'),
						'full_name' => $aUser['full_name'],
						'total' => $iCnt
					)
				)
			);
		}		
		
		Phpfox::getLib('pager')->set(array('page' => $iPage, 'size' => $iPageSize, 'count' => $iCnt));
		// check if user has voted here already
		$aVotedPollsByUser = Phpfox::getService('poll')->getVotedAnswersByUser(Phpfox::getUserId());
		// check editing permissions
		foreach ($aPolls as $iKey => &$aPoll)
		{
			// is guest the owner?
			$aPoll['bCanEdit'] = Phpfox::getService('poll')->bCanEdit($aPoll['user_id']);			
			
			$this->template()->setMeta('keywords', $this->template()->getKeywords($aPoll['question']));
		}		
		
		$this->template()->setTitle((defined('PHPFOX_IS_USER_PROFILE') ? Phpfox::getPhrase('poll.full_name_s_polls_upper', array('full_name' => $aUser['full_name'])) : Phpfox::getPhrase('poll.polls')))
			->setHeader('cache', array(
					'moderate.js' => 'module_poll',

				)
			)
			->setBreadcrumb((defined('PHPFOX_IS_USER_PROFILE') ? Phpfox::getPhrase('poll.full_name_s_polls_upper', array('full_name' => $aUser['full_name'])) : Phpfox::getPhrase('poll.polls')), (defined('PHPFOX_IS_USER_PROFILE') ? $this->url()->makeUrl($aUser['user_name'], 'poll') : $this->url()->makeUrl('poll')))
			->setMeta('description', Phpfox::getParam('poll.poll_meta_description'))
			->setMeta('keywords', Phpfox::getParam('poll.poll_meta_keywords'))
			->setHeader('cache', array(
					'pager.css' => 'style_css',
					'poll.css' => 'module_poll'
				)
			)
			->assign(array(
					'aPolls' => $aPolls,
					'sSuffix' => $sSuffix,					
				)
			);
		(($sPlugin = Phpfox_Plugin::get('poll.component_controller_index_process_end')) ? eval($sPlugin) : false);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('poll.component_controller_index_clean')) ? eval($sPlugin) : false);
	}
}

?>