<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Privacy
 * @version 		$Id: process.class.php 1496 2010-03-05 17:15:05Z Raymond_Benc $
 */
class Privacy_Service_Process extends Phpfox_Service  
{
	/**
	 * Class constructor
	 */	
	public function __construct()
	{	
		$this->_sTable = Phpfox::getT('privacy');
	}
	
	public function add($sCategory, $iItemId, $mUsers)
	{		
		$sUserNames = '';
		$bUserId = false;
		if (is_array($mUsers))
		{
			foreach ($mUsers as $sName)
			{
				if (empty($sName))
				{
					continue;
				}
				$sUserNames .= "" . (int) trim($sName) . ",";
			}
			$sUserNames = rtrim($sUserNames, ',');
			$bUserId = true;
		}
		else
		{
			$sUserNames = "'" . $this->database()->escape(trim($sName)) . "'";
		}		
		
		if (empty($sUserNames))
		{
			return false;
		}

		$aRows = $this->database()->select('user_id')
			->from(Phpfox::getT('user'))
			->where(($bUserId ? "user_id" : "user_name") . " IN({$sUserNames})")
			->execute('getSlaveRows');

		$aUsers = array();
		foreach($aRows as $aRow)
		{			
			$this->database()->insert($this->_sTable, array(
					'item_id' => $iItemId,
					'category_id' => $sCategory,
					'user_id' => $aRow['user_id'],
					'added' => PHPFOX_TIME
				)
			);
		}
		
		return true;
	}	
	
	public function update($sCategory, $iItemId, $sUsers)
	{
		$this->database()->delete($this->_sTable, "item_id = " . (int) $iItemId . " AND category_id = '" . $this->database()->escape($sCategory) . "'");
		
		return $this->add($sCategory, $iItemId, $sUsers);
	}

	/**
	 * If a call is made to an unknown method attempt to connect
	 * it to a specific plug-in with the same name thus allowing 
	 * plug-in developers the ability to extend classes.
	 *
	 * @param string $sMethod is the name of the method
	 * @param array $aArguments is the array of arguments of being passed
	 */
	public function __call($sMethod, $aArguments)
	{
		/**
		 * Check if such a plug-in exists and if it does call it.
		 */
		if ($sPlugin = Phpfox_Plugin::get('privacy.service_process__call'))
		{
			return eval($sPlugin);
		}
			
		/**
		 * No method or plug-in found we must throw a error.
		 */
		Phpfox_Error::trigger('Call to undefined method ' . __CLASS__ . '::' . $sMethod . '()', E_USER_ERROR);
	}
}

?>