<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * Profile Block Header
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Profile
 * @version 		$Id: header.class.php 2293 2011-02-03 13:22:26Z Miguel_Espinoza $
 */
class Profile_Component_Block_Header extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		$aMenus = $this->template()->getMenu('profile');
		$aUser = $this->getParam('aUser');
	
		foreach ($aMenus as $iKey => $aMenu)
		{
			if (Phpfox::getParam('profile.show_empty_tabs') == false
					&& Phpfox::hasCallback($aMenu['module'],'tabHasItems'))
			{
				if (Phpfox::callback($aMenu['module'].'.tabHasItems', $aUser['user_id']) == false)
				{
					unset($aMenus[$iKey]);
					continue;
				}
			}
			if ($aMenu['url'] == 'profile')
			{
				$aMenus[$iKey]['url'] = $aUser['user_name'];
			}
			else 
			{
				$aMenus[$iKey]['url'] = $aUser['user_name'] . '.' . $this->url()->doRewrite(preg_replace("/^profile\.(.*)$/i", "\\1", $aMenu['url']));
			}
		}
		
		$aUser = $this->getParam('aUser');
		
		if (!$this->getParam('bIsProfileIndex'))
		{
			$sImage = Phpfox::getLib('image.helper')->display(array(
					'user' => $aUser,
					'suffix' => '_50_square',
					'max_width' => 50,
					'max_height' => 50,					
                    'class' => 'profile_image'
				)
			);	
			
			$this->template()->assign('sProfileImage', $sImage);
		}
		
		$this->template()->assign(array(
				'aProfileMenus' => $aMenus,				
			)
		);
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('profile.component_block_header_clean')) ? eval($sPlugin) : false);
	}
}

?>