<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Quiz
 * @version 		$Id: callback.class.php 2293 2011-02-03 13:22:26Z Miguel_Espinoza $
 */
class Quiz_Service_Callback extends Phpfox_Service 
{
	/**
	 * Class constructor
	 */	
	public function __construct()
	{	
		$this->_sTable = Phpfox::getT('quiz');
	}
	
	public function getProfileLink()
	{
		return 'profile.quiz';
	}

	public function getAjaxCommentVar()
	{
		return 'quiz.can_post_comment_on_quiz';
	}

	public function getCommentItemName()
	{
		return 'quiz';
	}
	
	public function getNewsFeed($aRow)
	{
		if ($sPlugin = Phpfox_Plugin::get('quiz.service_callback_getnewsfeed_start')){eval($sPlugin);}
		$oUrl = Phpfox::getLib('url');
		$oParseOutput = Phpfox::getLib('parse.output');

		$aRow['text'] = Phpfox::getPhrase('quiz.a_href_user_link_full_name_a_added_a_new_quiz_a_href_question_url_question_a', array(
				'user_link' => $oUrl->makeUrl('feed.user', array('id' => $aRow['owner_user_id'])),
				'full_name' => $this->preParse()->clean($aRow['owner_full_name']),
				'question_url' => $aRow['link'],
				'question' => Phpfox::getService('feed')->shortenTitle($aRow['content'])
			)
		);	
		
		$aRow['icon'] = 'module/quiz.png';
		$aRow['enable_like'] = true;

		return $aRow;
	}
	
	public function getCommentItem($iId)
	{
		return $this->database()->select('quiz_id AS comment_item_id, allow_comment AS comment_view_id, user_id AS comment_user_id')
			->from($this->_sTable)
			->where('quiz_id = ' . (int) $iId)
			->execute('getSlaveRow');
	}

	public function getFeedRedirect($iId, $iChild = 0)
	{
		$aQuiz = $this->database()->select('q.quiz_id, q.title_url, u.user_id, u.user_name')
			->from($this->_sTable, 'q')
			->join(Phpfox::getT('user'), 'u', 'u.user_id = q.user_id')
			->where('q.quiz_id = ' . (int) $iId)
			->execute('getSlaveRow');

		if (!isset($aQuiz['quiz_id']))
		{
			return false;
		}

		if (Phpfox::getParam('core.is_personal_site'))
		{
			return Phpfox::getLib('url')->makeUrl('quiz', $aQuiz['title_url']);
		}

		if ($iChild > 0)
		{
			return Phpfox::getLib('url')->makeUrl($aQuiz['user_name'], array('quiz', $aQuiz['title_url'], 'comment' => $iChild, '#comment-view'));
		}		
		return Phpfox::getLib('url')->makeUrl($aQuiz['user_name'], array('quiz', $aQuiz['title_url']));
	}

	public function getCommentNewsFeed($aRow)
	{
		$oUrl = Phpfox::getLib('url');
		$oParseOutput = Phpfox::getLib('parse.output');

		if ($aRow['owner_user_id'] == $aRow['item_user_id'])
		{
			$aRow['text'] = Phpfox::getPhrase('quiz.a_href_user_link_full_name_a_added_a_new_comment_on_their_own_a_href_title_link_quiz_a', array(
					'user_link' => $oUrl->makeUrl('feed.user', array('id' => $aRow['user_id'])),
					'full_name' => $this->preParse()->clean($aRow['owner_full_name']),
					'title_link' => $aRow['link']
				)
			);
		}
		else 
		{
			if ($aRow['item_user_id'] == Phpfox::getUserBy('user_id'))
			{
				$aRow['text'] = Phpfox::getPhrase('quiz.a_href_user_link_full_name_a_added_a_new_comment_on_your_a_href_title_link_quiz_a', array(
						'user_link' => $oUrl->makeUrl('feed.user', array('id' => $aRow['user_id'])),
						'full_name' => $this->preParse()->clean($aRow['owner_full_name']),
						'title_link' => $aRow['link']				
					)
				);
			}
			else 
			{
				$aRow['text'] = Phpfox::getPhrase('quiz.a_href_user_link_full_name_a_added_a_new_comment_on_a_href_item_user_link_item_user_name_s_a_a_href_title_link_quiz_a', array(
						'user_link' => $oUrl->makeUrl('feed.user', array('id' => $aRow['user_id'])),
						'full_name' => $this->preParse()->clean($aRow['owner_full_name']),
						'title_link' => $aRow['link'],
						'item_user_name' => $this->preParse()->clean($aRow['viewer_full_name']),
						'item_user_link' =>	$oUrl->makeUrl('feed.user', array('id' => $aRow['viewer_user_id']))
					)
				);
			}
		}		

		$aRow['text'] .= Phpfox::getService('feed')->quote($aRow['content']);

		return $aRow;
	}
	
	public function processCommentModeration($sAction, $iId)
	{
		// Is this comment approved?
		if ($sAction == 'approve')
		{
			// Update the blog count
			Phpfox::getService('quiz.process')->updateCounter($iId);

			// Get the blogs details so we can add it to our news feed
			$aQuiz = $this->database()->select('q.quiz_id, q.user_id, q.title_url, ct.text_parsed, c.user_id AS comment_user_id, c.comment_id')
				->from($this->_sTable, 'q')
				->join(Phpfox::getT('comment'), 'c', 'c.type_id = \'quiz\' AND c.item_id = q.quiz_id')
				->join(Phpfox::getT('comment_text'), 'ct', 'ct.comment_id = c.comment_id')
				->where('q.quiz_id = ' . (int) $iId)
				->execute('getSlaveRow');

			// Add to news feed
			(Phpfox::isModule('feed') ? Phpfox::getService('feed.process')->add('comment_quiz', $aQuiz['quiz_id'], $aQuiz['text_parsed'], $aQuiz['comment_user_id'], $aQuiz['user_id'], $aQuiz['comment_id']) : null);

			// Send the user an email
			if (Phpfox::getParam('core.is_personal_site'))
			{
				$sLink = Phpfox::getLib('url')->makeUrl('quiz', $aQuiz['title_url']);
			}
			else
			{
				$sLink = Phpfox::getService('user')->getLink(Phpfox::getUserId(), Phpfox::getUserBy('user_name'), array('quiz', $aQuiz['title_url']));
			}

			Phpfox::getLib('mail')->to($aQuiz['comment_user_id'])
				->subject(array('quiz.full_name_approved_your_comment_on_site_title', array('full_name' => Phpfox::getUserBy('full_name'), 'site_title' => Phpfox::getParam('core.site_title'))))
				->message(array('quiz.full_name_approved_your_comment_on_site_title_message', array(
							'full_name' => Phpfox::getUserBy('full_name'),
							'site_title' => Phpfox::getParam('core.site_title'),
							'link' => $sLink
						)
					)
				)
				->notification('comment.approve_new_comment')
				->send();
		}
	}

	public function getRedirectComment($iId)
	{
		return $this->getFeedRedirect($iId);
	}
	
	public function addComment($aVals, $iUserId = null, $sUserName = null)
	{
		$aQuiz = $this->database()->select('u.full_name, u.user_id, u.user_name, q.title_url')
			->from($this->_sTable, 'q')
			->join(Phpfox::getT('user'), 'u', 'u.user_id = q.user_id')
			->where('q.quiz_id = ' . (int) $aVals['item_id'])
			->execute('getSlaveRow');
			
		// Update the post counter if its not a comment put under moderation or if the person posting the comment is the owner of the item.
		if ($aVals['comment_view_id'] != 2 || ($aVals['comment_view_id'] == 2 && $aVals['comment_user_id'] == $iUserId))
		{
			Phpfox::getService('quiz.process')->updateCounter($aVals['item_id']);
			(Phpfox::isModule('feed') ? Phpfox::getService('feed.process')->add('comment_quiz', $aVals['item_id'], $aVals['text_parsed'], $iUserId, $aQuiz['user_id'], $aVals['comment_id']) : null);

			// Send the user an email
			if (Phpfox::getParam('core.is_personal_site'))
			{
				$sLink = Phpfox::getLib('url')->makeUrl('quiz', $aQuiz['title_url']);
			}
			else
			{
				$sLink = Phpfox::getService('user')->getLink($aQuiz['user_id'], $aQuiz['user_name'], array('quiz', $aQuiz['title_url']));
			}
			Phpfox::getLib('mail')->to($aQuiz['user_id'])
				->subject(array('quiz.user_name_left_you_a_comment_on_site_title', array('user_name' => $sUserName, 'site_title' => Phpfox::getParam('core.site_title'))))
				->message(array('quiz.user_name_left_you_a_comment_on_site_title_message', array(
							'user_name' => $sUserName,
							'site_title' => Phpfox::getParam('core.site_title'),
							'link' => $sLink
						)
					)
				)				
				->notification('comment.add_new_comment')
				->send();
		}

		if ($aVals['comment_view_id'] == 2 && Phpfox::isModule('request') && !Phpfox::getUserParam('comment.approve_all_comments'))
		{
			$sLink = Phpfox::getLib('url')->makeUrl('request', '#comment');
			Phpfox::getLib('mail')->to($aQuiz['user_id'])
				->subject(array('quiz.user_name_left_you_a_comment_on_site_title', array('user_name' => $sUserName, 'site_title' => Phpfox::getParam('core.site_title'))))
				->message(array('quiz.user_name_left_you_a_comment_on_site_title_however_before_it_can_be_displayed_it_needs_to_be_approved_by_you_you_can_approve_or_deny_this_comment_by_following_the_link_below_a_href_link_link_a', array(
							'user_name' => $sUserName,
							'site_title' => Phpfox::getParam('core.site_title'),
							'link' => $sLink
						)
					)
				)				
				->notification('comment.approve_new_comment')
				->send();
		}
	}
	
	public function updateCommentText($aVals, $sText)
	{
		(Phpfox::isModule('feed') ? Phpfox::getService('feed.process')->update('comment_quiz', $aVals['item_id'], $sText, $aVals['comment_id']) : null);
	}		

	public function getItemName($iId, $sName)
	{
		return '<a href="' . Phpfox::getLib('url')->makeUrl('comment.view', array('id' => $iId)) . '">' . Phpfox::getPhrase('quiz.on_name_s_quiz', array('name' => $sName)) . '</a>';
	}	
	
	/**
	 * Adds a track to quiz_track only if this user has not taken the quiz. Meaning
	 * if the user has taken the quiz then no new track is added.
	 * @param int $iId quiz id
	 */
	public function addTrack($iId)
	{
		(($sPlugin = Phpfox_Plugin::get('quiz.component_service_callback_addtrack_start')) ? eval($sPlugin) : false);

		$iCnt = $this->database()->select('COUNT(*)')
			->from(Phpfox::getT('quiz_track'))
			->where('item_id = ' . (int)$iId . ' AND user_id = ' . Phpfox::getUserId())
			->execute('getSlaveField');

		if ($iCnt <= 0)
		{
			$this->database()->insert(Phpfox::getT('quiz_track'), array(
					'item_id' => (int) $iId,
					'user_id' => Phpfox::getUserBy('user_id'),
					'time_stamp' => PHPFOX_TIME
				)
			);
		}

		
		(($sPlugin = Phpfox_Plugin::get('quiz.component_service_callback_addtrack_end')) ? eval($sPlugin) : false);
	}

	public function getLatestTrackUsers($iId, $iUserId)
	{
		$aUsers = $this->database()->select(Phpfox::getUserField())
			->from(Phpfox::getT('quiz_track'), 'track')
			->join(Phpfox::getT('user'), 'u', 'u.user_id = track.user_id')
			->where('track.item_id = ' . (int) $iId . ' AND track.user_id != ' . (int) $iUserId)
			->order('track.time_stamp DESC')
			->limit(0, 6)
			->execute('getSlaveRows');		
		
		if (count($aUsers))
		{
			// get their answers and percentage
			$aAnswers = $this->database()->select('*')
				->from(Phpfox::getT('quiz_answer'), 'qa')
				->join(Phpfox::getT('quiz_result'), 'qr', 'qr.answer_id = qa.answer_id AND qr.quiz_id = ' . (int)$iId . ' AND qr.user_id = ' . (int)$iUserId)
				
				->execute('getSlaveRows');
			
		}
		return (count($aUsers) ? $aUsers : false);
	}
	
	public function deleteComment($iId)
	{
		$this->database()->updateCounter('quiz', 'total_comment', 'quiz_id', $iId, true);
	}
	
	public function getDashboardLinks()
	{
		return array(
			'submit' => array(
				'phrase' => Phpfox::getPhrase('quiz.create_a_quiz'),
				'link' => 'quiz.add',
				'image' => 'misc/chart_pie_add.png'
			),
			'edit' => array(
				'phrase' => Phpfox::getPhrase('quiz.manage_quizzes'),
				'link' => 'profile.quiz',
				'image' => 'misc/chart_pie_edit.png'
			)
		);
	}	

	/**
	 * Action to take when user cancelled their account
	 * @param int $iUser
	 */
	public function onDeleteUser($iUser)
	{
		$aQuizzes = $this->database()
			->select('quiz_id')
			->from($this->_sTable)
			->where('user_id = ' . (int)$iUser)
			->execute('getSlaveRows');
		foreach ($aQuizzes as $aQuiz)
		{
			Phpfox::getService('quiz.process')->deleteQuiz($aQuiz['quiz_id'], $iUser);
		}
	}
	
	public function getItemView()
	{
		if (Phpfox::getLib('request')->get('req3') != '')
		{
			return true;
		}
	}
	
	public function getDashboardActivity()
	{
		$aUser = Phpfox::getService('user')->get(Phpfox::getUserId(), true);
		
		return array(
			Phpfox::getPhrase('quiz.quizzes') => $aUser['activity_quiz']
		);
	}

	public function getSiteStatsForAdmins()
	{
		$iToday = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
		
		return array(
			'phrase' => Phpfox::getPhrase('quiz.quizzes'),
			'value' => $this->database()->select('COUNT(*)')
				->from(Phpfox::getT('quiz'))
				->where('view_id = 0 AND time_stamp >= ' . $iToday)
				->execute('getSlaveField')
		);
	}
	
	public function getFeedRedirectFeedLike($iId, $iChildId = 0)
	{
		return $this->getFeedRedirect($iChildId);
	}
	
	public function getNewsFeedFeedLike($aRow)
	{
		if ($aRow['owner_user_id'] == $aRow['viewer_user_id'])
		{
			$aRow['text'] = Phpfox::getPhrase('quiz.a_href_user_link_full_name_a_liked_their_own_a_href_link_quiz_a', array(
					'full_name' => Phpfox::getLib('parse.output')->clean($aRow['owner_full_name']),
					'user_link' => Phpfox::getLib('url')->makeUrl($aRow['owner_user_name']),
					'link' => $aRow['link']
				)
			);
		}
		else 
		{
			$aRow['text'] = Phpfox::getPhrase('quiz.a_href_user_link_full_name_a_liked_a_href_view_user_link_view_full_name_a_s_a_href_link_quiz_a', array(
					'full_name' => Phpfox::getLib('parse.output')->clean($aRow['owner_full_name']),
					'user_link' => Phpfox::getLib('url')->makeUrl($aRow['owner_user_name']),
					'view_full_name' => Phpfox::getLib('parse.output')->clean($aRow['viewer_full_name']),
					'view_user_link' => Phpfox::getLib('url')->makeUrl($aRow['viewer_user_name']),
					'link' => $aRow['link']			
				)
			);
		}
		
		$aRow['icon'] = 'misc/thumb_up.png';

		return $aRow;				
	}		

	public function getNotificationFeedNotifyLike($aRow)
	{		
		return array(
			'message' => Phpfox::getPhrase('quiz.a_href_user_link_full_name_a_likes_your_a_href_link_quiz_a', array(
					'full_name' => Phpfox::getLib('parse.output')->clean($aRow['full_name']),
					'user_link' => Phpfox::getLib('url')->makeUrl($aRow['user_name']),
					'link' => Phpfox::getLib('url')->makeUrl('quiz', array('redirect' => $aRow['item_id']))
				)
			),
			'link' => Phpfox::getLib('url')->makeUrl('quiz', array('redirect' => $aRow['item_id']))			
		);				
	}	
	
	public function sendLikeEmail($iItemId)
	{
		return Phpfox::getPhrase('quiz.a_href_user_link_full_name_a_likes_your_a_href_link_quiz_a', array(
					'full_name' => Phpfox::getLib('parse.output')->clean(Phpfox::getUserBy('full_name')),
					'user_link' => Phpfox::getLib('url')->makeUrl(Phpfox::getUserBy('user_name')),
					'link' => Phpfox::getLib('url')->makeUrl('quiz', array('redirect' => $iItemId))
				)
			);
	}

	public function getActivityPointField()
	{
		return array(
			Phpfox::getPhrase('quiz.quizzes') => 'activity_quiz'
		);
	}

	public function pendingApproval()
	{
		$aPending[] = array(
			'phrase' => Phpfox::getPhrase('quiz.quizzes'),
			'value' => $this->database()->select('COUNT(*)')->from(Phpfox::getT('quiz'))->where('view_id = 1')->execute('getSlaveField'),
			'link' => Phpfox::getLib('url')->makeUrl('quiz', array('view' => 'approval'))
		);		
		
		return $aPending;
	}

	public function getSqlTitleField()
	{
		return array(
			array(
				'table' => 'quiz',
				'field' => 'title'
			),
			array(
				'table' => 'quiz_answer',
				'field' => 'answer'
			),
			array(
				'table' => 'quiz_question',
				'field' => 'question'
			)			
		);
	}	

	public function tabHasItems($iUser)
	{
		$iCount = $this->database()->select('COUNT(user_id)')
				->from($this->_sTable)
				->where('user_id = ' . (int)$iUser)
				->execute('getSlaveField');
		return $iCount > 0;
	}
	/**
	 * If a call is made to an unknown method attempt to connect
	 * it to a specific plug-in with the same name thus allowing 
	 * plug-in developers the ability to extend classes.
	 *
	 * @param string $sMethod is the name of the method
	 * @param array $aArguments is the array of arguments of being passed
	 */
	public function __call($sMethod, $aArguments)
	{
		/**
		 * Check if such a plug-in exists and if it does call it.
		 */
		if ($sPlugin = Phpfox_Plugin::get('quiz.service_callback__call'))
		{
			return eval($sPlugin);
		}
			
		/**
		 * No method or plug-in found we must throw a error.
		 */
		Phpfox_Error::trigger('Call to undefined method ' . __CLASS__ . '::' . $sMethod . '()', E_USER_ERROR);
	}	
}

?>