<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Search
 * @version 		$Id: index.class.php 2013 2010-11-01 13:12:53Z Raymond_Benc $
 */
class Search_Component_Controller_Index extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{		
		Phpfox::getUserParam('search.can_use_global_search', true);
		
		$this->template()->setHeader(array(
				'search.css' => 'style_css'
				)
			)
			->setTitle(Phpfox::getPhrase('search.results'))
			->setBreadcrumb(Phpfox::getPhrase('search.search'), $this->url()->makeUrl('search'));
		
		$bIsTagSearch = false;	
		$sQuery = $this->request()->get('q', null);
		if ($this->request()->get('req2') == 'tag' && $this->request()->get('req3'))
		{
			$sQuery	= $this->request()->get('req3');
			$bIsTagSearch = true;
		}
		
		
		if ($sQuery !== null)
		{		
			if (empty($sQuery))
			{
				Phpfox_Error::set(Phpfox::getPhrase('search.provide_a_search_query'));	
			}
			else 
			{
				$iPageLimit = 10;
				$iTotalResults = 0;					
				$aModuleResults = Phpfox::massCallback('globalSearch', Phpfox::getLib('parse.input')->clean($sQuery), $bIsTagSearch);
				
				$aResults = array();
				$aMenus = array();
				$aForms = array();
				foreach ($aModuleResults as $sModule => $aResult)
				{			
					if ($aResult === null)
					{
						continue;
					}
					
					if (!$aResult['total'])
					{
						continue;
					}
					
					$iTotalResults += $aResult['total'];
					
					$aMenus[] = array(
						'name' => $sModule,
						'total' => $aResult['total'],
						'menu' => $aResult['menu']
					);
					
					$aForms[] = array(
						'name' => $sModule,
						'form' => $aResult['form']
					);
					
					foreach ($aResult['results'] as $aRes)
					{				
						$aRes['module'] = $sModule;
						$aResults[] = $aRes;
					}
				}		
				
				if ($bIsTagSearch === true)
				{
					$this->template()->setBreadcrumb(Phpfox::getPhrase('search.tags'), $this->url()->makeUrl('search'));
				}
		
				$this->template()->setBreadcrumb(Phpfox::getPhrase('search.results_for') . ': ' . $sQuery, '', true)
					->setHeader(array(
							'search.js' => 'module_search',
							'<script type="text/javascript">Phpfox.search.init({limit: ' . $iPageLimit . ', total: ' . count($aResults) . '});</script>',
							'jquery/plugin/jquery.scrollTo.js' => 'static_script'
						)
					)
					->assign(array(
						'aResults' => $aResults,
						'aSearchMenus' => $aMenus,
						'iTotalResults' => $iTotalResults,
						'iPageLimit' => $iPageLimit,
						'iActualCount' => count($aResults),
						'iViewMore' => (count($aResults) - $iPageLimit),
						'aForms' => $aForms,
						'sQuery' => ($bIsTagSearch === true ? '' : Phpfox::getLib('parse.output')->clean($sQuery))
					)
				);
			
			}	
		}		
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('search.component_controller_index_clean')) ? eval($sPlugin) : false);
	}
}

?>