<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Theme
 * @version 		$Id: ajax.class.php 2000 2010-10-29 11:24:24Z Raymond_Benc $
 */
class Theme_Component_Ajax_Ajax extends Phpfox_Ajax
{
	public function sample()
	{
		if (Phpfox::getUserParam('theme.can_view_theme_sample'))
		{
			echo '<iframe src="' . Phpfox::getLib('url')->makeUrl('theme', array('sample', 'get-block-layout' => 'true')) . '" width="1300" height="400" frameborder="0"></iframe>';
		}
	}
	
	public function revertDesign()
	{
		if (Phpfox::getService('theme.process')->revertDesign('profile'))
		{
			$this->call('window.location.href = \'' . Phpfox::getLib('url')->makeUrl('profile.designer') . '\';');
		}
	}
	
	public function deleteCss()
	{
		$aVals = $this->get('val');
		
		if (Phpfox::getService('theme.style.process')->deleteCss($aVals['file_name'], $aVals['style_id'], $aVals['module_id']))
		{
			$iId = '' . $aVals['style_id'] . '_' . str_replace('.', '_', $aVals['file_name']) . '_' . $aVals['module_id'] . '';
			$this->call('editAreaLoader.closeFile(\'js_template_content\', \'' . $iId . '\');')
				->remove('.js_link_cache_' . $iId)
				->call('Phpfox.cssEditor.checkIfAnyOpen(\'' . $iId . '\');');
		}
	}
	
	public function deleteTemplate()
	{
		$aVals = $this->get('val');
		
		if (Phpfox::getService('theme.template.process')->delete($aVals))
		{
			$iId = '' . $aVals['type'] . '_' . $aVals['module'] . '_' . str_replace('.', '_', $aVals['name']) . '';
			$this->call('editAreaLoader.closeFile(\'js_template_content\', \'' . $iId . '\');')
				->remove('.js_link_cache_' . $aVals['type'] . '_' . str_replace('.', '_', $aVals['name']) . '_' . $aVals['module'] . '')
				->call('Phpfox.templateEditor.checkRevertChild();')
				->call('Phpfox.templateEditor.checkIfAnyOpen(\'' . $iId . '\');');
		}		
	}
	
	public function getCssFile($bRevert = false)
	{
		if ($aData = Phpfox::getService('theme.style')->getFile($this->get('style_id'), $this->get('file_name'), $this->get('module_id')))
		{
			if (is_array($aData['modified']))
			{
				$this->call('$(\'#js_last_modified\').show();')
					->hide('.js_theme_last_modified')
					->remove('#modify_' . $aData['id'] . '')
					->call('$(\'#js_last_modified_info\').append(\'<div id="modify_' . $aData['id'] . '" class="js_theme_last_modified extra_info"><i>' . Phpfox::getPhrase('theme.last_modified_time_stamp_by_full_name', array('phpfox_squote' => true, 'time_stamp' => Phpfox::getTime(Phpfox::getParam('core.global_update_time'), $aData['modified']['time_stamp']), 'full_name' => $aData['modified']['full_name'])) . '</i></div>\');');				
				$sProduct = $aData['product_id'];
			}
			else 
			{
				$this->call('$(\'#js_last_modified\').hide();')->hide('.js_theme_last_modified');
				$sProduct = 'phpfox';
			}
			
			if ($aData['is_custom'])
			{
				$this->show('#js_delete_custom');
			}
			else 
			{
				$this->hide('#js_delete_custom');
			}
			
			if ($bRevert)
			{
				$this->call('editAreaLoader.closeFile(\'js_template_content\', \'' . $aData['id'] . '\');');
				$this->call('$(\'.js_link_cache_' . $aData['id'] . '\').removeClass(\'modified\');');			
				$this->call('$(\'#js_last_modified\').hide();')->hide('.js_theme_last_modified');	
			}			
			
			$this->call('editAreaLoader.openFile(\'js_template_content\', {id:\'' . $aData['id'] . '\', text:"' . str_replace('"', '\"', $aData['content']) . '", title:\'' . $aData['title'] . '\'});')
				->hide('#js_template_content_loader')
				->val('#js_css_style_id', $this->get('style_id'))
				->val('#js_css_file', $this->get('file_name'))
				->val('#js_css_module', $this->get('module_id'))
				->remove('#' . $aData['id'])
				->val('#js_template_product_id', $sProduct)
				->call('$(\'#js_theme_cache_info\').append("<div class=\'js_append_theme_layer\' id=\'' . $aData['id'] . '\'>{style_id: \'' . $this->get('style_id') . '\', file: \'' . $this->get('file_name') . '\', module: \'' . $this->get('module_id') . '\', product: \'' . $sProduct . '\', custom: \'' . $aData['is_custom'] . '\'}</div>");')
				->hide('.js_css_ajax_' . str_replace('.', '_', $aData['title']));
		}
	}
	
	public function saveCssFile()
	{
		if (Phpfox::getService('theme.style.process')->update($this->get('val')))
		{
			$this->show('#js_last_modified');	
		}
	}
	
	public function revertCss()
	{		
		$this->set($this->get('val'));
		if (Phpfox::getService('theme.style.process')->revert($this->get('val')))
		{
			$this->getCssFile(true);
		}		
	}
	
	public function getTemplate($bRevert = false)
	{		
		Phpfox::isUser(true);
		Phpfox::getUserParam('admincp.has_admin_access', true);		
		
		$sData = Phpfox::getService('theme.template')->getTemplate($this->get('theme'), $this->get('type'), $this->get('name'), $this->get('module'));
		
		$this->show('#js_content_edit_area');
		
		if (is_array($sData))
		{						
			if ((int) $sData[1] > 0)
			{
				$this->call('$(\'#js_last_modified\').show();')
					->hide('.js_theme_last_modified')
					->remove('#modify_' . $this->get('type') . '_' . $this->get('module') . '_' . str_replace(array('.', '/'), '_', $this->get('name')) . '')					
					->call('$(\'#js_last_modified_info\').append(\'<div id="modify_' . $this->get('type') . '_' . $this->get('module') . '_' . str_replace(array('.', '/'), '_', $this->get('name')) . '" class="js_theme_last_modified extra_info"><i>' . Phpfox::getPhrase('theme.last_modified_time_stamp_by_full_name', array('time_stamp' => Phpfox::getTime(Phpfox::getParam('core.global_update_time'), $sData[1]), 'full_name' => $sData[2])) . '</i></div>\');');
			}
			else 
			{
				$this->call('$(\'#js_last_modified\').hide();')->hide('.js_theme_last_modified');					
			}

			$sProduct = $sData[3];	
			$sCustom = ($sData[4] ? '1' : '0');		
			$sData = $sData[0];					
		}
		else 
		{
			$this->call('$(\'#js_last_modified\').hide();')->hide('.js_theme_last_modified');	
			$sProduct = 'phpfox';
			$sCustom = '0';
		}
		
		$this->call('$("#js_template_type").val("' . $this->get('type') . '");')
			->call('$("#js_template_module").val("' . $this->get('module') . '");')
			->call('$("#js_template_theme").val("' . $this->get('theme') . '");')
			->call('$("#js_template_name").val("' . $this->get('name') . '");')
			->remove('#' . $this->get('type') . '_' . $this->get('module') . '_' . str_replace(array('.', '/'), '_', $this->get('name')) . '')
			->val('#js_template_product_id', $sProduct)
			->call('$(\'#js_theme_cache_info\').append("<div class=\'js_append_theme_layer\' id=\'' . $this->get('type') . '_' . $this->get('module') . '_' . str_replace(array('.', '/'), '_', $this->get('name')) . '\'>{type: \'' . $this->get('type') . '\', module: \'' . $this->get('module') . '\', theme: \'' . $this->get('theme') . '\', name: \'' . $this->get('name') . '\', product: \'' . $sProduct . '\', custom: \'' . $sCustom . '\'}</div>");');
		
		if ($bRevert)
		{
			$this->call('editAreaLoader.closeFile(\'js_template_content\', \'' . $this->get('type') . '_' . $this->get('module') . '_' . str_replace(array('.', '/'), '_', $this->get('name')) . '\');');
			$this->call('$(\'.js_link_cache_' . $this->get('type') . '_' . str_replace(array('.', '/'), '_', $this->get('name')) . '_' . $this->get('module') . '\').removeClass(\'modified\');');
			$this->call('Phpfox.templateEditor.checkRevertChild();');
		}
		$sData = str_replace('\\','\\\\', $sData);
		$this->call('editAreaLoader.openFile(\'js_template_content\', {id:\'' . $this->get('type') . '_' . $this->get('module') . '_' . str_replace(array('.', '/'), '_', $this->get('name')) . '\', text:"' . str_replace('"', '\"', $sData) . '", title:\'' . $this->get('name') . '\'});');
		
		$this->call('$(\'.js_link_cache_' . $this->get('type') . '_' . str_replace(array('.', '/'), '_', $this->get('name')) . '_' . $this->get('module') . '\').find(\'div:first\').hide().removeClass(\'.js_link_cache_' . $this->get('type') . '_' . str_replace(array('.', '/'), '_', $this->get('name')) . '_' . $this->get('module') . '\');')->hide('#js_template_content_loader');
	}
	
	public function updateTemplate()
	{		
		Phpfox::isUser(true);
		Phpfox::getUserParam('admincp.has_admin_access', true);				
		
		if (Phpfox::getService('theme.template.process')->update($this->get('val')))
		{			
			$this->show('#js_last_modified');
		}
	}
	
	public function revert()
	{
		Phpfox::isUser(true);
		Phpfox::getUserParam('admincp.has_admin_access', true);				
		
		$this->set($this->get('val'));
		if (Phpfox::getService('theme.template.process')->revert($this->get('val')))
		{
			$this->getTemplate(true);
		}
	}
	
	public function updateCss()
	{		
		if (Phpfox::getService('theme.process')->updateCss($this->get('type_id'), $this->get('css')))
		{
			$this->attr('#js_save_css_button', 'disabled', false)
				->removeClass('#js_save_css_button', 'disabled')
				->hide('#js_save_css');	
		}
	}
	
	public function updateTheme()
	{		
		if (($mReturn = Phpfox::getService('theme.process')->updateTheme($this->get('type_id'), $this->get('style_id'), $this->get('item_id', null))))
		{
			if (!is_bool($mReturn))
			{
				$this->call($mReturn);				
			}
		}
	}	
	
	public function updateBlock()
	{
		if (Phpfox::getService('theme.process')->updateBlock($this->get('val')))
		{
			
		}
	}	

	public function updateOrder()
	{		
		if (Phpfox::getService('theme.process')->updateOrder($this->get('val')))
		{
			
		}
	}
	
	public function processCss()
	{
		$sCss = $this->get('css');
		
		if ($this->get('save'))
		{
			Phpfox::getService('theme.process')->saveCssCode($this->get('type_id'), $sCss);
		}
		
		$this->remove('#js_cache_temp_style_data');
		
		if (!empty($sCss))
		{
			$this->append('body', '<div id="js_cache_temp_style_data"><style type="text/css">' . Phpfox::getLib('parse.css')->cleanCss($sCss) . '</style></div>');		
		}
		
		$this->attr('.js_save_css_code_button', 'disabled', false)
			->removeClass('.js_save_css_code_button', 'disabled')
			->hide('#js_save_css_code');		
	}
	
	public function updateStyleActivity()
	{
		if (Phpfox::getService('theme.style.process')->updateActivity($this->get('id'), $this->get('active')))
		{
			
		}		
	}
	
	public function updateThemeActivity()
	{
		if (Phpfox::getService('theme.process')->updateActivity($this->get('id'), $this->get('active')))
		{
			
		}	
	}
	
	public function updateStyleDefaultState()
	{
		if (Phpfox::getService('theme.style.process')->setToDefault($this->get('id'), $this->get('active')))
		{
			
		}
	}
}

?>