<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_User
 * @version 		$Id: privacy.class.php 1832 2010-09-21 14:43:50Z Raymond_Benc $
 */
class User_Component_Controller_Privacy extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::isUser(true);
		
		if (!Phpfox::getUserParam('user.can_control_notification_privacy') && !Phpfox::getUserParam('user.can_control_profile_privacy'))
		{
			return Phpfox_Error::display(Phpfox::getPhrase('user.privacy_settings_have_been_disabled_for_your_user_group'));
		}
		
		if (($aVals = $this->request()->getArray('val')))
		{
			if (Phpfox::getService('user.privacy.process')->update($aVals))
			{
				$this->url()->send('user.privacy', null, Phpfox::getPhrase('user.privacy_settings_successfully_updated'));
			}
		}

		list($aUserPrivacy, $aNotifications, $aProfiles) = Phpfox::getService('user.privacy')->get();
		
		$aUserInfo = Phpfox::getService('user')->get(Phpfox::getUserId());
		
		(($sPlugin = Phpfox_Plugin::get('user.component_controller_index_process')) ? eval($sPlugin) : false);
		
		$this->template()->setTitle(Phpfox::getPhrase('user.privacy_settings'))
			->setBreadcrumb(Phpfox::getPhrase('user.privacy_settings'))
			->assign(array(
					'aPrivacyNotifications' => $aNotifications,
					'aProfiles' => $aProfiles,
					'aUserPrivacy' => $aUserPrivacy,
					'aBlockedUsers' => Phpfox::getService('user.block')->get(),
					'aUserInfo' => $aUserInfo
				)
			);		
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('user.component_controller_index_clean')) ? eval($sPlugin) : false);
	}
}

?>