<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package  		Module_Video
 * @version 		$Id: ajax.class.php 2473 2011-03-29 11:09:42Z Miguel_Espinoza $
 */
class Video_Component_Ajax_Ajax extends Phpfox_Ajax
{
	public function addShare()
	{
		$this->errorSet('#js_video_error');
		
		if (($aVals = $this->get('val')))
		{
			if (Phpfox::getService('video.grab')->get($aVals['url']))
			{			
				if ($iId = Phpfox::getService('video.process')->addShareVideo($aVals, true))
				{
					$this->call('Editor.insert({type: \'video\', id: \'' . (int) $iId . '\', editor_id: \'' . $this->get('editor_id') . '\'});');
					$this->setMessage(Phpfox::getPhrase('video.video_successfully_added'));
					
					return;
				}
			}
		}
	}
	
	public function deleteImage()
	{
		Phpfox::isUser(true);
		
		if (Phpfox::getService('video.process')->deleteImage($this->get('id')))
		{
			
		}
	}	

	public function convert()
	{
		$iId = (int)$this->get('video_id');
		$sObjectId = $this->get('fObjectId');
		if (Phpfox::getService('video.convert')->process($iId) == true)
		{
			$this->call("convertCompleted('".$sObjectId."');");
		}
		else
		{
			Phpfox::getService('video.process')->delete($iId);
			$this->call("convertFailed('".$sObjectId."');");
		}
	}

	public function process()
	{
		$this->errorSet('#js_video_upload_message');
		$sModule = $this->get('module', null);
		$iItem = $this->get('item', null);

		$sMethod = Phpfox::getParam('video.video_enable_mass_uploader') && ($this->get('method','default') == 'massuploader');
		
		if ($iId = Phpfox::getService('video.process')->process($this->get('video'), $sModule, $iItem))
		{
			$sVideo = $this->get('video');
			// windows
			if (strpos($sVideo, "\\"))
			{
				$aParts = explode('\\', $sVideo);
				if (isset($aParts[count($aParts) - 1]))
				{
					$sVideo = $aParts[count($aParts) - 1];	
				}
			}
			
			$this
				->attr('#js_view_video_link', 'href', ($sModule !== null && $iItem !== null ? Phpfox::getLib('url')->makeUrl('video', array('redirect' => $iId)) : Phpfox::getService('video')->makeUrl(Phpfox::getUserBy('user_name'), $iId)))
				->show('#js_video_detail')
				->html('#js_upload_file_name', htmlentities(addslashes($sVideo)))
				->val('.js_cache_video_id', $iId)
				->val('#js_video_title', Phpfox::getLib('parse.output')->clean(Phpfox::getLib('parse.input')->clean(preg_replace("/^(.*?)\.(.*?)$/i", "\\1", $sVideo))));
			
			if ($sMethod == 'massuploader')
			{
				$this->call('swfu.addFileParam("'.$this->get('fId').'","video_id",'.$iId.');');
				$this->call('swfu.addFileParam("'.$this->get('fId').'","fObjectId","'.$this->get('fId').'");');
				$this->call('swfu.startUpload();');
			}
			else
			{
				$this->submit('#js_video_form')
					 ->show('#js_video_process')
					 ->hide('#js_upload_inner_form');
			}
		}
		else 
		{
			$this->show('#js_video_upload_error');
		}
	}
	
	public function update()
	{
		$aVals = $this->get('val');
		
		if (!isset($aVals['video_id']))
		{
			return Phpfox_Error::set(Phpfox::getPhrase('video.unable_to_edit_this_video_as_there_is_no_video_id'));
		}		

		Phpfox::getService('ban')->checkAutomaticBan($aVals['title'] . ' ' . $aVals['text'] . ' ' . $aVals['tag_list']);
		if ($mReturn = Phpfox::getService('video.process')->update($aVals['video_id'], $aVals))
		{			
			if (!is_bool($mReturn))
			{
				$aVideo = Phpfox::getService('video')->getVideo($aVals['video_id'], true);
				
				$this->attr('#js_view_video_link', 'href', ($aVideo['module_id'] != 'video' ? Phpfox::getLib('url')->makeUrl('video', array('redirect' => $aVideo['video_id'])) : Phpfox::getService('video')->makeUrl(Phpfox::getUserBy('user_name'), $mReturn)));
			}
			
			$this->show('#js_save_video')->html('#js_save_video', '<span class="valid_message">'.Phpfox::getPhrase('video.done').'</span>', '.fadeOut(5000)');
		}
		else 
		{
			$this->html('#js_save_video', '');
		}
		
		$this->attr('#js_save_button', 'disabled', false)
			->removeClass('#js_save_button', 'disabled');
	}
	
	public function edit()
	{
		Phpfox::isUser(true);
		
		if (Phpfox::getService('user.auth')->hasAccess('video', 'video_id', $this->get('video_id'), 'video.can_edit_own_video', 'video.can_edit_other_video'))
		{		
			$aVideo = Phpfox::getService('video')->getForEdit($this->get('video_id'));
			
			echo '<div><input type="hidden" name="val[video_id]" value="' . $aVideo['video_id'] . '" /></div>';
			echo '<div><input type="hidden" name="val[user_name]" value="' . $aVideo['user_name'] . '" /></div>';
			$this->template()->assign(array(
						'aForms' => $aVideo,
						'sCategories' => Phpfox::getService('video.category')->get(),
						'sModule' => isset($aVideo['module_id']) ? $aVideo['module_id'] : ''
					)
				)		
				->getTemplate('video.block.form');
			
			$this->html('#js_video_edit_form', $this->getContent(false))
				->show('#js_video_edit_form_outer')
				->attr('#js_video_go_advanced', 'href', Phpfox::getLib('url')->makeUrl('video.edit', array('id' => $aVideo['video_id'])))
				->hide('#js_video_outer_body')
				->call('Phpfox.loadInit();')
				->call('var aCategories = explode(\',\', \'' . $aVideo['categories'] . '\'); for (i in aCategories) { $(\'#js_mp_holder_\' + aCategories[i]).show(); $(\'#js_mp_category_item_\' + aCategories[i]).attr(\'selected\', true); }');
		}
	}
	
	public function viewUpdate()
	{
		$aVals = $this->get('val');
		
		if (!isset($aVals['video_id']))
		{
			return Phpfox_Error::set(Phpfox::getPhrase('video.unable_to_edit_this_video_as_there_is_no_video_id'));
		}		
		
		if ($mReturn = Phpfox::getService('video.process')->update($aVals['video_id'], $aVals))
		{
			$oParseInput = Phpfox::getLib('parse.input');
			$oParseOutput = Phpfox::getLib('parse.output');
			
			if (isset($aVals['is_inline']))
			{
				$aVideo = Phpfox::getService('video')->getForEdit($aVals['video_id']);
				
				$this->call('window.location.href = \'' . $aVideo['video_url'] . '\';');
				
				return;
			}
			
			if (!is_bool($mReturn))
			{
				$this->attr('.js_video_title_' . $aVals['video_id'], 'href', Phpfox::getService('video')->makeUrl($aVals['user_name'], $mReturn));
			}			
			
			$this->hide('#js_video_edit_form_outer')
				->html('#js_video_title_' . $aVals['video_id'], $oParseOutput->clean($oParseInput->clean($aVals['title'])))
				->html('#js_video_text_' . $aVals['video_id'], (empty($aVals['text']) ? '' : $oParseOutput->parse($oParseInput->prepare($aVals['text']))))
				->show('#js_video_outer_body');
		}					
	}
	
	public function delete()
	{
		if (Phpfox::getService('video.process')->delete($this->get('video_id')))
		{
			$this->remove('#js_video_id_' . $this->get('video_id'));	
		}
	}
	
	public function add()
	{
		$aParam = array();
		if ($this->get('bIsGroup'))
		{
			$aParam['bIsGroup'] = true;
		}
		if (!Phpfox::getParam('video.allow_video_uploading') || !Phpfox::getUserParam('video.can_upload_videos'))
		{
			Phpfox::getComponent('video.share', $aParam, 'controller');
		}
		else 
		{
			Phpfox::getComponent('video.upload', $aParam, 'controller');
		}
		
		echo $this->template()->getHeader();
		
		echo '<script type="text/javascript">Phpfox.loadInit();</script>';
	}
	
	public function upload()
	{		
		Phpfox::getComponent('video.upload', array('bHideSwitchMenu' => true), 'controller');	
		
		echo $this->template()->getHeader();
		
		echo '<script type="text/javascript">Phpfox.loadInit();</script>';	
		
		$this->html('#js_video_content', $this->getContent(false));
	}
	
	public function share()
	{
		Phpfox::getComponent('video.share', array(), 'controller');		
		
		echo $this->template()->getHeader();
		
		echo '<script type="text/javascript">Phpfox.loadInit();</script>';	
		
		$this->html('#js_video_content', $this->getContent(false));
	}
	
	public function getNew()
	{
		Phpfox::getBlock('video.new');
		
		$this->html('#' . $this->get('id'), $this->getContent(false));
		$this->call('$(\'#' . $this->get('id') . '\').parents(\'.block:first\').find(\'.bottom li a\').attr(\'href\', \'' . Phpfox::getLib('url')->makeUrl('video') . '\');');
	}
	
	public function feature()
	{
		if (Phpfox::getService('video.process')->feature($this->get('video_id'), $this->get('type')))
		{
			
		}
	}
	
	public function spotlight()
	{
		if (Phpfox::getService('video.process')->spotlight($this->get('video_id'), $this->get('type')))
		{
			
		}		
	}

	public function sponsor()
	{
	    Phpfox::getUserParam('video.can_sponsor_video', true);
	    if (Phpfox::getService('video.process')->sponsor($this->get('video_id'), $this->get('type')))
	    {
		if ($this->get('type') == '1')
		{
		    Phpfox::getService('ad.process')->addSponsor(array('module' => 'video', 'section' => '', 'item_id' => $this->get('video_id')));
		    // image was sponsored
		    $sHtml = '<a href="#" title="' . Phpfox::getPhrase('video.unsponsor_this_video') . '" onclick="$.ajaxCall(\'video.sponsor\', \'video_id=' . $this->get('video_id') . '&amp;type=0\'); return false;"><img src="' . $this->template()->getStyle('image', 'misc/medal_gold_delete.png') . '" alt="'.Phpfox::getPhrase('video.unsponsor_this_video').'" width="16" height="16" /></a>';
		}
		else
		{
		    Phpfox::getService('ad.process')->deleteAdminSponsor('video', $this->get('video_id'));
		    $sHtml = '<a href="#" title="' . Phpfox::getPhrase('video.sponsor_this_video') . '" onclick="$.ajaxCall(\'video.sponsor\', \'video_id=' . $this->get('video_id') . '&amp;type=1\'); return false;"><img src="' . $this->template()->getStyle('image', 'misc/medal_gold_add.png') . '" alt="'.Phpfox::getPhrase('video.sponsor_this_video').'" width="16" height="16" /></a>';
		}
		$this->html('#js_video_sponsor_' . $this->get('video_id'), $sHtml)
			->alert($this->get('type') == '1' ? Phpfox::getPhrase('video.video_successfully_sponsored') : Phpfox::getPhrase('video.video_successfully_un_sponsored'));
		if($this->get('type') == '1')
		{
		    $this->addClass('#js_video_id_' . $this->get('video_id'), 'row_sponsored');
		}
		else
		{
		    $this->removeClass('#js_video_id_' . $this->get('video_id'), 'row_sponsored');
		}
	    }
	}
	
	public function approve()
	{
		if (Phpfox::getService('video.process')->approve($this->get('video_id')))
		{
			
		}
	}
}

?>