<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: controller.class.php 103 2009-01-27 11:32:36Z Raymond_Benc $
 */
class Video_Component_Controller_Frame extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		if (!Phpfox::isUser())
		{
			exit;
		}

		if (!Phpfox::getParam('video.allow_video_uploading'))
		{
			exit;
		}

		if (!Phpfox::getUserParam('video.can_upload_videos'))
		{
			exit;
		}
		$bMassUploader = Phpfox::getParam('video.video_enable_mass_uploader') && (isset($_POST['sMethod']) && $_POST['sMethod'] == 'massuploader');
		if (isset($_FILES['Filedata']) && !isset($_FILES['video']))
		{
			$_FILES['video'] = $_FILES['Filedata'];
		}
		if (!isset($_FILES['video']))
		{
			Phpfox::getService('video.process')->delete();
			echo '<script type="text/javascript">';
			echo 'window.parent.document.getElementById(\'js_video_upload_error\').style.display = \'block\';';
			echo 'window.parent.document.getElementById(\'js_video_upload_message\').innerHTML = \''.Phpfox::getPhrase('video.upload_failed_file_is_too_large').'\';';
			echo 'window.parent.document.getElementById(\'js_upload_inner_form\').style.display = \'block\';';
			echo 'window.parent.document.getElementById(\'js_video_detail\').style.display = \'none\';';
			echo 'window.parent.document.getElementById(\'js_video_process\').style.display = \'none\';';
			echo '</script>';
			exit;
		}
		
		if (($iFlood = Phpfox::getUserParam('video.flood_control_videos')) !== 0)
		{
			$aFlood = array(
				'action' => 'last_post', // The SPAM action
				'params' => array(
					'field' => 'time_stamp', // The time stamp field
					'table' => Phpfox::getT('video'), // Database table we plan to check
					'condition' => 'view_id = 0 AND user_id = ' . Phpfox::getUserId(), // Database WHERE query
					'time_stamp' => $iFlood * 60 // Seconds);	
				)
			);
							 			
			// actually check if flooding
			if (Phpfox::getLib('spam')->check($aFlood))
			{
				Phpfox_Error::set(Phpfox::getPhrase('video.you_are_uploading_a_video_a_little_too_soon') . ' ' . Phpfox::getLib('spam')->getWaitTime());	
			}
		}

		if (!Phpfox_Error::isPassed())
		{
			Phpfox::getService('video.process')->delete();
			echo '<script type="text/javascript">';
			echo 'window.parent.document.getElementById(\'js_video_upload_error\').style.display = \'block\';';
			echo 'window.parent.document.getElementById(\'js_video_upload_message\').innerHTML = \'' . implode('<br />', Phpfox_Error::get()) . '\';';
			echo 'window.parent.document.getElementById(\'js_upload_inner_form\').style.display = \'block\';';
			echo 'window.parent.document.getElementById(\'js_video_detail\').style.display = \'none\';';
			echo 'window.parent.document.getElementById(\'js_video_process\').style.display = \'none\';';
			echo '</script>';
			exit;				
		}

		if ($iId = Phpfox::getService('video.process')->add($this->request()->get('video_id')))
		{
			if ($bMassUploader)
			{
				echo 'uploadCompleted('.$iId.', "'.$this->request()->get('fObjectId').'");';
			}
			else
			{
				$this->url()->send('video.convert', array('id' => $iId, 'editor-id' => base64_encode($this->request()->get('editor_id')), 'isajax' => $this->request()->get('is_ajax', '0')));
			}
		}
		else 
		{
			Phpfox::getService('video.process')->delete($this->request()->get('video_id'));
			echo '<script type="text/javascript">';
			echo 'window.parent.document.getElementById(\'js_video_upload_error\').style.display = \'block\';';			
			echo 'window.parent.document.getElementById(\'js_video_upload_message\').innerHTML = \'' . implode('<br />', Phpfox_Error::get()) . '\';';
			echo 'window.parent.document.getElementById(\'js_upload_inner_form\').style.display = \'block\';';
			echo 'window.parent.document.getElementById(\'js_video_detail\').style.display = \'none\';';
			echo 'window.parent.document.getElementById(\'js_video_process\').style.display = \'none\';';
			echo '</script>';			
		}

		exit;
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('video.component_controller_frame_clean')) ? eval($sPlugin) : false);
	}
}

?>