<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: upload.class.php 2485 2011-03-31 11:43:11Z Raymond_Benc $
 */
class Video_Component_Controller_Upload extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::isUser(true);
	
		$sModule = $this->request()->get('module', false);
		$iItem =  $this->request()->getInt('item', false);		
		
		if ($sModule !== false && $iItem !== false && Phpfox::hasCallback($sModule, 'uploadVideo'))
		{
			$aCallback = Phpfox::callback($sModule . '.uploadVideo', $iItem);			
		}		
		
		if (!Phpfox::getParam('video.allow_video_uploading'))
		{
			if ($sModule != false)
			{
				$this->url()->send('video.share', array('module' => $sModule, 'item' => $iItem));	
			}
			$this->url()->send('video.share');
		}
		
		Phpfox::getUserParam('video.can_upload_videos', true);		
		
		if ($aVals = $this->request()->get('val'))
		{
			if ($oValidator->isValid($aVals))
			{
				if ($sTitle = Phpfox::getService('video.process')->add($aVals))
				{
					$this->url()->forward(Phpfox::getService('video')->makeUrl(Phpfox::getUserBy('user_name'), $sTitle), Phpfox::getPhrase('video.video_successfully_uploaded'));
				}
			}
		}		

		$sMethod = Phpfox::getParam('video.video_enable_mass_uploader') && $this->request()->get('method','') != 'simple' ? 'massuploader' : 'simple';
		if ($sMethod == 'massuploader')
		{
			$iMaxFileSize = (Phpfox::getUserParam('video.video_file_size_limit') === 0 ? null : ((Phpfox::getUserParam('video.video_file_size_limit') / 1) * 1048576));
			$this->template()->setHeader('cache', array(
					'massuploader/swfupload.js' => 'static_script',
					'<script type="text/javascript">
							function setSWFUSettings()
							{								
								swfu.setButtonDimensions(' . (strlen(Phpfox::getPhrase('video.select_a_video_to_upload')) * 5) . ',20);
								swfu.setUploadURL("' . $this->url()->makeUrl('video.frame') . '");
								swfu.setFileSizeLimit("' . $iMaxFileSize . ' B");
								swfu.setFileUploadLimit(1);
								swfu.setFileQueueLimit(1);
								swfu.customSettings.progress_target = "js_progress_bar";
								swfu.customSettings.cookie = [];
								swfu.customSettings.flash_user_id = ' . Phpfox::getUserId() . ';
								swfu.customSettings.sAjaxCall = "";
								swfu.customSettings.sHash = "' . Phpfox::getService('core')->getHashForUpload() . '";
								swfu.customSettings.bDelayUpload = true;
								swfu.setFileTypes("*.mpg; *.mpeg; *.wmv; *.avi; *.mov; *.flv","Video files (mpg, mpeg, wmv, avi, mov or flv)");
								swfu.atFileQueue = function(fObject)
								{
									$(\'#swfUploadText\').hide();
									$(\'#js_video_form\').ajaxCall(\'video.process\',\'video=\'+fObject.name+\'&fId=\'+fObject.id);
								};
								swfu.setDebugEnabled(true);
							}
							</script>',
						'massuploader/upload.js' => 'static_script',
						'progress.css' => 'style_css'
					)
				)
				->setPhrase(array(
					'photo.you_can_upload_a_jpg_gif_or_png_file',
					'core.name',
					'core.status',
					'core.in_queue',
					'core.upload_failed_your_file_size_is_larger_then_our_limit_file_size',
					'core.more_queued_than_allowed'
				)
			);
		}

		$this->template()->setTitle(Phpfox::getPhrase('video.upload_a_video'))
			->setBreadcrumb(Phpfox::getPhrase('video.videos'), $this->url()->makeUrl('video'))
			->setBreadcrumb(Phpfox::getPhrase('video.upload_a_video'), null, true)
			->setHeader('cache', array(
					'upload.js' => 'module_video',
					'video.js' => 'module_video'
				)
			)
			->setHeader(array('<script type="text/javascript">oParams["sMethod"] = "'.$sMethod .'";</script>'))
			->assign(array(
					'iUploadLimit' => Phpfox::getLib('file')->getLimit(Phpfox::getUserParam('video.video_file_size_limit')),
					'sFileExt' => Phpfox::getService('video')->getFileExt(true),
					'sCategories' => Phpfox::getService('video.category')->get(),
					'sModule' => $sModule,
					'iItem' => $iItem,
					'sEditorId' => $this->request()->get('editor_id'),
					'sMethod' => $sMethod,
					'sMassPath' => $this->url()->makeUrl('video.upload', array('method' => 'simple'))
				)
			);
			
		if (PHPFOX_IS_AJAX)
		{
			$this->template()
				->assign(array(
						'bHideSwitchMenu' => $this->getParam('bHideSwitchMenu', false)						
					)
				)
				->setHeader(array(
					'switch_legend.js' => 'static_script',
					'switch_menu.js' => 'static_script'		
				)
			);
		}
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('video.component_controller_upload_clean')) ? eval($sPlugin) : false);
	}
}

?>