<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');

/**
 * 
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author  		Raymond Benc
 * @package 		Phpfox_Component
 * @version 		$Id: controller.class.php 103 2009-01-27 11:32:36Z Raymond_Benc $
 */
class Video_Component_Controller_View extends Phpfox_Component
{
	/**
	 * Class process method wnich is used to execute this component.
	 */
	public function process()
	{
		Phpfox::getUserParam('video.can_access_videos', true);
		
		$aCallback = $this->getParam('aCallback', false);
		
		$sVideo = $this->request()->get(($aCallback !== false ? $aCallback['request'] : 'req3'));		
		
		if (!($aVideo = Phpfox::getService('video')->callback($aCallback)->getVideo($sVideo)))
		{
			return Phpfox_Error::display(Phpfox::getPhrase('video.the_video_you_are_looking_for_does_not_exist_or_has_been_removed'));
		}		
		
		if (Phpfox::isModule('track') && Phpfox::isUser() && Phpfox::getUserId() != $aVideo['user_id'] && !$aVideo['video_is_viewed'])
		{
			Phpfox::getService('track.process')->add('video', $aVideo['video_id']);
		}		
		
		if (Phpfox::isModule('notification') && $aVideo['user_id'] == Phpfox::getUserId())
		{
			Phpfox::getService('notification.process')->delete('video_approved', $aVideo['video_id'], Phpfox::getUserId());
			Phpfox::getService('notification.process')->delete('video_notifyLike', $aVideo['video_id'], Phpfox::getUserId());
		}		
		
		if ($aVideo['user_id'] == Phpfox::getUserId())
		{
			Phpfox::getService('video.process')->isViewed($aVideo['video_id']);
			Phpfox::getService('notification.process')->delete('comment_video', $aVideo['video_id'], Phpfox::getUserId());
		}		
		
		$this->setParam('aVideo', $aVideo);
		$this->setParam('sGroup', ($this->request()->get('req1') == 'group') ? $this->request()->get('req2') : '');
		$this->setParam('aRatingCallback', array(
				'type' => 'video',
				'total_rating' => Phpfox::getPhrase('video.total_rating_ratings', array('total_rating' => $aVideo['total_rating'])),//$aVideo['total_rating'] . ' Ratings',
				'default_rating' => $aVideo['total_score'],
				'item_id' => $aVideo['video_id'],
				'stars' => array(
					'2' => Phpfox::getPhrase('video.poor'),
					'4' => Phpfox::getPhrase('video.nothing_special'),
					'6' => Phpfox::getPhrase('video.worth_watching'),
					'8' => Phpfox::getPhrase('video.pretty_cool'),
					'10' => Phpfox::getPhrase('video.awesome')
				)
			)
		);		
		
		$this->template()->setTitle($aVideo['title'])
			->setTitle(Phpfox::getPhrase('video.videos'))
			->setBreadcrumb(Phpfox::getPhrase('video.videos'), ($aCallback === false ? $this->url()->makeUrl('video') : $this->url()->makeUrl($aCallback['url'][0], array_merge($aCallback['url'][1], array('video')))))
			->setBreadcrumb($aVideo['title'], null, true)
			->setMeta('description', $aVideo['title'] . '.' . (!empty($aVideo['text']) ? $aVideo['text'] : ''))
			->setMeta('keywords', $this->template()->getKeywords($aVideo['title']))
			->setPhrase(array(
					'rate.thanks_for_rating'			
				)
			)
			->setHeader('cache', array(
					'video.js' => 'module_video',
					'rate.js' => 'module_rate',					
					'jquery/plugin/jquery.highlightFade.js' => 'static_script',	
					'jquery/plugin/jquery.scrollTo.js' => 'static_script',
					'quick_edit.js' => 'static_script',
					'comment.css' => 'style_css',
					'pager.css' => 'style_css',
					'switch_legend.js' => 'static_script',
					'switch_menu.js' => 'static_script',
					'video.css' => 'module_video'		
				)
			)
			->setEditor(array(
					'load' => 'simple'
				)
			)
			->assign(array(
					'aVideo' => $aVideo
				)
			);
			
			(($sPlugin = Phpfox_Plugin::get('video.component_controller_view_end')) ? eval($sPlugin) : false);
			
			if (Phpfox::isModule('rate'))
			{
				$this->template()->setHeader(array(
						'<script type="text/javascript">$(function() { Phpfox.rate.init({display: ' . ($aVideo['has_rated'] ? 'false' : ($aVideo['user_id'] == Phpfox::getUserId() ? 'false' : 'true')) . ', error_message: \'' . ($aVideo['has_rated'] ? Phpfox::getPhrase('video.you_have_already_voted', array('phpfox_squote' => true)) : Phpfox::getPhrase('video.you_cannot_rate_your_own_video', array('phpfox_squote' => true))) . '\'}); });</script>',
						'<script type="text/javascript">$(function() { $(\'#menu ul li a:first\').addClass(\'first\'); });</script>'
					)
				);			
			}			
			
			if (!$aVideo['is_stream'])
			{
				$sVideoPath = (preg_match("/\{file\/videos\/(.*)\/(.*)\.flv\}/i", $aVideo['destination'], $aMatches) ? Phpfox::getParam('core.path') . str_replace(array('{', '}'), '', $aMatches[0]) : Phpfox::getParam('video.url') . $aVideo['destination']);
				if (Phpfox::getParam('core.allow_cdn') && !empty($aVideo['server_id']))
				{
					//$sVideoPath = Phpfox::getLib('cdn')->getUrl($sVideoPath);
					$sTempVideoPath = Phpfox::getLib('cdn')->getUrl($sVideoPath);
					if (!empty($sTempVideoPath))
					{
						$sVideoPath = $sTempVideoPath;
					}
				}
				
				$this->template()->setHeader(array(
						'player/' . Phpfox::getParam('core.default_music_player') . '/phpfox.js' => 'static_script',
						'<script type="text/javascript">$(function() { Phpfox.player.load({id: \'js_video_player\', auto: true, type: \'video\', play: \'' . $sVideoPath . '\'}); });</script>'
					)
				);
			}
			
			if (isset($aVideo['breadcrumb']) && is_array($aVideo['breadcrumb']))
			{
				foreach ($aVideo['breadcrumb'] as $aParentCategory)
				{
					if (isset($aParentCategory[0]))
					{
						$this->template()->setMeta('description', $aParentCategory[0]);
						$this->template()->setMeta('keywords', $this->template()->getKeywords($aParentCategory[0]));
					}
				}
			}
	}
	
	/**
	 * Garbage collector. Is executed after this class has completed
	 * its job and the template has also been displayed.
	 */
	public function clean()
	{
		(($sPlugin = Phpfox_Plugin::get('video.component_controller_view_clean')) ? eval($sPlugin) : false);
	}
}

?>