<?php 
/**
 * [PHPFOX_HEADER]
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author			Raymond Benc
 * @package 		Phpfox
 * @version 		$Id: template.html.php 2481 2011-03-31 09:19:11Z Raymond_Benc $
 */
 
defined('PHPFOX') or exit('NO DICE!'); 

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="{$sLocaleDirection}" lang="{$sLocaleCode}">
	<head>
		<title>{title}</title>	
	{header}
	</head>
	<body>	
		<div id="global_ajax_message"></div>
		<div id="top">
			<div id="top_left">
			{if !Phpfox::getParam('core.branding')}			
				<a href="{url link="admincp"}">{img theme='layout/logo.jpg' alt=''}</a>
				{else}
				<a href="{url link="admincp"}">{param var='core.site_title'}</a>
			{/if}
			</div>
			<div id="top_right">
				{phrase var='admincp.logged_in_as' user=$aUserDetails}<span class="separator">|</span><a href="{url link=""}">{phrase var='admincp.view_site'}</a>
				{if !Phpfox::getUserBy('fb_user_id')}
				<span class="separator">|</span><a href="{url link='admincp.logout'}">{phrase var='admincp.logout'}</a>
				{/if}
			</div>
			<div class="clear"></div>
		</div>
		<div id="menu_outer">
			<div id="menu">
				<div class="menu horizontal">
					<ul>
					{foreach from=$aAdminMenus key=sPhrase item=sLink}
						{if is_array($sLink)}
						{if count($sLink)}
						<li><a href="#" class="isMenu">{phrase var=$sPhrase}</a>
							<ul>
							{foreach from=$sLink key=sPhrase2 item=sLink2}
								{if is_array($sLink2)}
								{if count($sLink2)}
								<li><a href="#" class="is_sub_menu">{phrase var=$sPhrase2}</a>
								<ul>
									{foreach from=$sLink2 key=sPhrase3 item=sLink3}
									<li><a href="{url link=""$sLink3""}">{phrase var=$sPhrase3}</a></li>
									{/foreach}	
								</ul>
								</li>
								{/if}
								{else}
								<li><a href="{url link=""$sLink2""}">{phrase var=$sPhrase2}</a></li>
								{/if}
							{/foreach}	
							</ul>
						</li>
						{/if}
						{else}
						<li><a href="{url link=""$sLink""}">{phrase var=$sPhrase}</a></li>
						{/if}
					{/foreach}
					{if is_array($aModulesMenu) && count($aModulesMenu)}
						<li><a href="#" class="isMenu">{phrase var='admincp.modules'}</a>
							<ul>
							{foreach from=$aModulesMenu item=aModule}
								<li><a href="{url link="admincp."$aModule.url_name""}"{if $aModule.menu} class="is_sub_menu"{else}{/if}>{translate var=$aModule.module_id prefix='module'}</a>
								{if $aModule.menu}
								<ul>
								{foreach from=$aModule.menu key=sMenuName item=aMenu}
									<li><a href="{url link="admincp."$aMenu.url""}">{phrase var=$sMenuName}</a></li>
								{/foreach}
								</ul>
								{/if}
								</li>
							{/foreach}
							</ul>
						</li>
					{/if}
					</ul>
					<div class="clear"></div>
				</div>
			</div>
		</div>			
		<div class="colmask leftmenu" id="js_content_container">
			<div class="colleft">
				<div id="main" class="col1">
					{if isset($aMaxHistory) && count($aMaxHistory)}		
					<div id="hosting_info">
						<div id="hosting_info_title">
							{phrase var='core.limit_warning'}							
						</div>			
						<div id="hosting_info_message">
							{phrase var='core.your_website_has_surpassed_its_limit_on_how_many_active'}
						</div>
						<div class="table_header">
							{phrase var='core.online_usage_log'}
						</div>
						<div class="label_flow" style="height:100px;">
							<table cellpadding="0" cellspacing="0">
								<tr>
									<th>{phrase var='core.timestamp'}</th>
									<th>{phrase var='core.users'}</th>
								</tr>					
							{foreach from=$aMaxHistory name=maxhistory item=aMaxHistory}
								<tr{if is_int($phpfox.iteration.maxhistory/2)} class="tr"{/if}>
									<td>{$aMaxHistory.time_stamp|date:'core.extended_global_time_stamp'}</td>
									<td>{$aMaxHistory.total}</td>
								</tr>					
							{/foreach}
							</table>
						</div>
					</div>
					{/if}
					{if $iBreadTotal = count($aBreadCrumbs)}<h1>{foreach from=$aBreadCrumbs key=sLink item=sCrumb name=link}{if !empty($sLink)}<a href="{$sLink}">{/if}{$sCrumb|clean}{if !empty($sLink)}</a>{/if}{if $iBreadTotal != $phpfox.iteration.link} &raquo; {/if}{/foreach}</h1>{/if}{if count($aBreadCrumbTitle)}<h2>&raquo; <a href="{$aBreadCrumbTitle[1]}">{$aBreadCrumbTitle[0]|clean}</a></h2>{/if}
					{if isset($bIsModuleConnection) && $bIsModuleConnection}
					<div id="breadcrumb_holder">
						<div id="breadcrumb_position">
							<ul id="breadcrumb_menu">
							{foreach from=$aActiveMenus key=sPhrase item=sLink}
								<li{if $sMenuController == $sLink} class="active"{/if}><a href="{url link=$sLink}">{phrase var=$sPhrase}</a></li>
							{/foreach}
							</ul>
							<div class="clear"></div>
						</div>
					</div>
					{/if}
					{error}
					<div style="margin-top:10px;">										
						{content}						
					</div>
				</div>
				<div id="sidebar" class="col2 js_content_parent">		
				{if isset($aCachedSubMenus)}
				{foreach from=$aCachedSubMenus key=sSubName item=mCachedSubMenus}
					<div class="sidebar_group{if $sSubName == $sActiveSideBar} sidebar_active{/if}">
						<div class="sidebar_header">
							{if $bIsModuleConnection}{$sSubName|translate:'module'}{else}{phrase var=$sSubName}{/if}
						</div>
						<ul class="sidebar_menu">
						{foreach from=$mCachedSubMenus key=sPhraseName item=mCachedSubMenu}
							<li><a href="{url link=$mCachedSubMenu}">{phrase var=$sPhraseName}</a></li>
						{/foreach}
						</ul>
					</div>
				{/foreach}
				{/if}
				{if isset($bIsDashboard)}
				{block location='1'}
				{/if}
				</div>
			</div>
		</div>		
		<div class="clear"></div>	
		<div id="copyright">
			{branding}
		</div>		
		{footer}
		<script type="text/javascript">
			Phpfox.init();
		</script>	
		{plugin call='theme_template_body__end'}	
	</body>
</html>