<?php 
/**
 * [PHPFOX_HEADER]
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author			Raymond Benc
 * @package 		Phpfox
 * @version 		$Id: template.html.php 2049 2010-11-02 20:20:01Z Raymond_Benc $
 */
 
defined('PHPFOX') or exit('NO DICE!'); 

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="{$sLocaleDirection}" lang="{$sLocaleCode}">
	<head>
		<title>{title}</title>	
		{header}
	</head>
	<body>
	{plugin call='theme_template_body__start'}
	{if Phpfox::getParam('core.site_is_offline')}
		<div id="site_offline">
			<a href="{url link='admincp.setting.edit.group-id_site_offline_online'}">{phrase var='core.the_site_is_currently_in_offline_mode'}</a>
		</div>
	{/if}
		{module name='theme.design'}
		{module name='core.footer'}
		<div id="header_holder">
			{block location='9'}
			<div id="header" class="body_width_holder">			
				<div id="top_nav_holder">
					<div id="top_nav">
						{block location='10'}								
					</div>								
				</div>				
				<div id="logo_holder">
					<div id="logo_corner">&nbsp;</div>
					<div id="logo">
						{if !empty($sStyleLogo)}
						<div id="custom_logo"><a href="{url link=''}"><img src="{$sStyleLogo}" alt="{param var='core.site_title'}" /></a></div>
						{else}
						<div class="logo"><a href="{url link=''}">{param var='core.site_title'}</a></div>
						{/if}
						<div id="banner">
							<div id="top_nav_search_holder">
								<div id="top_nav_search">
									<form method="post" action="{url link='search'}">
										<div>
											<input type="text" name="q" value="{phrase var='core.search'}" onclick="if (this.value == '{phrase var='core.search' phpfox_squote=true}') this.value = '';" onblur="if (this.value == '') this.value = '{phrase var='core.search' phpfox_squote=true}';" id="search_field" />
											<input type="submit" value="" id="search_button" />
										</div>
									</form>
								</div>							
							</div>
							<div id="banner_holder">
								{block location='6'}
							</div>	
						</div>
						<div class="clear"></div>						
					</div>						
				</div>				
				<div id="navigation">
					<div id="right_nav">				
						<ul>
							{foreach from=$aRightMenus key=iKey item=aMenu}
								<li{if isset($aMenu.is_selected)} class="active"{/if}><a href="{url link=$aMenu.url}">{phrase var=$aMenu.module'.'$aMenu.var_name}</a>
								{if isset($aMenu.children) && count($aMenu.children)}
								<ul>
									{foreach from=$aMenu.children item=aChild name=child_menu}
									<li{if $phpfox.iteration.child_menu == 1} class="first"{/if}><a href="{url link=$aChild.url}">{phrase var=$aChild.module'.'$aChild.var_name}</a></li>
									{/foreach}
								</ul>
								{/if}
								</li>
							{/foreach}
							{unset var=$aRightMenus var2=$aMenu var3=$iKey}
						</ul>				
					</div>
				</div>						
				<ul id="main_nav">
					{foreach from=$aMenus key=iKey item=aMenu}
						<li{if isset($aMenu.is_selected)} class="active"{/if}><a href="{url link=$aMenu.url}">{phrase var=$aMenu.module'.'$aMenu.var_name}{if isset($aMenu.suffix)}{$aMenu.suffix}{/if}</a>
						{if isset($aMenu.children) && count($aMenu.children)}
						<ul>
							{foreach from=$aMenu.children item=aChild name=child_menu}
							<li{if $phpfox.iteration.child_menu == 1} class="first"{/if}><a href="{url link=$aChild.url}">{phrase var=$aChild.module'.'$aChild.var_name}</a></li>
							{/foreach}
						</ul>
						{/if}
						</li>
					{/foreach}
					{unset var=$aMenus var2=$aMenu var3=$iKey}
					{if count($aAppMenus)}
					<li class="explore"><a href="#" onclick="return false;">{phrase var='core.explore'}</a>					
						<ul>
						{foreach from=$aAppMenus key=iAppKey item=aAppMenu name=app_menu}
							<li{if $phpfox.iteration.app_menu == 1} class="first"{/if}><a href="{url link=$aAppMenu.url}"{if isset($aAppMenu.module_image)} style="background-image:url('{$aAppMenu.module_image}');"{/if}>{phrase var=$aAppMenu.module'.'$aAppMenu.var_name}</a>
							{if isset($aAppMenu.children) && count($aAppMenu.children)}
								<ul>
									{foreach from=$aAppMenu.children item=aAppChild}
									<li><a href="{url link=$aAppChild.url}">{phrase var=$aAppChild.module'.'$aAppChild.var_name}</a></li>
									{/foreach}
								</ul>
							{/if}
							</li>
						{/foreach}
						</ul>					
					</li>	
					{/if}			
				</ul>						
				<div class="clear"></div>				
			</div>			
		</div>		
		<div id="content_container" class="body_width_holder">				
			<div class="inner">
			  	{nomoreie}			
				{block location='7'}								
				{if $bIsUsersProfilePage}
					{module name='profile.header'}
				{/if}					
				<div id="js_content_container">		
					
					{if !$bUseFullSite && (count($aBlocks1) || count($aBlocks3) || count($aSubMenus) || count($aAdBlocks1) || count($aAdBlocks3))}						
					<div id="sidebar" class="js_content_parent">
						{block location='3'}							
						{if !$bIsUsersProfilePage && count($aSubMenus)}
						<div id="menu">
							<ul>
							{foreach from=$aSubMenus key=iKey name=submenu item=aSubMenu}
								<li><a href="{url link=$aSubMenu.url)}"{if $phpfox.iteration.submenu == 1} class="first"{/if}>{phrase var=$aSubMenu.module'.'$aSubMenu.var_name}</a></li>
							{/foreach}
							</ul>						
						</div>
						{/if}						
						{block location='1'}					
					</div>
					{/if}			

					<div id="content" class="js_content_parent {if !$bUseFullSite && (count($aBlocks1) || count($aBlocks3) || (isset($aSubMenus) && count($aSubMenus)))}split{else}full{/if}">
						{breadcrumb}
						{error}
						{block location='2'}
						{content}
						{block location='4'}
					</div>
											
					<div class="clear"></div>
					{block location='8'}						
				</div>								
				{block location='5'}							
			</div>					
		</div>		
		<div id="bottom" class="body_width_holder">
			<div class="bottom_menu">					
				<ul>
					{if Phpfox::isModule('rss')}<li class="rss_link"><a href="{url link='rss'}"></a></li>{/if}
					{foreach from=$aFooterMenu key=iKey item=aMenu name=footer}
					<li>{if $phpfox.iteration.footer != 1}<span>|</span>{/if}<a href="{url link=""$aMenu.url""}">{phrase var=$aMenu.module'.'$aMenu.var_name}</a></li>
					{/foreach}
					{unset var=$aFooterMenu var2=$aMenu}	
					<li><a href="#" id="select_lang_pack"><span>|</span>{if Phpfox::getParam('language.display_language_flag') && !empty($sLocaleFlagId)}<img src="{$sLocaleFlagId}" alt="{$sLocaleName}" class="v_middle" /> {/if}{$sLocaleName} {img theme='layout/selector_arrow.gif' alt=''}</a></li>							
				</ul>
			</div>			
			<div class="copyright">		
					{branding}						
			</div>				
			<div class="clear"></div>
		</div>					
		{footer}		
		<script type="text/javascript">
			Phpfox.init();
		</script>
		{plugin call='theme_template_body__end'}
	</body>
</html>