<?php 
/**
 * [PHPFOX_HEADER]
 * 
 * @copyright		[PHPFOX_COPYRIGHT]
 * @author			Raymond Benc
 * @package 		Phpfox
 * @version 		$Id: template.html.php 1458 2010-01-29 19:28:49Z Raymond_Benc $
 */
 
defined('PHPFOX') or exit('NO DICE!'); 

?><!DOCTYPE html PUBLIC "-//WAPFORUM//DTD XHTML Mobile 1.2//EN"
"http://www.openmobilealliance.org/tech/DTD/xhtml-mobile12.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" dir="{$sLocaleDirection}" lang="{$sLocaleCode}">
	<head>
		<title>{title}</title>	
		{header}
	</head>
	<body>
		<div id="header">
			<a href="{url link=''}">{param var='core.site_title'}</a>
		</div>
		{if Phpfox::isUser()}
		<div id="menu">
			<ul>
				<li><a href="{url link=''}"{if isset($bMobileHomeIsActive)} class="active"{/if}>{phrase var='mobile.home'}</a></li>
				<li><a href="{url link='profile'}"{if isset($bMobileProfileIsActive)} class="active"{/if}>{phrase var='mobile.profile'}</a></li>
				{if Phpfox::isModule('friend')}
				<li><a href="{url link='friend'}"{if isset($bMobileFriendIsActive)} class="active"{/if}>{phrase var='mobile.friends'}</a></li>
				{/if}
				{if Phpfox::isModule('mail')}
				<li><a href="{url link='mail'}"{if isset($bMobileInboxIsActive)} class="active"{/if}>{phrase var='mobile.mail'}</a></li>
				{/if}
			</ul>
			<div class="clear"></div>
		</div>
		{/if}	
		<div id="holder">
			{if defined('PHPFOX_IS_USER_PROFILE')}
			{if !empty($sProfileImage)}
			<div class="profile_image">
				{$sProfileImage}
			</div>
			<div class="profile_status">
			{/if}
			<div class="profile_full_name">{$aUser.full_name|clean}</div>
			<div class="profile_status">{$aUser.status|clean|split:50|shorten:300}</div>
			<div class="clear"></div>
			{if !empty($sProfileImage)}
			</div>
			{/if}	
			{/if}
			{if isset($aMobileSubMenus)}
			<div id="sub_menu">
				<ul>
				{foreach from=$aMobileSubMenus key=sLink item=sPhrase}
					<li><a href="{$sLink}"{if $sActiveMobileSubMenu == $sLink} class="active"{/if}>{$sPhrase}</a></li>
				{/foreach}
				</ul>		
				<div class="clear"></div>
			</div>
			{/if}
			<div id="content">
			{if $sPublicMessage}
			<div class="public_message" id="public_message" style="display:block;">
				{$sPublicMessage}
			</div>			
			{/if}			
			{if count($aErrors)}
			{foreach from=$aErrors item=sErrorMessage}
			<div class="error_message">{$sErrorMessage}</div>
			{/foreach}			
			{/if}
			{content}
			</div>
		</div>
		<div id="bottom">
			{branding}
		</div>
		<div id="bottom_menu">
			<ul>
				<li><a href="{url link='go-to-full-site'}" class="first">{phrase var='mobile.full_site'}</a></li>
				{if Phpfox::isUser()}
				<li><a href="{url link='logout'}">{phrase var='mobile.logout'}</a></li>
				{/if}
			</ul>
		</div>
	</body>
</html>
